/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
#include "aconst.h"

char data0[32768] ;    /* teiHeader area */
int  dct0 ;
char data1[32768] ;    /* text area */
int  dct1 ;
char data2[32768] ;    /* index area */
int  dct2 ;
char textno[32] ;      /* text_no area */


char *featurept( char *feat, char *data ) ;
char *fvaluept( char *data ) ;

/**************************************************************
 ѥٱΥǡμѴ롣
**************************************************************/
void
main(int argc,  char **argv)
{
  char *cp ;
  int   flag;
  int   ret ;
  int   len ;
  char  work[4096] ;

    flag = 0 ;
    dct0 = dct1 = dct2 = 0 ;
    while( ret != EOF ) {
      ret = get_tag( work, &len )  ;
      if ( len == 0)
        continue ;
      if ( flag == 0 ) 
        flag = CheckTag( work,len) ;

      if ( flag == 1 ) 
        flag = setdata0(work,len) ;
      else if ( flag == 2 )
        flag = setdata1(work,len) ;
      else if ( flag == 3 ) {
        flag = setdata2(work,len) ;
        if ( flag == 1 ) {
          outputtext() ;
          dct0 = dct1 = dct2 = 0 ;
        }
      }
    }
}



/* Check CorpusData(teiHeader) */
int CheckTag( char *in, int len)
{
  char *cp ;

    if ( strncmp( in, "<teiHeader", 10) == 0 ) {
      cp = featurept("id", in+10 ) ;
      cp = fvaluept( cp ) ;
      if ( CopyTeiVal(textno, cp) == 0 )
        return 0;
      return 1 ;
    }
    return 0 ;
}



/* Set teiHeader */
int setdata0( char *in, int len)
{
  int flag = 1 ;
  char *cp ;

    strcpy( &data0[dct0], in ) ;
    dct0 += len ;
    if ( strncmp( in, "<teiHeader", 10) == 0 ) {
      cp = featurept("id", in+10 ) ;
      cp = fvaluept( cp ) ;
      CopyTeiVal(textno, cp) ;
      return flag ;
    }
    if ( strncmp( in, "</teiHeader", 11 ) == 0 ) {
      flag++ ;
      data0[dct0] = '\0' ;
    }
    return flag ;
}


/* Set text */
int setdata1( char *in, int len)
{
  int    flag = 2 ;
  char  *cp ;

    strcpy( &data1[dct1], in ) ;
    dct1 += len ;
    if ( strncmp( in, "</text", 6 ) == 0 ) {
      flag++ ;
      data1[dct1] = '\0' ;
    }
    return flag ;
}


/* Set INDEX FIELD */
int setdata2( char *in, int len)
{
  int flag = 3 ;

    strcpy( &data2[dct2], in ) ;
    dct2 += len ;
    if ( strncmp( in, "</keywords", 10 ) == 0 ) {
      flag = 1 ;
      data2[dct2] = '\0' ;
    }
    return flag ;
}




int outputtext()
{
  printf("%%%%%%쥳ֹ%%%%%%\n") ;
    printf(" %s\n", textno) ;
  
  printf("%%%%%%teiHeader%%%%%%\n") ;
    print_tag(stdout, data0 ) ;

  printf("%%%%%%teiText%%%%%%\n") ;
    print_tag(stdout, data1 ) ;

  printf("%%%%%%keywords%%%%%%\n") ;
    print_tag(stdout, data2 ) ;

  return 1 ;
}


int get_tag( unsigned char *out, int *size ) 
{
  unsigned char *cp = out ;
  int   ch ;

  *size = 0 ;
  while( 1 ) {
    ch = getchar() ;
    if ( ch == EOF )
      return EOF ;
    if ( ch > ' ' )
      break ;
  }
  *cp = ch ; cp++ ;
  while( 1 ) {
    ch = getchar() ;
    if ( ch == EOF )
      break ;
    *cp = ch ; cp++ ;
    if ( ch == '>' ) 
      break ;
  }
  *cp = '\0' ;
  *size = cp - out ;
  return ( ch ) ;
}

   
