#include <stdio.h>
#include <fcntl.h>

#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/


void WordPr(int word, int offset, MorphInfo **wdinfo, char *text, int textlen, MorphInfo **mordata) ;
void  PrnEdrCPCDATA(char dict, int lev, int pcid, char **leaf, char **hdwd, int *workp, int *workc, int wct ) ;
void PrnConceptNode(FILE *fp, char dict, char *node) ;
void MinWordPr(int word, int offset, MorphInfo **wdinfo, char *text, int textlen, MorphInfo **mordata,unsigned char *MIN_NODE) ;
void SetWdList1(int word, MorphInfo **wdinfo, char *text, int textlen, unsigned char *MIN_NODE) ;
void PrintErrorInfo(char *text, int textlen, MorphInfo **mordata) ;
int GetSubClassrec(char dict, int flag, char *cid, int *workp, int *workc, int *workr, int *wct, int lim) ;
int GetParent_CPCDB(char dict, int flag, char *cid, int *workp, int *workc, int *workr, int wct, int lmt ) ;
int PrEDRJWDsub(FILE *outfp, char dict, char *kbuff, unsigned char **cary) ;
void PrRid2VEDRJWD(FILE *outfp, char dict, char *kbuff,int ksz, char *rbuff, int rsz)  ;
int PrVEDRJWDsub(FILE *outfp, char dict, char *kbuff, unsigned char **cary) ;
int GetEDRJWDsub( char *buff, char dict, char *kbuff, unsigned char **cary) ;




/*** 쥳ɥեƽϴؿ : 쥳ɣɣġ쥳 */
int PrRid2Dic(FILE *outfp, char *kbuff,int ksz, char *rbuff, int rsz)
{
  int i , j , kk;
  int ret ;
  char *cary[64] ;

  ret = StartPts( rbuff, rsz, cary) ;
  //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
  //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
  //*
  //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
  //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |


  i = *(int *)kbuff ;
  fprintf( outfp, "+++++++++++++++++ Key=[%d] \n",i) ;
  i = *(int *)rbuff ;
  fprintf( outfp, "     Rec-ID = [JWD%07d]\n", i ) ;
  fprintf( outfp, "     L_CON  = [%s]\n", J_lcon[rbuff[4]].type1 ) ;
  fprintf( outfp, "     R_CON  = [%s]\n", J_rcon[rbuff[5]].type1 ) ;
  fprintf( outfp, "     JPoS   = [%s]\n", J_POS[rbuff[6]].type1 ) ;
  i = get4byte( &rbuff[7] ) ;
  fprintf( outfp, "     Gid    = [%d]\n", i ) ;
  fprintf( outfp, "     Cid    = [%s]\n", cary[5] ) ;
  fprintf( outfp, "     Conns  = [%s]\n", cary[6] ) ;
  fprintf( outfp, "     reading= [%s]\n", cary[7] ) ;
  fprintf( outfp, "     pron.  = [%s]\n", cary[8] ) ;
  fprintf( outfp, "     freq   = [%s]\n", cary[9] ) ;
  fprintf( outfp, "     etc    = [%s]\n", cary[10] ) ;


  fprintf( outfp, "\n" ) ;
  return j  ;
}


/*** 쥳ɥեƽϴؿ : 쥳ɣɣġǲϾ */
int PrRid2Mor(FILE *outfp, char *kbuff,int ksz, char *rbuff, int rsz)
{
  int i , j , kk;
  int ret ;
  char *cary[64] ;
  char lcon[128],rcon[128], *cp ;

  ret = StartPts( rbuff, rsz, cary) ;
  //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
  //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
  //*
  //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
  //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

  i = *(int *)rbuff ;
  j = get4byte( cary[4] ) ;
  cp = skip_ptr( '\t', J_lcon[rbuff[4]].type2 ) ;
  if ( cp == NULL ) 
    strcpy(lcon, J_lcon[rbuff[4]].type1) ;
  else
    ret = copy_word( lcon, 128, J_lcon[rbuff[4]].type2, cp) ;
  cp = skip_ptr( '\t', J_rcon[rbuff[5]].type2 ) ;
  if ( cp == NULL ) 
    strcpy(rcon, J_rcon[rbuff[5]].type1) ;
  else
    ret = copy_word( rcon, 128, J_rcon[rbuff[5]].type2, cp) ;
/*
  fprintf( outfp, "%s\tRid[%07d]\t%d=%d(%s=%s)\t%d(%s)\tGram[%d]\tCid[%s]\n",cary[6]
           ,i,rbuff[4],rbuff[5],J_lcon[rbuff[4]].type1,J_rcon[rbuff[5]].type1
           ,rbuff[6],J_POS[rbuff[6]].type1,j,cary[5] ) ;
*/

  fprintf( outfp, "%s\tRid[%07d]\t%s\t%s\t(%s=%s)\n",cary[6]
           ,i,J_POS[rbuff[6]].type1,cary[5],lcon,rcon ) ;
  return 1  ;
}


 
/*** ţģҥ쥳ɷϴؿ */

int PrRid2EDRJWD(FILE *outfp, char dict, char *kbuff,int ksz, char *rbuff, int rsz) 
{
  int ret ;
  unsigned char *cary[64] ;


  //fprintf( stderr, "Start PrRid2EDRJWD!\n") ;
  ret = StartPts( rbuff, rsz, cary) ;
  //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
  //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
  //*
  //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
  //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

  //printf("START PrRid2EDRJWD[%s]\n",cary[6]) ;
  //debug2( rbuff, rsz ) ;


  ret = PrEDRJWDsub(outfp, dict, kbuff, cary) ;
  return ret ;
}



int PrEDRJWDsub(FILE *outfp, char dict, char *kbuff, unsigned char **cary)
{
  char buff[8192] ;
  int ret ;

  ret = GetEDRJWDsub( buff, dict, kbuff, cary ) ;
  fprintf( outfp, "%s\n", buff ) ;
  return ret ;
}

int GetEDRJWDsub( char *buff, char dict, char *kbuff, unsigned char **cary)
{
  int i, ct, len ;
  int ret, Gid ;
  char work[1024] ;
  char work1[8192] ;
  char work0[4096] ;
  char *cpt[512], *conc[10] ;

  i = *(int *)kbuff ;                      /* 쥳ֹ */

  if ( dict == 'B' ) 
    sprintf( buff,"JWD%07d",i) ;
  else 
    sprintf( buff,"TJWD%07d",i) ;
  ct = strlen(buff) ;

  buff[ct] = '\t' ;
  ct++ ;

  if ( skip_ptr( '/', cary[6]) != NULL) {  /* ñ츫Ф */
    len = GetIdiomSpl_J(cary[6], *cary[3], work, 1024) ;
    len = EDR_StrCapsule( &buff[ct], work, 8192-ct ) ;
    ct += len ;
    buff[ct++] = '[' ;
    len = GetIdiomYomi_J(cary[6], cary[7], *cary[3], work, 1024) ;
    len = EDR_StrCapsule( &buff[ct], work, 8192-ct ) ;    
    ct += len ;
    buff[ct++] = ']' ;
  }
  else {
    len = GetWordSpl_J(cary[6],*cary[3],*cary[2], work, 1024) ;
    len = EDR_StrCapsule( &buff[ct], work, 8192-ct ) ;    
    ct += len ;
    buff[ct++] = '[' ;
    len = GetYomiGobi(cary[6],*cary[3], cary[7], work, 1024) ;
    len = EDR_StrCapsule( &buff[ct], work, 8192-ct ) ;    
    ct += len ;
    buff[ct++] = ']' ;
  }

  buff[ct++] = '\t' ;                      /* ѲϢ */
  len =  copy_word( &buff[ct], 8192 - ct, cary[6], NULL ) ;
  ct += len ;
  buff[ct++] = '\t' ;                      /* ɤ */
  len =  copy_word( &buff[ct], 8192 - ct, cary[7], NULL ) ;
  ct += len ;
  buff[ct++] = '\t' ;                      /* ȯ */
  len =  copy_word( &buff[ct], 8192 - ct, cary[8], NULL ) ;
  ct += len ;
  buff[ct++] = '\t' ;                      /* ʻ */
  len =  copy_word( &buff[ct], 8192 - ct, J_POS[*cary[3]].type1, NULL ) ;
  ct += len ;
  buff[ct++] = '\t' ;

                                           /* ʸˡ󥲥å */
  Gid = get4byte( cary[4] ) ;
  if ( GramId2Val != NULL && Gid >= 0 ) 
    Get_IXT(GramId2Val, cary[4], 4, work, 1024) ;
  else
    work[0] = '\0' ;
  //printf("GRAM=%d [%s]\n",Gid,work) ;
  len = EDR_CreJGram(work, cary[6], work1, 8192 )  ;

  
  split1( '\t', work1, cpt) ;              /* ʸ */
  len =  copy_word( &buff[ct], 8192 - ct, cpt[0], NULL ) ;
  ct += len ;
  buff[ct++] = '\t' ;                      /* Ѿ */
  len =  copy_word( &buff[ct], 8192 - ct, cpt[1], NULL ) ;
  ct += len ;
  buff[ct++] = '\t' ;                      /* ɽسʾ */
  len =  copy_word( &buff[ct], 8192 - ct, cpt[2], NULL ) ;
  ct += len ;
  buff[ct++] = '\t' ;                      /*  */
  len =  copy_word( &buff[ct], 8192 - ct, cpt[3], NULL ) ;
  ct += len ;
  buff[ct++] = '\t' ;                      /* ǽ */
  len =  copy_word( &buff[ct], 8192 - ct, cpt[4], NULL ) ;
  ct += len ;
  buff[ct++] = '\t' ;                      /* ǰ̻ */
  len =  copy_word( &buff[ct], 8192 - ct, cary[5], NULL ) ;
  ct += len ;
  buff[ct++] = '\t' ;
  len = 0 ;

  if ( dict == 'B' ) {
    if ( CHID2CPRecID != NULL && CPHRecId2Val != NULL) {
      len = Get_IXT(CHID2CPRecID, cary[5], strlen(cary[5]), work, 1024) ;
      if ( len != 0 )
        len = Get_IXT(CPHRecId2Val, work, 4, work0, 4096) ;
    }
  }
  else {
    if ( TCHID2CPRecID != NULL && TCPHRecId2Val != NULL) {
      len = Get_IXT(TCHID2CPRecID, cary[5], strlen(cary[5]), work, 1024) ;
      if ( len != 0 )
        len = Get_IXT(TCPHRecId2Val, work, 4, work0, 4096) ;
    }
  }

  if ( len != 0 ) {
    StartPtsCPH(work0, len, conc)  ;
    len =  copy_word( &buff[ct], 8192 - ct, conc[2], NULL ) ;
    ct += len ;
    buff[ct++] = '\t' ;
    len =  copy_word( &buff[ct], 8192 - ct, conc[3], NULL ) ;
    ct += len ;
    buff[ct++] = '\t' ;
    len =  copy_word( &buff[ct], 8192 - ct, conc[4], NULL ) ;
    ct += len ;
    buff[ct++] = '\t' ;
    len =  copy_word( &buff[ct], 8192 - ct, conc[5], NULL ) ;
    ct += len ;
  }
  else {                                   /* ߡ̣ */
    len =  copy_word( &buff[ct], 8192 - ct, "\"\"", NULL ) ;
    ct += len ;
    buff[ct++] = '\t' ;
    len =  copy_word( &buff[ct], 8192 - ct, "\"\"", NULL ) ;
    ct += len ;
    buff[ct++] = '\t' ;
    len =  copy_word( &buff[ct], 8192 - ct, "\"\"", NULL ) ;
    ct += len ;
    buff[ct++] = '\t' ;
    len =  copy_word( &buff[ct], 8192 - ct, "\"\"", NULL ) ;
    ct += len ;
  }
  buff[ct++] = '\t' ;                      /* ˡ */

  len =  copy_word( &buff[ct], 8192 - ct, cpt[5], NULL ) ;
  ct += len ;
  buff[ct++] = '\t' ;                      /* پ */
  len =  copy_word( &buff[ct], 8192 - ct, cary[9], NULL ) ;
  ct += len ;
  buff[ct++] = '\t' ;                      /*  */
  len =  copy_word( &buff[ct], 8192 - ct, cary[10], NULL ) ;
  ct += len ;
  buff[ct] = '\0' ;
  return ct  ;
}





void PrRid2FVEDRJWD(FILE *outfp, char dict, char *kbuff,int ksz, char *rbuff, int rsz) 
{
  int i, ct, len ;
  int ret, Gid ;
  unsigned char *cary[64] ;
  char buff[8192] ;
  char work[1024] ;
  char work1[8192] ;
  char work0[4096] ;
  char *cpt[512], *conc[10] ;

  //fprintf( stderr, "Start PrRid2FVEDRJWD!\n") ;
  ret = StartPts( rbuff, rsz, cary) ;
  //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
  //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
  //*
  //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
  //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

  //printf("START PrRid2EDRJWD[%s]\n",cary[6]) ;
  i = *(int *)kbuff ;                      /* 쥳ֹ */
  if ( dict == 'B' )
    sprintf( buff,"JWD%07d",i) ;
  else
    sprintf( buff,"TJWD%07d",i) ;
  fprintf( outfp, "<쥳ֹ>                  %s\n", buff ) ;

  fprintf( outfp, "<Ф>\n") ;
  if ( skip_ptr( '/', cary[6]) != NULL) {  /* ñ츫Ф */
    len = GetIdiomSpl_J(cary[6], *cary[3], work, 1024) ;
    len = EDR_StrCapsule( &buff[0], work, 8192 ) ;
    ct = len ;
    buff[ct++] = '[' ;
    len = GetIdiomYomi_J(cary[6], cary[7], *cary[3], work, 1024) ;
    len = EDR_StrCapsule( &buff[ct], work, 8192-ct ) ;    
    ct += len ;
    buff[ct++] = ']' ;
  }
  else {
    len = GetWordSpl_J(cary[6],*cary[3],*cary[2], work, 1024) ;
    len = EDR_StrCapsule( &buff[0], work, 8192 ) ;    
    ct = len ;
    buff[ct++] = '[' ;
    len = GetYomiGobi(cary[6],*cary[3], cary[7], work, 1024) ;
    len = EDR_StrCapsule( &buff[ct], work, 8192-ct ) ;    
    ct += len ;
    buff[ct++] = ']' ;
  }
  buff[ct] = '\0' ;
  fprintf( outfp, "  <ñ츫Ф>                  %s\n", buff ) ;

  
  copy_word( &buff[0], 8192, cary[6], NULL ) ; /* ѲϢ */
  fprintf( outfp, "  <Ѳ-Ϣ°>         %s\n", buff ) ;

  copy_word( &buff[0], 8192, cary[7], NULL ) ; /* ɤ */
  fprintf( outfp, "  <ɽ>                    %s\n", buff ) ;


  copy_word( &buff[0], 8192, cary[8], NULL ) ; /* ȯ */
  fprintf( outfp, "  <ȯ>                        %s\n", buff ) ;


  fprintf( outfp, "<ʸˡ>\n" ) ;
  copy_word( &buff[0], 8192 , J_POS[*cary[3]].type1, NULL ) ;  /* ʻ */
  fprintf( outfp, "  <ʻ>                        %s\n", buff ) ;

                                           /* ʸˡ󥲥å */
  Gid = get4byte( cary[4] ) ;
  if ( GramId2Val != NULL && Gid >= 0 ) 
    Get_IXT(GramId2Val, cary[4], 4, work, 1024) ;
  else
    work[0] = '\0' ;
  len = EDR_CreJGram(work, cary[6], work1, 8192 )  ;
  
  split1( '\t', work1, cpt) ;              /* ʸ */
  copy_word( &buff[0], 8192, cpt[0], NULL ) ;
  fprintf( outfp, "  <ʸ>                      %s\n", buff ) ;
  copy_word( &buff[0], 8192, cpt[1], NULL ) ;   /* Ѿ */
  fprintf( outfp, "  <Ѿ>                    %s\n", buff ) ;
  copy_word( &buff[0], 8192, cpt[2], NULL ) ;   /* ɽسʾ */
  fprintf( outfp, "  <ɽسʾ>                  %s\n", buff ) ;
  copy_word( &buff[0], 8192, cpt[3], NULL ) ;   /*  */
  fprintf( outfp, "  <>                      %s\n", buff ) ;
  copy_word( &buff[0], 8192, cpt[4], NULL ) ;   /* ǽ */
  fprintf( outfp, "  <ǽ>                  %s\n", buff ) ;

  fprintf( outfp, "<̣>\n" ) ;
  copy_word( &buff[0], 8192, cary[5], NULL ) ;  /* ǰ̻ */
  fprintf( outfp, "  <ǰ̻>                  %s\n", buff ) ;
  len = 0 ;
  if ( dict == 'B' ) {
    if ( CHID2CPRecID != NULL && CPHRecId2Val != NULL) {
      len = Get_IXT(CHID2CPRecID, cary[5], strlen(cary[5]), work, 1024) ;
      if ( len != 0 )
        len = Get_IXT(CPHRecId2Val, work, 4, work0, 4096) ;
    }
  }
  else {
    if ( TCHID2CPRecID != NULL && TCPHRecId2Val != NULL) {
      len = Get_IXT(TCHID2CPRecID, cary[5], strlen(cary[5]), work, 1024) ;
      if ( len != 0 )
        len = Get_IXT(TCPHRecId2Val, work, 4, work0, 4096) ;
    }
  }
  if ( len != 0 ) {
    fprintf( outfp, "  <ǰФ>\n" ) ;
    StartPtsCPH(work0, len, conc)  ;
    copy_word( &buff[0], 8192, conc[2], NULL ) ;
    fprintf( outfp, "    <Ѹ쳵ǰФ>            %s\n", buff ) ;
    copy_word( &buff[0], 8192, conc[3], NULL ) ;
    fprintf( outfp, "    <ܸ쳵ǰФ>          %s\n", buff ) ;
    fprintf( outfp, "  <ǰ>\n" ) ;
    copy_word( &buff[0], 8192, conc[4], NULL ) ;
    fprintf( outfp, "    <Ѹ쳵ǰ>              %s\n", buff ) ;
    copy_word( &buff[0], 8192, conc[5], NULL ) ;
    fprintf( outfp, "    <ܸ쳵ǰ>            %s\n", buff ) ;
  }
  fprintf( outfp, "  <ѡ¾>\n" ) ;
  copy_word( &buff[0], 8192, cpt[5], NULL ) ;  /* ˡ */
  fprintf( outfp, "  <ˡ>                        %s\n", buff ) ;
  copy_word( &buff[0], 8192, cary[9], NULL ) ;  /* پ */
  fprintf( outfp, "  <>                        %s\n", buff ) ;
  fprintf( outfp, "<>\n" ) ;
  copy_word( &buff[0], 8192, cary[10], NULL ) ;  /*  */
  fprintf( outfp, "  <>                    %s\n", buff ) ;

}






void PrRid2VEDRJWD(FILE *outfp, char dict, char *kbuff,int ksz, char *rbuff, int rsz) 
{
  int ret ;
  unsigned char *cary[64] ;

  //fprintf( stderr, "Start PrRid2FVEDRJWD!\n") ;
  ret = StartPts( rbuff, rsz, cary) ;
  //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
  //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
  //*
  //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
  //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

  //printf("START PrRid2EDRJWD[%s]\n",cary[6]) ;
  
  ret = PrVEDRJWDsub( outfp, dict, kbuff, cary) ;
  return  ;
}



int PrVEDRJWDsub(FILE *outfp, char dict, char *kbuff, unsigned char **cary)
{
  int i, ct, len ;
  int ret, Gid ;
  char buff[8192] ;
  char work[1024] ;
  char work1[8192] ;
  char work0[4096] ;
  char *cpt[512], *conc[10] ;

  i = *(int *)kbuff ;                      /* 쥳ֹ */
  if ( dict == 'B' )
    sprintf( buff,"JWD%07d",i) ;
  else
    sprintf( buff,"TJWD%07d",i) ;
  ct = strlen(buff) ;
  buff[ct] = '\t' ;
  ct++ ;
  if ( skip_ptr( '/', cary[6]) != NULL) {  /* ñ츫Ф */
    len = GetIdiomSpl_J(cary[6], *cary[3], work, 1024) ;
    len = EDR_StrCapsule( &buff[ct], work, 8192 ) ;
    ct += len ;
    buff[ct++] = '[' ;
    len = GetIdiomYomi_J(cary[6], cary[7], *cary[3], work, 1024) ;
    len = EDR_StrCapsule( &buff[ct], work, 8192-ct ) ;    
    ct += len ;
    buff[ct++] = ']' ;
  }
  else {
    len = GetWordSpl_J(cary[6],*cary[3],*cary[2], work, 1024) ;
    len = EDR_StrCapsule( &buff[ct], work, 8192 ) ;    
    ct += len ;
    buff[ct++] = '[' ;
    len = GetYomiGobi(cary[6],*cary[3], cary[7], work, 1024) ;
    len = EDR_StrCapsule( &buff[ct], work, 8192-ct ) ;    
    ct += len ;
    buff[ct++] = ']' ;
  }
  buff[ct++] = '\t' ;
  copy_word( &buff[ct], 8192, cary[6], NULL ) ; /* ѲϢ */

  fprintf( outfp, "  %s\n", buff ) ;

  buff[0] = '\t' ;
  len = copy_word( &buff[1], 8192, cary[7], NULL ) ; /* ɤ */
  ct = len+1 ;
  buff[ct++] = '\t' ;
  len = copy_word( &buff[ct], 8192, cary[8], NULL ) ; /* ȯ */
  ct += len ;
  buff[ct++] = '\t' ;
  copy_word( &buff[ct], 8192 , J_POS[*cary[3]].type1, NULL ) ;  /* ʻ */
  fprintf( outfp, "%s\n", buff ) ;

                                           /* ʸˡ󥲥å */
  Gid = get4byte( cary[4] ) ;
  if ( GramId2Val != NULL && Gid >= 0 )  {
    Get_IXT(GramId2Val, cary[4], 4, work, 1024) ;
    fprintf( outfp, "\t%s\n", work ) ;
  }

  copy_word( &buff[0], 8192, cary[5], NULL ) ;  /* ǰ̻ */
  fprintf( outfp, "\t%s\n", buff ) ;
  len = 0 ;
  if ( dict == 'B' ) {
    if ( CHID2CPRecID != NULL && CPHRecId2Val != NULL) {
      len = Get_IXT(CHID2CPRecID, cary[5], strlen(cary[5]), work, 1024) ;
      if ( len != 0 )
        len = Get_IXT(CPHRecId2Val, work, 4, work0, 4096) ;
    }
  }
  else {
    if ( TCHID2CPRecID != NULL && TCPHRecId2Val != NULL) {
      len = Get_IXT(TCHID2CPRecID, cary[5], strlen(cary[5]), work, 1024) ;
      if ( len != 0 )
        len = Get_IXT(TCPHRecId2Val, work, 4, work0, 4096) ;
    }
  }
  if ( len != 0 ) {
    StartPtsCPH(work0, len, conc)  ;
    copy_word( &buff[0], 8192, conc[2], NULL ) ;
    fprintf( outfp, "\t{%s}", buff ) ;
    copy_word( &buff[0], 8192, conc[4], NULL ) ;
    fprintf( outfp, "\t[%s]\n", buff ) ;
    copy_word( &buff[0], 8192, conc[3], NULL ) ;
    fprintf( outfp, "\t{%s}", buff ) ;
    copy_word( &buff[0], 8192, conc[5], NULL ) ;
    fprintf( outfp, "\t[%s]\n", buff ) ;
  }
  copy_word( &buff[0], 8192, cary[10], NULL ) ;  /*  */
  fprintf( outfp, "\t%s\n", buff ) ;

}






/**********************************************************
*   ɽ伭쥳
*   USAGE:		PrnRecFromHdwd(CFile  *ix, CFile  *dt, char *key)
*   SYNOPSIS:		CFile  *ix  ǥåե뼱̻
*                       CFile  *dt  ǡե뼱̻
*                       char   *key ʸ
*
*   DESCRIPTION:	
*	ꤵ줿˰פΥ쥳ɤɽ롣
*       㤨Сܸɽס䳺쥳ɤɽ
*       ɽϣţģҼ
*
*   RETURN:		쥳ɿ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int PrnRecFromHdwd(CFile  *ix, CFile  *dt, char *key)
{
   char buf[1024] , data[8192] ;
   int  len, i ,j ;
   int  Rid, ret ;

   if ( ix == NULL )
     return 0 ;
   //printf("(PrnRecFromHdwd)[%s](%d)\n",key,strlen(key)) ;
   len = Get_IXT(ix, key, strlen(key), buf, 1024) ;
   for( i = j = 0 ; i < len  ; i += 4 ) {
     Rid = *(int *)&buf[i] ;
     ret = Get_IXT(dt, (char *)&Rid, 4, data, 8192) ;
     PrRid2EDRJWD( stdout,'B', (char *)&Rid,4,data,ret) ;
     j++ ;
   }
   return j ;
}


int PrnMorFromHdwd(CFile  *ix, CFile  *dt, char *key)
{
   char buf[1024] , data[8192] ;
   int  len, i ,j ;
   int  Rid, ret ;

   if ( ix == NULL )
     return 0 ;
   //printf("(PrnRecFromHdwd)[%s](%d)\n",key,strlen(key)) ;
   len = Get_IXT(ix, key, strlen(key), buf, 1024) ;
   for( i = j = 0 ; i < len  ; i += 4 ) {
     Rid = *(int *)&buf[i] ;
     ret = Get_IXT(dt, (char *)&Rid, 4, data, 8192) ;
     PrRid2Mor( stdout, (char *)&Rid,4,data,ret) ;
     j++ ;
   }
   return j ;
}




/**********************************************************
*   쥳ֹ伭쥳
*   USAGE:		PrnRecFromRID(FILE *fp, CFile  *dt, int id)
*   SYNOPSIS:		FILE   *fp  Ƥν
*                       CFile  *ix  ǥåե뼱̻
*                       int    id   쥳ɣɣ
*
*   DESCRIPTION:	
*	ꤵ줿˰פΥ쥳ɤɽ롣
*       㤨Сܸɽס䳺쥳ɤɽ
*       ɽϣţģҼ
*
*   RETURN:		쥳ɿ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
void PrnRecFromRID(FILE  *fp, CFile  *dt, int id)
{
   char data[8192] ;
   int  ret ;

   if ( dt == NULL )
     return ;
   ret = Get_IXT(dt, (char *)&id, 4, data, 8192) ;
   if ( ret == 0 )
     return  ;
   PrRid2EDRJWD( fp,'B', (char *)&id,4,data,ret) ;
   return  ;
}
void PrnRecFromRIDT(FILE  *fp, CFile  *dt, int id)
{
   char data[8192] ;
   int  ret ;

   if ( dt == NULL )
     return ;
   ret = Get_IXT(dt, (char *)&id, 4, data, 8192) ;
   if ( ret == 0 )
     return  ;
   PrRid2EDRJWD( fp,'T', (char *)&id,4,data,ret) ;
   return  ;
}



/**********************************************************
*   쥳ֹ伭쥳
*   USAGE:		PrnFVRecFromRID(FILE *fp, CFile  *dt, int id)
*   SYNOPSIS:		FILE   *fp  Ƥν
*         		CFile  *ix  ǥåե뼱̻
*                       int    id   쥳ɣɣ
*
*   DESCRIPTION:	
*	ꤵ줿˰פΥ쥳ɤɽ롣
*       㤨Сܸɽס䳺쥳ɤɽ
*       ɽϡFIELDVALUEη
*
*   RETURN:		쥳ɿ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
void PrnFVRecFromRID(FILE *fp, CFile  *dt, int id)
{
   char data[8192] ;
   int  ret ;

   if ( dt == NULL )
     return ;
   ret = Get_IXT(dt, (char *)&id, 4, data, 8192) ;
   if ( ret == 0 )
     return  ;
   PrRid2FVEDRJWD( fp,'B', (char *)&id,4,data,ret) ;
   return  ;
}
void PrnFVRecFromRIDT(FILE *fp, CFile  *dt, int id)
{
   char data[8192] ;
   int  ret ;

   if ( dt == NULL )
     return ;
   ret = Get_IXT(dt, (char *)&id, 4, data, 8192) ;
   if ( ret == 0 )
     return  ;
   PrRid2FVEDRJWD( fp,'T', (char *)&id,4,data,ret) ;
   return  ;
}



/**********************************************************
*   쥳ֹ伭쥳
*   USAGE:		PrnVRecFromRID(FILE *fp, CFile  *dt, int id)
*   USAGE:		PrnVRecFromRIDT(FILE *fp, CFile  *dt, int id)    Ѹ 
*   SYNOPSIS:		CFile  *ix  ǥåե뼱̻
*                       int    id   쥳ɣɣ
*
*   DESCRIPTION:	
*	ꤵ줿˰פΥ쥳ɤɽ롣
*       㤨Сܸɽס䳺쥳ɤɽ
*       ɽϡVALUEΤߤơ֥ˤΡ
*
*   RETURN:		쥳ɿ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
void PrnVRecFromRID(FILE *fp, CFile  *dt, int id)
{
   char data[8192] ;
   int  ret ;
   if ( dt == NULL )
     return ;
   ret = Get_IXT(dt, (char *)&id, 4, data, 8192) ;
   if ( ret == 0 )
     return  ;
   PrRid2VEDRJWD( fp,'B', (char *)&id,4,data,ret) ;
   return  ;
}



void PrnVRecFromRIDT(FILE *fp, CFile  *dt, int id)
{
   char data[8192] ;
   int  ret ;

   if ( dt == NULL )
     return ;
   ret = Get_IXT(dt, (char *)&id, 4, data, 8192) ;
   if ( ret == 0 )
     return  ;
   PrRid2VEDRJWD( fp,'T', (char *)&id,4,data,ret) ;
   return  ;
}





/**********************************************************
*   쥳ֹǲϾʼ쥳ɡ
*   USAGE:		PrnMorFromRID(char *cp, MorphInfo *mp)
*   SYNOPSIS:		char      *cp  ؤΥݥ
*                       MorphInfo *mp  ǥåǼ
*
*   DESCRIPTION:	
*	ꤵ줿ФǾɽ롣
*       㤨Сܸɽס䳺Ǿɽ
*
*   RETURN:		
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
void PrnMorFromRID( char *cp, MorphInfo *mp)
{
   char data[256] ;
   int  ret ;
   char lcon[128],rcon[128];

  ret = copy_word( data, 256, cp, cp + (mp->leng) ) ;
  cp = skip_ptr( '\t', J_lcon[ mp->lcon].type2 ) ;
  if ( cp == NULL ) 
    strcpy(lcon, J_lcon[ mp->lcon ].type1) ;
  else
    ret = copy_word( lcon, 128, J_lcon[ mp->lcon ].type2, cp) ;
  cp = skip_ptr( '\t', J_rcon[ mp->rcon ].type2 ) ;
  if ( cp == NULL ) 
    strcpy(rcon, J_rcon[ mp->rcon ].type1) ;
  else
    ret = copy_word( rcon, 128, J_rcon[ mp->rcon ].type2, cp) ;

  fprintf( stdout, "%s\tRid[JWD%07d]\t%s\t%s,%s(%s,%s)\n", data
           , mp->rno,J_POS[ mp->lcon].type1,J_lcon[ mp->lcon ].type1,J_rcon[ mp->rcon ].type1,lcon,rcon ) ;
  return  ;
}




/***********************************************************
*   ɽ
*   USAGE:		PrintWordList(int flag, char *text, MorphInfo **mordata)
*   SYNOPSIS:		int         flag (IN) ɽؼ
*                       char       *text (IN) ʸѲΡ
*                       MorInfo    *md   (IN) ǾؤΥݥ
*
*   DESCRIPTION:	
*	ʸñζڤƬˤ˳ƷǾ󤬥󥯤
*     Ƥ롣ηǾϢܾ򸫤ʤ³å
*     ʸ˶ڤ줿Τɽ롣
*       裱 ͤĻǾΡɿΥɥꥹȤΤߤɽ
*                  ͤĻϡɽ롣
*                  ͤĻϡǾΡɿΥɥꥹȤΤߤɽ
*                                    λƬ TAB 򣲤
*
*   RETURN:		
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
void  PrintWordList(int flag, char *work1, MorphInfo **mordata) 
{
  int off ;
  MorphInfo *wdinfo[256] ;
  unsigned char MIN_NODE[32768] ;

  MIN_NODE[0] = 0 ;
  MinWordPr(0,0,wdinfo,work1,strlen(work1),mordata,MIN_NODE) ;
  if ( flag == 3 ) {
    if ( MIN_NODE[0] != 0 )
      printf("\t\t%s\n",&MIN_NODE[1]) ;
    else 
      PrintErrorInfo(work1,strlen(work1),mordata) ;
    return ;
  }
  printf("############### Node Count %d ####################################\n",MIN_NODE[0]) ;
  if ( MIN_NODE[0] != 0 )
    printf("%s\n",&MIN_NODE[1]) ;
  else 
    PrintErrorInfo(work1,strlen(work1),mordata) ;
  if ( flag == 1 )
    return ;
  printf("======================================================\n") ;
  WordPr(0,0,wdinfo,work1,strlen(work1),mordata) ;
  return ;
}


void MinWordPr(int word, int offset, MorphInfo **wdinfo, char *text, int textlen, MorphInfo **mordata,unsigned char *MIN_NODE)
{
  MorphInfo *mp , *wp ;
  int ii, ct, off, leng, pt ;
  int ret, soffset ;
  char work[128] ;
  char lcon[128], rcon[128], *cp ;

  //printf("WordPr: %d off=%d textlen=%d  <word=%d>\n",word,offset,textlen,word) ;
  if ( textlen == offset ) {
    SetWdList1( word, wdinfo, text, textlen, MIN_NODE) ;
    return ;
  }
  soffset = offset ;
  if ( *(mordata+offset) == NULL ) {
    //    return ;
    /***********/
    for( offset += 2 ; textlen > offset ; offset += 2 ) {
      if (*(mordata+offset) != NULL)
        break ;
    }
    if ( textlen <= offset ) {
      SetWdList1( word, wdinfo, text, textlen, MIN_NODE) ;
      return ;
    }
    /****************/
  }
  for( mp = *(mordata+offset) ; mp != NULL ; mp = mp->next ) {
    if ( word != 0 && soffset == offset ) {
      if ( EDR_Rensetsu[ (*(wdinfo+word-1))->rcon ][mp->lcon] == 0 ) {
        //printf("%s,%s FAIL\n",J_rcon[(*(wdinfo+word-1))->rcon].type1,J_lcon[mp->lcon].type1) ;
        continue ;
      }
      //printf("%s,%s SUCCESS\n",J_rcon[(*(wdinfo+word-1))->rcon].type1,J_lcon[mp->lcon].type1) ;
    }
    for( wp = *(mordata+offset) ; wp != mp ; wp = wp->next ) {
      if ( wp->leng == mp->leng && wp->lcon == mp->lcon && wp->rcon == mp->rcon ) 
        break ;
    }
    if ( wp != mp )
      continue ;
    *(wdinfo+word) = mp ;
    MinWordPr(word+1,offset+(mp->leng), wdinfo, text,textlen, mordata, MIN_NODE ) ;

    if (*MIN_NODE != 0)
      return ;

  }
  return ;
}




void SetWdList1(int word, MorphInfo **wdinfo, char *text, int textlen, unsigned char *MIN_NODE)
{
  int ii, ct, off, leng, pt ;
  int ret ;
  char work[128] ;
  char lcon[128], rcon[128], *cp ;

  //printf("word=%d MIN_NODE=%d\n",word,*MIN_NODE) ;
  if ( *MIN_NODE == 0 || word < *MIN_NODE ) {
    *MIN_NODE = word ;
    ct = 1 ;
    pt = 0 ;
    for( ii = 0 ; ii < word ; ii++ ) {
      leng = (*(wdinfo+ii))->leng ;
      off = (*(wdinfo+ii))->off ;
      if ( pt != off ) {
        ret = copy_word( work, 128, text+pt, text+off ) ;
        sprintf( &MIN_NODE[ct],"[%s](-,-) / ",work ) ;
        ct += strlen(&MIN_NODE[ct]) ;
      }
      ret = copy_word( work, 128, text+off, text+off+leng ) ;
      /* Ϣ 
      cp = skip_ptr( '\t', J_lcon[(*(wdinfo+ii))->lcon].type2 ) ;
      if ( cp == NULL ) 
        strcpy(lcon, J_lcon[(*(wdinfo+ii))->lcon].type1) ;
      else
        ret = copy_word( lcon, 128, J_lcon[(*(wdinfo+ii))->lcon].type2, cp) ;
      */
      /* Ϣ 
      cp = skip_ptr( '\t', J_rcon[(*(wdinfo+ii))->rcon].type2 ) ;
      if ( cp == NULL ) 
        strcpy(rcon, J_rcon[(*(wdinfo+ii))->rcon].type1) ;
      else
        ret = copy_word( rcon, 128, J_rcon[(*(wdinfo+ii))->rcon].type2, cp) ;
      */
      sprintf( &MIN_NODE[ct],"%s(%s,%s) / ",work,J_lcon[(*(wdinfo+ii))->lcon].type1,J_rcon[(*(wdinfo+ii))->rcon].type1 ) ;
      ct += strlen(&MIN_NODE[ct]) ;
      pt = off+leng ;
    }
    if ( pt != textlen ) {
      ret = copy_word( work, 128, text+pt, text+textlen ) ;
      sprintf( &MIN_NODE[ct],"[%s] ",work ) ;
    }
  }   
  return ;
}  

void WordPr(int word, int offset, MorphInfo **wdinfo, char *text, int textlen, MorphInfo **mordata)
{
  MorphInfo *mp , *wp ;
  int ii, off, leng ;
  int ret ;
  char work[128] ;
  char lcon[128], rcon[128], *cp ;

  //printf("WordPr: %d off=%d textlen=%d  <word=%d>\n",word,offset,textlen,word) ;
  if ( textlen == offset ) {
    off = 0 ;
    for( ii = 0 ; ii < word ; ii++ ) {
      leng = (*(wdinfo+ii))->leng ;
      ret = copy_word( work, 128, text+off, text+off+leng ) ;
      cp = skip_ptr( '\t', J_lcon[(*(wdinfo+ii))->lcon].type2 ) ;
      if ( cp == NULL ) 
        strcpy(lcon, J_lcon[(*(wdinfo+ii))->lcon].type1) ;
      else
        ret = copy_word( lcon, 128, J_lcon[(*(wdinfo+ii))->lcon].type2, cp) ;
      cp = skip_ptr( '\t', J_rcon[(*(wdinfo+ii))->rcon].type2 ) ;
      if ( cp == NULL ) 
        strcpy(rcon, J_rcon[(*(wdinfo+ii))->rcon].type1) ;
      else
        ret = copy_word( rcon, 128, J_rcon[(*(wdinfo+ii))->rcon].type2, cp) ;
      printf("%s(%s,%s) / ",work,J_lcon[(*(wdinfo+ii))->lcon].type1,J_rcon[(*(wdinfo+ii))->rcon].type1 ) ;
      off += leng ;
    }
    printf("\n") ;
    return ;
  }
  if ( *(mordata+offset) == NULL ) {
    return ;
  }
  for( mp = *(mordata+offset) ; mp != NULL ; mp = mp->next ) {
    if ( word != 0 ) {
      if ( EDR_Rensetsu[ (*(wdinfo+word-1))->rcon ][mp->lcon] == 0 ) {
        //printf("%s,%s FAIL\n",J_rcon[(*(wdinfo+word-1))->rcon].type1,J_lcon[mp->lcon].type1) ;
        continue ;
      }
      //printf("%s,%s SUCCESS\n",J_rcon[(*(wdinfo+word-1))->rcon].type1,J_lcon[mp->lcon].type1) ;
    }
    for( wp = *(mordata+offset) ; wp != mp ; wp = wp->next ) {
      if ( wp->leng == mp->leng && wp->lcon == mp->lcon && wp->rcon == mp->rcon ) 
        break ;
    }
    if ( wp != mp )
      continue ;
    *(wdinfo+word) = mp ;
    WordPr(word+1,offset+(mp->leng), wdinfo, text,textlen, mordata ) ;
  }
  return ;
}



void PrintErrorInfo(char *text, int textlen, MorphInfo **mordata)
{
  MorphInfo *mp , *wp ;
  int ii, jj, flag, off, leng ;
  int ret, err ;
  char work[4096] ;
  char mae[128], ato[128] ;

  printf("\t\tERROR:[%s]\n",text) ;
  printf("\t\tERROR=>") ;

  off = err = 0 ;
  for( ii = 2 ; ii < textlen ; ii += 2) {
    if ( *(mordata+ii) == NULL)
      continue ;
    for( mp = *(mordata+ii) ; mp != NULL ; mp = mp->next ) {
      flag = 0 ;
      for( jj = 0  ; jj < ii  ; jj += 2 ) {
        for( wp = *(mordata+jj) ; wp != NULL ; wp = wp->next ) {
          if ( *(mordata+jj) == NULL)
            continue ;
          if ( ( jj + (wp->leng) ) < ii )
            continue ;
          if ( ( jj + (wp->leng) ) > ii ) {
            flag = 1 ;          /* ֤ޤΤ */
            break ;
          }
          if ( EDR_Rensetsu[ wp->rcon ][mp->lcon] != 0 ) {
            flag = 1 ;          /* ³åϣˤʤ */
            break ;
          }
          /*******
          ret = copy_word( mae, 4096, text+(wp->off), text+(wp->off)+(wp->leng) ) ;
          ret = copy_word( ato, 4096, text+(mp->off), text+(mp->off)+(mp->leng) ) ;
          printf("[%s] : [%s] = %s,%s FAIL\n",mae,ato,J_rcon[wp->rcon].type1,J_lcon[mp->lcon].type1) ;
          **********/
	}
        if ( flag != 0 )
          break ;
      }
      if ( flag != 0 )
        break ;
    }
    if ( flag == 0 ) {          /* ³Ǥʤ */
      ret = copy_word( work, 4096, text+off, text+ii ) ;
      printf("[%s] X ",work ) ;
      off = ii ;
    }
  }
  if ( off != 0 ) {
    ret = copy_word( work, 4096, text+off, text+ii ) ;
    printf("[%s]\n",work ) ;
  }
  else 
    printf("\n") ;
  return ;
}


  




/***********************************************************
*   ǰηϤɽ
*   USAGE:		PrnPathRecFromRID(char **cid, char **hdwd, int cidct)
*   SYNOPSIS:		char      **cid    (IN) ǰɣʸ
*         		char      **hdwd   (IN) ɽʸ
*                       int         cidct  (IN) ǰ
*
*   DESCRIPTION:	
*	ϤΤϡɽΥꥹȤȤ줾ɽ
*     ĳǰɣġʥꥹȡˡ
*       裳ϡꥹȤĹǿˡ
*
*       [ɽ] <-----hdwd[0]    cid[0]------>[ãɣģ]
*       [ɽ] <-----hdwd[1]    cid[1]------>[ãɣģ]
*           :::                              :::
*       [ɽ] <-----hdwd[n]    cid[n]------>[ãɣģ]
*                           cidct = n
*       ΥꥹȤ˳Ǽ줿ǰξ̤éꡢǰηϤΥѥ
*     ɽ롣
*
*   RETURN:		
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
void  PrnPathRecFromRID(char **cid, char **hdwd, int cidct) 
{
  int  workp[8192] ;
  int  workc[8192] ;
  int  workr[8192] ;
  int  ret, wct = 0 ;
  int  workpT[8192] ;
  int  workcT[8192] ;
  int  workrT[8192] ;
  int  wctT = 0 ;
  int  ii , jj,top ;

  if ( cidct == 0 )
    return ;
  for ( ii = 0 ; ii < cidct ; ii++ ) {
    ret = GetSubClassrec( 'B', ii, *(cid+ii), workp, workc, workr, &wct, 8192 ) ;
    if ( ret < 0 ) {
      fprintf(stderr, "ERROR(PrnPathRecFromRID):ηϤΥѥǤʤ\n") ;
      return ;
    }
    ret = GetSubClassrec( 'T', ii, *(cid+ii), workpT, workcT, workrT, &wctT, 8192 ) ;
    if ( ret < 0 ) {
      fprintf(stderr, "ERROR(PrnPathRecFromRID):ηϤΥѥǤʤ\n") ;
      return ;
    }
    /*************************
    printf("GetSubClassrec ret = %x\n", ret ) ;
    printf("GetSubClassrec wct = %d\n", wct ) ;
    for ( jj = 0 ; jj < wct ; jj++ ) {
      printf("P[%x]=>C[%x]\n",workp[jj],workc[jj]) ;
    }
    **************************/
  }
  if ( wct > 0 ) {
    top = HextoBin( "3aa966" ) ; /* EDRγǰηϤΥȥåץΡ */
    PrnEdrCPCDATA( 'B', 0, top, cid, hdwd, workp, workc, wct ) ;
  }
  if ( wctT > 0 ) {
    top = HextoBin( "2f3526" ) ; /* EDRγǰηϤΥȥåץΡ */
    PrnEdrCPCDATA( 'T', 0, top, cid, hdwd, workpT, workcT, wctT ) ;
  }
}




/***********************************************************
*   ǰηϤΰʬ
*   USAGE:		GetSubClassrec(char dict, int flag, char *cid, int *workp, int *workc, int *workr, int *wct, int lim)
*   SYNOPSIS:		char dict         'B'/'T' Ķܸ줫Ѹ줫
*                       int flag          оݳǰΥ󥷥ֹʣγǰ򥭡ˤǤ뤫
*                       char *cid         ǰID
*                       int *workp        ǰημοƳǰ̻ҡintꥨꥢ
*                       int *workc        ǰημλҳǰ̻ҡintꥨꥢ
*                       int *workr        ǰημΥե饰intꥨꥢ
*                       int *wct          ǰηϤμ
*                       int lim           ꥨꥢο
*
*   DESCRIPTION:	
*	Ϥ줿ǰɣĤ򲼰̳ǰȤ복ǰημ
*     ᡢμξ̳ǰɣĤȲ̳ǰIDʰ͡ˤ
*     åȤ
*       δؿꥫ֤˸ƤФ뤳Ȥǡꤷǰξ
*     ¸ߤƤημФ롣
*
*   RETURN:		ｪλ:
*                       ۾郎:
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int GetSubClassrec(char dict, int flag, char *cid, int *workp, int *workc, int *workr, int *wct, int lim)
{
  char cidstr[32], cidwk[32] ;
  int  wk, ii, jj ;
  int  newc, len, ret = 0, lpc ;

  lpc = GetParent_CPCDB( dict, flag, cid, workp, workc, workr, *wct, lim ) ;
  // printf("GetParent_CPCDB [CID=%s] ret = %d\n",cid,lpc) ;
  if ( lpc < 0 ) 
    return lpc ;
  if ( lpc == 0 ) {
    return 0 ;
  }
  wk = *wct ;
  *wct += lpc ;
  for ( ii = 0 ; ii < lpc ; ii++ ) {
    newc = *(workp + wk +ii) ;
    for ( jj = 0 ; jj < *wct ; jj++ ) {
      if ( newc == *(workc+jj) ) 
        break ;  /* ˾̤ϵƤ */
    }
    if ( jj < (*wct) ) /* ˾̤ϵƤ */
      continue ;
    len = BintoHex( 4, (char *)&newc, cidwk) ;
    if ( len > 6 ) {
      fprintf(stderr,"ERROR(GetSubClassrec):CID[%s] ?\n",cidwk) ;
      continue ;
    }
    if ( (ret = GetSubClassrec( dict, -1, cidwk, workp, workc, workr, wct, lim) ) < 0 )
      return ( -1 ) ;
  }
  return ret ;
}



int GetParent_CPCDB(char dict, int flag, char *cid, int *workp, int *workc, int *workr, int wct, int lmt )
{
  char data[4096], *datap ;
  char work[1024] , *cary[32] ;
  int  ii, fd, len, slen, msz ;
  int  ret ;
  int  st = wct ;

  len = 0 ;
  if ( dict == 'B' && CCID2CPRecID != NULL)
    len = Get_DataLeng(CCID2CPRecID, cid, strlen(cid) ) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    len = Get_DataLeng(TCCID2CPRecID, cid, strlen(cid) ) ;
  if ( len == 0 )
    return 0 ;
  if ( len > 4096 ) {
    ret = len / 4096 ;
    msz = ( ret +1 ) * 4096 ;
    if ( (datap = (unsigned char *)malloc( msz ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return -1 ;
    }
  }
  else {
    datap = &data[0] ;
    msz = 4096 ;
  }

  ret = 0 ;                                /* ǰηϥǥå */
  if ( dict == 'B' && CCID2CPRecID != NULL )
    ret = Get_IXT(CCID2CPRecID, cid, strlen(cid), datap, msz) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    ret = Get_IXT(TCCID2CPRecID, cid, strlen(cid), datap, msz) ;

  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x01) == 0 ) 
      continue ;
    if ( wct >= lmt ) {
      fprintf( stderr,"ERROR(GetParent_CPCDB)Work(Parent:Child) is too small!\n") ;
      if ( len > 4096 )
        free( datap ) ;
      return -1 ;
    }
    slen = 0 ;
    if ( dict == 'B' && CPCRecId2Val != NULL )
      slen = Get_IXT(CPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    else if ( dict == 'T' && TCPCRecId2Val != NULL)
      slen = Get_IXT(TCPCRecId2Val, (char *)(datap + ii), 4, work,1024) ;
    if ( slen <= 0 ) {
      fprintf( stderr,"ERROR(GetParent_CPCDB):ģ¤\n") ;
      fprintf( stderr,"   CID[%s] RID[%d]\n",cid,*(int *)(datap + ii)) ;
      if ( len > 4096 )
        free( datap ) ;
      return( -1 );
    }
    fd = StartPtsCPC( work, slen, cary)  ;

    *(workr+wct) = *(datap + ii) ;
    *(workp+wct) = HextoBin( cary[1] ) ;
    if ( flag == -1 )
      *(workc+wct) = HextoBin( cary[2] ) ;
    else 
      *(workc+wct) = (-1) * flag ;
    wct++ ;
  }
  if ( len > 4096 )
    free( datap ) ;
  return ( wct - st ) ;
}


/*
 Ϳ줿ǰɣĤɽθ塢γǰɣĤ̳ǰȤ
 ̳ǰᡢꥫ֤˥뤹롣
*/
void  PrnEdrCPCDATA(char dict, int lev, int pcid, char **leaf, char **hdwd, int *workp, int *workc, int wct ) 
{
  int ii ;
  int flag ;
  char cidstr[32] ;

  printf("%02d:\t",lev) ;
  for ( ii = 0 ; ii < lev ; ii++ ) {
    printf("  ") ;
  } 
  if ( pcid <= 0 )  {
    pcid = (-1) * pcid ;
    PrnConceptNode(stdout, dict, *(leaf+pcid) ); 
    if ( **(hdwd+pcid) == '\0' )
      printf("\n") ;
    else
      printf("    [%s]\n", *(hdwd+pcid) ) ;
    return ;
  }
  sprintf(cidstr,"%06x",pcid) ;
  PrnConceptNode(stdout, dict, cidstr);
  printf("\n") ;
  for ( ii = flag = 0 ; ii < wct ; ii++ ) {
    if ( *(workp+ii) == pcid ) {
      PrnEdrCPCDATA( dict, lev+1, *(workc+ii), leaf, hdwd, workp, workc, wct ) ;
      flag++ ;
    }
  }
  if ( flag == 0 ) {
    PrnEdrCPCDATA( dict, lev+1, 0, leaf, hdwd, workp, workc, wct ) ;
  }
}



void PrnConceptNode(FILE *fp, char dict, char *node)
{
  int  len ;
  char work[128], work0[4096], *conc[32] ;

  fprintf( fp, "%s\t",node) ;
  if ( dict == 'B') {
    if ( CHID2CPRecID != NULL && CPHRecId2Val != NULL) {
      len = Get_IXT(CHID2CPRecID, node, strlen(node), work, 128) ;
      if ( len != 0 )
        len = Get_IXT(CPHRecId2Val, work, 4, work0, 4096) ;
    }
  }
  else {
    if ( TCHID2CPRecID != NULL && TCPHRecId2Val != NULL) {
      len = Get_IXT(TCHID2CPRecID, node, strlen(node), work, 128) ;
      if ( len != 0 )
        len = Get_IXT(TCPHRecId2Val, work, 4, work0, 4096) ;
    }
  }
  if ( len != 0 ) {
    StartPtsCPH(work0, len, conc)  ;
    /********
    if ( strcmp(conc[3],"\"\"") == 0 ) 
      fprintf( fp, "{%s}\t",conc[2] ) ;
    else
      fprintf( fp, "{%s}\t",conc[3] ) ;
    *********************************/
    if ( strcmp(conc[5],"\"\"") == 0 )
      fprintf( fp, "%s",conc[4]) ;
    else
      fprintf( fp, "%s",conc[5]) ;
  }
}



void PrnConceptNodeEJ(FILE *fp, char dict, char *node)
{
  int  len ;
  char work[128], work0[4096], *conc[32] ;

  fprintf( fp, "%s\t",node) ;
  if ( dict == 'B') {
    if ( CHID2CPRecID != NULL && CPHRecId2Val != NULL) {
      len = Get_IXT(CHID2CPRecID, node, strlen(node), work, 128) ;
      if ( len != 0 )
        len = Get_IXT(CPHRecId2Val, work, 4, work0, 4096) ;
    }
  }
  else {
    if ( TCHID2CPRecID != NULL && TCPHRecId2Val != NULL) {
      len = Get_IXT(TCHID2CPRecID, node, strlen(node), work, 128) ;
      if ( len != 0 )
        len = Get_IXT(TCPHRecId2Val, work, 4, work0, 4096) ;
    }
  }
  if ( len != 0 ) {
    StartPtsCPH(work0, len, conc)  ;
    fprintf( fp, "E{%s}\tJ{%s}",conc[4],conc[5]) ;
  }
}





 
/*** ǰηϣţģҥ쥳ɷϴؿ */

int PrRid2EDRCPC(FILE *outfp, char dict, int rid)
{
  int  slen, ret ;
  char work[1024] ;
  char *cary[64] ;

  if ( dict == 'B' && CPCRecId2Val != NULL ) {
    slen = Get_IXT(CPCRecId2Val, (char *)&rid, 4, work,1024) ;
    if ( slen <= 0 ) 
      return( -1 );
    //        | Rec-ID | ̳ǰID\0 | ̳ǰID\0 | \0 |
    //        |  (4)   | (n)          | (n)          | (n)        |
    ret = StartPtsCPC( work, slen, cary)  ;
    fprintf( outfp,"CPC%07d\t%s\t%s\t%s\n",rid,cary[1],cary[2],cary[3]) ;
    return slen ;
  }
  else if ( dict == 'T' && TCPCRecId2Val != NULL) {
    slen = Get_IXT(TCPCRecId2Val, (char *)&rid, 4, work,1024) ;
    if ( slen <= 0 ) 
      return( -1 );
    //        | Rec-ID | ̳ǰID\0 | ̳ǰID\0 | \0 |
    //        |  (4)   | (n)          | (n)          | (n)        |
    ret = StartPtsCPC( work, slen, cary)  ;
    fprintf( outfp,"TCPC%07d\t%s\t%s\t%s\n",rid,cary[1],cary[2],cary[3]) ;
    return slen ;
  }
  return -1 ;
}




/*** ǰңţģҥ쥳ɷϴؿ */

int PrRid2EDRCPT(FILE *outfp, char dict, int rid)
{
  int  slen, tid, ret ;
  char work[1024] ;
  char *cary[64] ;
  char ei, rf ;

  if ( dict == 'B' && CPTRecId2Val != NULL ) {
    slen = Get_IXT(CPTRecId2Val, (char *)&rid, 4, work,1024) ;
    if ( slen <= 0 ) 
      return( -1 );
    //       Ǽ쥳ɷ
    //        | Rec-ID | FLAG | طID | 긵ǰID\0 |
    //        |  (4)   | (1)  | (1)      | (n)            |
    //
    //        | 賵ǰID\0 | \0 |
    //        | (n)            | (n)        |
    //
    //             FLAG:  Ҷʬ    
    //                    FLAG & 0x01 == 0B : Ҷʬ  I
    //                    FLAG & 0x01 == 1B : Ҷʬ  E
    //                    FLAG & 0x02 == 0B :    
    //                    FLAG & 0x02 == 1B :    
    ret = StartPtsCPT( work, slen, cary)  ;
    if ( ( *cary[1] & 0x01 ) == 0 )
      ei = 'I' ;
    else
      ei = 'E' ;
    if ( ( *cary[1] & 0x02 ) == 0 )
      rf = '0' ;
    else
      rf = '1' ;

    tid = *cary[2] ;
    fprintf( outfp,"CPT%07d\t%c\t%s\t%s\t%s\t%c\t%s\n",rid,ei,cary[3],Concept_Rel[tid].type1,cary[4],rf,cary[5]) ;
    return slen ;
  }
  return -1 ;
}








