#include  <stdio.h>
#include  "fconst.h"
#include  "fextern.h"
#include  "ftemp.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/



/****************************************************
*  ܸñˤñ츫Фؿ
*   USAGE:		GetWordSpl_J( char *hdcon, int cat, char *out, int size)
*   SYNOPSIS:		char *hdcon (IN)  ѲϢ
*                       int  cat    (IN)  ʻɣ
*                       char *out   (OUT) ñ츫ФǼ
*                       int  size   (IN)  ñ츫ФǼΥ
*
*   DESCRIPTION:	
*	ñ츫Ф[ɤ]פΡñ츫Фʬؿ
*       ߷δФ롣
*
*   RETURN:	        ñ츫ФΥ
*
*****************************************************/
int   GetWordSpl_J(char *hdcon, unsigned char cat, unsigned char rcon, char *out, int size)
{
  char  gobi[16] ;
  int   ii , ret ;
  char *cp  ;

  //printf("(GetWordSpl) hdcon=[%s] cat(%d)=%s\n", hdcon,cat,J_POS[cat].type1) ;
  if ( cat < 255 ) {
    if (strcmp(J_POS[cat].type1,"JVE") == 0 ||
        strcmp(J_POS[cat].type1,"JAX") == 0 ||
        strcmp(J_POS[cat].type1,"JPR") == 0 ||
        strcmp(J_POS[cat].type1,"JJD") == 0 ||
        strcmp(J_POS[cat].type1,"JJP") ==0 ) {
      for( ii = 0 ; CHGJHDWDTBL[ii].type1 != NULL ; ii++ ) {
        if ( *(unsigned char *)hdcon == *(CHGJHDWDTBL[ii].type1) &&
               strcmp(hdcon,CHGJHDWDTBL[ii].type1) == 0) {
          cp = skip_ptr( '\t', CHGJHDWDTBL[ii].type2 ) ;
          ret = copy_word( out, size , CHGJHDWDTBL[ii].type2, cp ) ;
          return( ret ) ;
        }
      }
    }
  }
  j_katuyou(J_rcon[rcon].type1, gobi) ;
  cp = skip_ptr( '(', hdcon ) ;
  ret = copy_word( out, size , hdcon, cp ) ;
  if ( (ret + strlen(gobi)) >= size) {
    *out = '\0' ;
    return 0 ;
  }
  strcpy( out+ret, gobi) ;
  return ( strlen( out ) ) ;
}  




/****************************************************
*  ܸñˤñ츫Фդָդɤߡפؿ
*   USAGE:		GetYomiGobi( char *hdcon, int cat, char *yomi, char *out, int size)
*   SYNOPSIS:		char *hdcon (IN) ѲϢ
*                       int  cat    (IN)  ʻɣ
*                       char *yomi  (OUT) ʤɤ
*                       char *out   (OUT) դɤ߳Ǽ
*                       int  size   (IN)  դɤ߳ǼΥ
*
*   DESCRIPTION:	
*	ñ츫Ф[ɤ]פΡɤߡפؿ
*       ߷ɤߤ롣
*
*   RETURN:	        ñ츫ФΥ
*
*****************************************************/
int  GetYomiGobi( char *hdcon, int cat, char *yomi, char *out, int size)
{
  int ii , hdlen , ret ;
  unsigned char lcon, rcon ;
  char  gobi[16], gobi2[16] ;
  char  *hptr , *cp ;

  //printf("(GetYomiGobi)hdcon=[%s] yomi=[%s]\n",hdcon,yomi );
  if ( cat < 255 ) {
    if (strcmp(J_POS[cat].type1,"JVE") == 0 ||
        strcmp(J_POS[cat].type1,"JAX") == 0 ||
        strcmp(J_POS[cat].type1,"JPR") == 0 ||
        strcmp(J_POS[cat].type1,"JJD") == 0 ||
        strcmp(J_POS[cat].type1,"JJP") ==0 ) {
      for( ii = 0 ; CHGJHDWDTBL[ii].type1 != NULL ; ii++ ) {
        if ( *(unsigned char *)hdcon == *(CHGJHDWDTBL[ii].type1) &&
               strcmp(hdcon,CHGJHDWDTBL[ii].type1) == 0) {
          cp = skip_ptr( '\t', CHGJHDWDTBL[ii].type2 ) ;
          ret = copy_word( out, size , cp+1, NULL ) ;
          return( ret ) ;
        }
      }
    }
  }
  Getconn( hdcon , &hptr, &hdlen, &lcon, &rcon) ;
  if (rcon == 255) {
    fprintf(stderr,"ERROR:Rcon is unmatch![%s]\n",hdcon) ;
    if (strlen( yomi) >= size ) {
      fprintf(stderr ,"ERROR(GetYomiGobi):OutBuffer is too small!\n") ;
      *out = '\0' ;
      return 0 ;
    }
    strcpy( out, yomi) ;
    return( strlen( out ) );
  }
  j_katuyou(J_rcon[rcon].type1, gobi) ;
  //cp = skip_ptr( '(', hdcon ) ;
  ret = copy_word( out, size , yomi, NULL ) ;
  if ( (ret + strlen(gobi)) >= size) {
    *out = '\0' ;
    return 0 ;
  }
  if ( gobi[0] != '\0' ) {
    strcpy( out+ret, "") ;
    EDR_HiraKana(gobi2,gobi) ;
    strcpy( out+ret+2, gobi2) ;
  }
  return ( strlen( out ) ) ;
}






/****************************************************
*  ܸʹˤñ츫Фؿ
*   USAGE:		GetIdiomSpl_J( char *hdcon, int cat, char *out, int size)
*   SYNOPSIS:		char *hdcon (IN)  ѲϢ
*                       int  cat    (IN)  ʻɣ
*                       char *out   (OUT) ñ츫ФǼ
*                       int  size   (IN)  ñ츫ФǼΥ
*
*   DESCRIPTION:	
*	ñ츫Ф[ɤ]פΡñ츫Фʬؿ
*       ߷δФ롣
*
*   RETURN:	        ñ츫ФΥ
*
*****************************************************/
int   GetIdiomSpl_J(char *hdcon, int cat, char *out, int size)
{
  int ii , jj , kk, ct ;
  char work[8192] , *ary[256] , wk[1024] ;
  int hdlen , ret ;
  char *hptr,word[1024], *st = out ;
  char  *cp ;
  unsigned char lcon, rcon ;

  if (strlen(hdcon) >= 8192) {
    fprintf( stderr,"ERRPR(GetIdiomSpl_J):Work buffer is too small!\n" ) ;
    *out = '\0' ;
    return 0 ;
  }
  ii = rep1( '/', hdcon, '\t', work) ;
  jj = split1( '\t', work, ary) ;
  for( ii = 0 ; ii < (jj - 1) ; ii++ ) {
    Getconn( ary[ii] , &hptr, &hdlen, &lcon, &rcon) ;
    if ( ClassNamep( 'J', hptr, hdlen, lcon, rcon ) < 0) { /* *nodeå */
      if ( ii != ( jj -1 ) ) {
         copy_word(wk, 1024 , hptr, hptr+hdlen ) ;
         ret = EDR_StrStrip(out,wk) ;
         out += ret ;
         size -= ret;
      }
    }
  }
  Getconn( ary[ii] , &hptr, &hdlen, &lcon, &rcon) ;
  copy_word(word, 1024 , hptr, hptr+hdlen ) ;
  kk = SetHdcon(word,lcon,rcon,wk,1024) ;
  if ( cat < 255 ) {
    if (strcmp(J_POS[cat].type1,"JVE") == 0 ||
        strcmp(J_POS[cat].type1,"JAX") == 0 ||
        strcmp(J_POS[cat].type1,"JPR") == 0 ||
        strcmp(J_POS[cat].type1,"JJD") == 0 ||
        strcmp(J_POS[cat].type1,"JJP") ==0 ) {
      for( kk = 0 ; CHGJHDWDTBL[kk].type1 != NULL ; kk++ ) {
        //printf("SetHdcon:work=[%s] : tbl[%s]\n",wk,CHGJHDWDTBL[kk].type1) ;
        if ( *(unsigned char *)wk == *(CHGJHDWDTBL[kk].type1) &&
             strcmp(wk,CHGJHDWDTBL[kk].type1) == 0 ) {
          cp = skip_ptr( '\t', CHGJHDWDTBL[kk].type2 ) ;
          ret = copy_word( out, size , CHGJHDWDTBL[kk].type2, cp ) ;
          out += ret ;
          size -= ret ;
          break ;
        }
      }
      if ( CHGJHDWDTBL[kk].type1 != NULL ) 
        return( out - st ) ;
    }
    j_katuyou(J_rcon[rcon].type1, wk) ;
    copy_word(out, size , hptr, hptr+hdlen ) ;
    out += hdlen ;
    size -= hdlen;
    ret = copy_word( out, size , wk, NULL ) ;
    ct = strlen(wk) ;
    out += ct ;
    return( out - st );
  }
  ret = copy_word( out, size , wk, NULL ) ;
  ct = strlen(wk) ;
  out += ct ;
  return( out - st );
}




/****************************************************
*  ܸʹˤñ츫Фդָդɤߡפؿ
*   USAGE:		GetIdiomYomi_J( char *hdcon, char *yomi, char *out, int size)
*   SYNOPSIS:		char *hdcon (IN) ѲϢ
*                       char *yomi  (OUT) ʤɤ
*                       int  cat    (IN)  ʻɣ
*                       char *out   (OUT) դɤ߳Ǽ
*                       int  size   (IN)  դɤ߳ǼΥ
*
*   DESCRIPTION:	
*	ñ츫Ф[ɤ]פΡɤߡפؿ
*       ߷ɤߤ롣
*
*   RETURN:	        ñ츫ФΥ
*
*****************************************************/
int   GetIdiomYomi_J( char *hdcon, char *yomi, int cat, char *out, int size)
{
  char work1[8192] , *ary1[256] ;
  char work2[8192] , *ary2[256] ;
  char work[8192] ;
  int hdlen ;
  char *hptr,word[1024], *cp ;
  int  ii, kk , jj ,j1, j2 ,ret ;
  unsigned char lcon, rcon ;


  if (strlen(hdcon) >= 8192) {
    fprintf( stderr,"ERRPR(GetIdiomYomi_J):Work buffer is too small!\n" ) ;
    *out = '\0' ;
    return 0 ;
  }
  if (strlen(yomi) >= 8192) {
    fprintf( stderr,"ERRPR(GetIdiomYomi_J):Work buffer is too small!\n" ) ;
    *out = '\0' ;
    return 0 ;
  }
  ii = rep1( '/', hdcon, '\t', work1) ;
  j1 = split1( '\t', work1, ary1) ;
  ii = rep1( '/', yomi, '\t', work2) ;
  j2 = split1( '\t', work2, ary2) ;
  if ( j1 != j2 ) {
    fprintf( stderr,"ERRPR(GetIdiomYomi_J):Idiom Info. is illegal!\n" ) ;
    *out = '\0' ;
    return 0 ;
  }
  Getconn( ary1[j1-1] , &hptr, &hdlen, &lcon, &rcon) ;
  if ( ClassNamep( 'J', hptr, hdlen, lcon, rcon ) < 0) { /* *nodeå */
    copy_word(word, 1024 , hptr, hptr+hdlen ) ;
    ret = SetHdcon(word,lcon,rcon,work,8192) ;
    if ( cat < 255 ) {
      if (strcmp(J_POS[cat].type1,"JVE") == 0 ||
          strcmp(J_POS[cat].type1,"JAX") == 0 ||
          strcmp(J_POS[cat].type1,"JPR") == 0 ||
          strcmp(J_POS[cat].type1,"JJD") == 0 ||
          strcmp(J_POS[cat].type1,"JJP") ==0 ) {
        for( kk = 0 ; CHGJHDWDTBL[kk].type1 != NULL ; kk++ ) {
          //printf("SetHdcon:work=[%s] : tbl[%s]\n",work,CHGJHDWDTBL[kk].type1) ;
          if ( *(unsigned char *)work == *(CHGJHDWDTBL[kk].type1) &&
               strcmp(work,CHGJHDWDTBL[kk].type1) == 0 ) {
            cp = skip_ptr( '\t', CHGJHDWDTBL[kk].type2 ) ;
            ret = copy_word( work, 1024, cp+1, NULL ) ;
            ret = YomiGobiJ( ary2, j2, word, work, out, size ) ;
            return ret ;
          }
        }
      }
    }
    j_katuyou(J_rcon[rcon].type1, work) ;
    //printf("j_katuyou ret=[%s]\n", work) ;
    if ( work[0] == '\0' ) {
      ret = YomiGobiJ( ary2, j2, NULL, work, out, size ) ;
      return ret ;
    }
    ret = YomiGobiJ( ary2, j2, NULL, work, out, size ) ;
    return ret ;
  }
  ret = YomiGobiJ( ary2, j2, NULL, NULL, out, size ) ;
  return ret ;
}




int SetHdcon(char *word,int lcon, int rcon,char *out, int size)
{
  int ret ;
  ret = copy_word(out, size , word, NULL) ;
  *(out+ret) = '(' ; ret++ ;
  ret += copy_word(out+ret, (size - ret), J_lcon[lcon].type1, NULL ) ;
  *(out+ret) = ',' ; ret++ ;
  ret += copy_word(out+ret, (size - ret), J_rcon[rcon].type1, NULL ) ;
  *(out+ret) = ')' ; ret++ ;
  *(out+ret) = '\0' ;
  return ret ;
}



int  YomiGobiJ( char **ary, int aryct, char *rep, char *gobi, char *out, int size )
{
  int ii, len ;
  int ret = 0 ;

  *out = '\0' ;
  
  for ( ii = 0 ; ii < (aryct - 1)  ; ii++) {
    if ( ( ret + strlen(ary[ii]) ) >= size ) {
      fprintf( stderr,"ERROR(YomiGobiJ):Output buffer is too small!\n") ;
      *out = '\0' ;
      return 0 ;
    }
    len = EDR_StrStrip(out+ret,ary[ii]) ;
    ret += len ;
  }

  if ( rep == NULL || *rep == '\0' ) {
    if ( ( ret + strlen(ary[ii]) ) >= size ) {
      fprintf( stderr,"ERROR(YomiGobiJ):Output buffer is too small!\n") ;
      *out = '\0' ;
      return 0 ;
    }
    len = EDR_StrStrip(out+ret,ary[ii]) ;
    ret += len ;
  }
  if ( ii != 0 & gobi != NULL && *gobi != '\0' ) {
    if ( ( ret + strlen(gobi)+ 2 ) >= size ) {
      fprintf( stderr,"ERROR(YomiGobiJ):Output buffer is too small!\n") ;
      *out = '\0' ;
      return 0 ;
    }
    strcpy(out+ret,"") ;
    EDR_HiraKana( out+ret+2, gobi ) ;
    ret += (strlen( gobi )+2) ;
  }
  else {
    if ( ( ret + strlen(gobi)+ 2 ) >= size ) {
      fprintf( stderr,"ERROR(YomiGobiJ):Output buffer is too small!\n") ;
      *out = '\0' ;
      return 0 ;
    }
    EDR_HiraKana( out+ret, gobi ) ;
    ret += strlen(gobi) ;
  }
  return( ret ) ;
}
       



int ClassNamep( char lang, char *hptr, int hlen, unsigned char lcon, unsigned char rcon)
{
  if ( lang == 'J' ) {
    if ( *hptr == '*' && hlen == 1 &&
         *J_lcon[lcon].type1 == '*' && *(J_lcon[lcon].type1+1) == '\0' &&
         *J_lcon[rcon].type1 == '*' && *(J_lcon[rcon].type1+1) == '\0' ) {
            return( 1 ) ;
    }
    return( -1 ) ;
  }
  return( -1 );
}


/*######################################################Ѹ*/
/****************************************************************
*   Ϣ°ͤ顢Ѹ롣
*   USAGE:		j_katuyou( char *rcon, char *out )
*   SYNOPSIS:		char  *rcon   (IN)   Ϣ°
*                       char  *out    (OUT)  Ǽꥢ
*
*   DESCRIPTION:	
*	ơ֥뤫鳺ᡢ֤ͤ
*       ޤͤơ֥ϿƤʤС
*       "" ֤
*       :ΰϣХȰʾѰդ٤
*
*   RETURN:		ʤ
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
void  j_katuyou( char *rcon, char *out )
{
  unsigned char  ii ;
  char ch3 = *(rcon+2) ;

  //printf("(j_katuyou):rcon=>[%s]\n",rcon) ;
  for( ii = 0 ; J_KATSUYOU[ii].type1 != NULL && ii < 255 ; ii++) {
    if ( ch3 == *(J_KATSUYOU[ii].type1+2) && strcmp( rcon, J_KATSUYOU[ii].type1) == 0 ) {
      strcpy(out,J_KATSUYOU[ii].type2 ) ;
      return ;
    }
  }
  *out = '\0' ;
  return ;
}
















