/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include <stdlib.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
#include "aconst.h"

/*** template ***/
char ExistCPC( char *node ) ;
int  GetParentCPC( char dict, char *cid, char *parents, int *rids )  ;



/****************************************************************
*   ǰηϥѥå롣
*   USAGE:		ChkCPCPath( char *path )
*   SYNOPSIS:           char  *path (IN)  ǰ̻Ҥ/ǤĤʤѥ
*                       
*   DESCRIPTION:	
*	Ϳ줿ǰηϥѥФΥΡɿ֤
*
*   RETURN:		ǰηϥѥξ:Ρɿ
*                       ǰ̻Ҵ֤Υ󥯤: -1
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int ChkCPCPath( char *path )
{
   char *nd[128], *cary[12] ;
   int   nct, ii, jj ;
   int   len, ret, msz, slen, fd ;
   char  dict = '\0' ;
   char  data[4096], work[1024] ;
   char *datap ;

   nct = split1( '/', path, nd) ;
   for( ii = 0 ; ii < nct ; ii++ ) {
     if ( ii == 0 && *nd[ii] == '\0' )
       continue ;
     len = 0 ;
     if ( (dict == 'B' || dict == '\0' ) && CCID2CPRecID != NULL) {
       len = Get_DataLeng(CCID2CPRecID, nd[ii], strlen(nd[ii]) ) ;
       if ( len != 0 )
         dict = 'B' ;
     }
     if ( (dict == 'T' || dict == '\0' ) && TCCID2CPRecID != NULL) {
       len = Get_DataLeng(TCCID2CPRecID, nd[ii], strlen( nd[ii] ) ) ;
       dict = 'T' ;
     }
     if ( len == 0 ) {
       fprintf( stderr, "ERROR:Don't exist CID[%s]\n",nd[ii]) ;
       return -1;
     }
     if ( ii == (nct -1 ) )
       break ;
     if ( len > 4096 ) {
       ret = len / 4096 ;
       msz = ( ret +1 ) * 4096 ;
       if ( (datap = (unsigned char *)malloc( msz ) ) == NULL ) {
         fprintf( stderr,"ERROR:malloc error!\n" ) ;
         return  ;
       }
     }
     else {
       datap = &data[0] ;
       msz = 4096 ;
     }
     ret = 0 ;                                /* ǰηϥǥå */
     if ( dict == 'B' )
       ret = Get_IXT(CCID2CPRecID, nd[ii], strlen(nd[ii]), datap, msz) ;
     else if ( dict == 'T' )
       ret = Get_IXT(TCCID2CPRecID, nd[ii], strlen(nd[ii]), datap, msz) ;

     for( jj = 0 ; jj < ret ; jj += 5 ) {
       if ( (*(datap + jj + 4) & 0x02) == 0 ) 
         continue ;
       slen = 0 ;
       if ( dict == 'B' && CPCRecId2Val != NULL )
         slen = Get_IXT(CPCRecId2Val, (char *)(datap + jj), 4, work,1024) ;
       else if ( dict == 'T' && TCPCRecId2Val != NULL)
         slen = Get_IXT(TCPCRecId2Val, (char *)(datap + jj), 4, work,1024) ;
       if ( slen <= 0 ) {
         fprintf( stderr,"ERROR(GetParent_CPCDB):ģ¤\n") ;
         fprintf( stderr,"   CID[%s] RID[%d]\n",nd[ii],*(int *)(datap + jj)) ;
         if ( len > 4096 )
           free( datap ) ;
         return -1;
       }
       fd = StartPtsCPC( work, slen, cary)  ;
       if ( strcmp( cary[1], nd[ii+1]) == 0 ) 
         break ;
     }
     if ( len > 4096 )
       free( datap ) ;
     if ( ii == ret ) {
       fprintf(stderr, "ERROR:%s => %s\n",nd[ii], cary[1] ) ;
       return -1 ;
     }
  }
  return nct ;
}





/****************************************************************
*   ǰηϥѥΥ꡼եΡɤ֤
*   USAGE:		GetLastNodePt( char *path )
*   SYNOPSIS:           char  *path (IN)  ǰ̻Ҥ/ǤĤʤѥ
*                       
*   DESCRIPTION:	
*	Ϳ줿ǰηϥѥüΡɤΰ֤֤
*
*   RETURN:	
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
char *GetLastNodePt( char *path )
{
   char *cp, *ncp ;

   for( cp = path ; *cp != '\0' ; cp = ncp + 1 ) {
     ncp = skip_ptr('/',cp) ;
     if ( ncp == NULL )
       return ( cp ) ;
   }
   return NULL ;
}




/****************************************************************
*   ǰηϥѥκ
*   USAGE:		SetNewDir(char *cur, char *add)
*   SYNOPSIS:           char  *path (IN/OUT)  ǰ̻Ҥ/ǤĤʤѥ
*                       char  *add  (IN)      лѥ
*                                 ./aaaa/bbb
*                                 ../../ccc
*
*   DESCRIPTION:	
*	Ϳ줿ǰηϥѥüΡɤΰ֤֤
*
*   RETURN:	
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int SetNewDir(char *cur, char *add)
{
   char *nd[128] ;
   int   ii, jj, nct ;
   char *cp ;

   nct = split1( '/', add, nd) ;
   for( ii = 0 ; ii < nct ; ii++ ) {
     if ( strcmp( nd[ii], ".." )  != 0 )
       break ;
   }
   cp = cur + strlen(cur) ;
   jj = ii ;
   if ( ii != 0 ) {
     for(  ; cp != cur ; cp-- ) {
       if ( *cp == '/' ) {
         ii-- ;
         if ( ii == 0 ) 
           break ;
       }
     }
   }
   for( ii = jj ; ii < nct ; ii++ ) {
     if ( strcmp( nd[ii], "." ) == 0 )
       continue ;
     if ( *cp != '/' ) {
       *cp = '/' ;
     }
     cp++ ;
     strcpy( cp, nd[ii] ) ;
     cp += strlen( nd[ii] ) ;
   }
   *cp = '\0' ;
   return ( cp - cur ) ;
}




/****************************************************************
*   ǰηϤΥ󥯴طƻҥΡ̾ʬ
*   USAGE:		GetParChi( char *path, char *parent, char *child)
*   SYNOPSIS:           char  *path   (IN)  ǰ̻Ҥ/ǤĤʤѥ
*                       char  *parent (OUT) ƥΡ
*                       char  *child  (OUT) ҥΡ
*
*   DESCRIPTION:	
*	Ϳ줿ǰηϥѥüοƻҥΡɤ֤
*       ƥΡɤꤵƤʤϡparent  '\0'򥻥åȡ
*
*   RETURN:	
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int GetParChi( char *path, char *parent, char *child)  
{
   char *nd[128] ;
   int   ii, jj, nct ;
   char *cp ;

   nct = split1( '/', path, nd) ;
   if ( nct > 1 ) {
     strcpy( parent, nd[nct-2]) ;
     strcpy( child , nd[nct-1]) ;
   }
   else {
     *parent = '\0' ;
     strcpy( child, path );
   }
   return 1 ;
}




/****************************************************************
*   ꤵ줿ǰοƻҴطǧ
*   USAGE:		ChkParChi( char *parent, char *child )
*   SYNOPSIS:           char  *parent (IN)  Ƴǰ̻
*                       char  *child  (OUT) ҳǰ̻
*
*   DESCRIPTION:	
*	Ϳ줿ǰ֤˿ƻҴطΩäƤ뤫ǧ
*     ƻҴطʤ餽μΥ쥳ID֤롣
*
*   RETURN:	  RID : ƻҴط򵭽ҤημΥ쥳ID
*                 -1  : ǰˤϿƻҴطΩʤä
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int ChkParChi( char *parent, char *child ) 
{
  char dict ;
  char parents[512] ;
  int  ii, jj, ret ;
  int  rids[32] ;

  dict = ExistCPC( child ) ;

  if ( dict == '\0' )
    return ( -1 ) ;

  *parents = '\0' ;
  ret = GetParentCPC( dict, child, parents, rids ) ;
  if ( *parent == '\0' ) {
    if ( ret == 1 ) {
      strcpy(parent,parents) ;
      fprintf(stderr,"ERROR:does not select a parent.\n") ;
      return( rids[0] ) ;
    }
    return -2 ;
  }
  for ( ii = jj = 0 ; ii < ret ; ii++)  {
    if ( strcmp( &parents[jj], parent ) == 0 ) {
      return ( rids[ii] ) ;
    }
    jj += strlen(&parents[jj]) +1 ;
  }
  fprintf(stderr,"ERROR:CID{ %s } =X=> CID{ %s }\n", parent, child ) ;
  return( -2 ) ;
}




/* ̳ǰ쥳ֹ ɲ */
int AddRIDtoPN( int rid, char *parent, char *child ) 
{
  char work[16] ;
  int  ret ;
  
  put4byte( rid, work ) ;
  work[4] = 0x02 ;
  ret = Add_IXT_DATA2( CCID2CPRecID, parent, strlen(parent), work, 5) ;
  if ( ret <= 0 ) {
    fprintf( stderr,"̳ǰ[%s]쥳ֹ[%d] ɲäǤޤǤ\n",parent,rid) ;
    return -1 ;
  }
  return 1 ;
}



/* ̳ǰ쥳ֹ  */
int DelRIDfromPN( int rid, char *parent, char *child ) 
{
  char work[16] ;
  int  ret ;
  
  put4byte( rid, work ) ;
  work[4] = 0x02 ;
  ret = Rem_IXT_DATA( CCID2CPRecID, parent, strlen(parent), work, 5) ;
  if ( ret <= 0 ) {
    fprintf( stderr,"̳ǰ[%s]쥳ֹ[%d] ǤޤǤ\n",parent,rid) ;
    return -1 ;
  }
  return 1 ;
}



/* ̳ǰ쥳ֹ ɲ */
int AddRIDtoCN( int rid, char *parent, char *child ) 
{
  char work[16] ;
  int  ret ;
  
  put4byte( rid, work ) ;
  work[4] = 0x01 ;
  ret = Add_IXT_DATA2( CCID2CPRecID, child, strlen(child), work, 5) ;
  if ( ret <= 0 ) {
    fprintf( stderr,"̳ǰ[%s]쥳ֹ[%d] ɲäǤޤǤ\n",child,rid) ;
    return -1 ;
  }
  return 1 ;
}



/* ̳ǰ쥳ֹ  */
int DelRIDfromCN( int rid, char *parent, char *child ) 
{
  char work[16] ;
  int  ret ;
  
  put4byte( rid, work ) ;
  work[4] = 0x01 ;
  ret = Rem_IXT_DATA( CCID2CPRecID, child, strlen(child), work, 5) ;
  if ( ret <= 0 ) {
    fprintf( stderr,"̳ǰ[%s]쥳ֹ[%d] ǤޤǤ\n",child,rid) ;
    return -1 ;
  }
  return 1 ;
}


/* ǰηϥ쥳ɤι */
int UpdateCPC( int rid, char *parent, char *child ) 
{
  char work[1024] ;
  char date[32] ;
  char *user ;
  int  ct ;
  int  ret ;

  put4byte( rid, work ) ;
  ct = 4 ;
  strcpy( &work[ct], parent) ; ct += strlen(parent) + 1 ;
  strcpy( &work[ct], child ) ; ct += strlen(child) + 1 ;
  ret = PackNowDateC( date ) ;
  strcpy( &work[ct], "DATE=\"" ) ; ct += 6 ;
  strcpy( &work[ct], date ) ; ct += strlen(date) ;
  user = getenv("USER") ;
  strcpy( &work[ct], "\";USER=\"" ) ; ct += 8 ;
  strcpy( &work[ct], user ) ; ct += strlen(user) ;
  strcpy( &work[ct], "\"" ); 
  ct++ ;
  ret = Put_IXT(CPCRecId2Val, work, 4, work, ct) ;
  /* printf("Put_IXT(Rid=>CPC): ret=%d\n",ret) ; */
  return 1 ;
}


/* ǰηϥ쥳ɤι */
int DeleteCPC( int rid, char *parent, char *child ) 
{
  int  ret ;

  ret = Put_IXT(CPCRecId2Val, (char *)&rid, 4, NULL, 0) ;
  /* printf("Put_IXT(Rid=>CPC): ret=%d\n",ret) ; */
  return 1 ;
}


/* ǰη Ǽ */
int PutCPCLOG( char *com, char dict, int rid, char *from, char *child, char *to )
{
  int bdate, dhash ;
  int ret ;
  char work[1024] , *user ;
  int  len ;
  
  bdate = PackNowDateI() ;
  dhash = ConvPackDate2B( bdate ) ;

  strcpy( work, com ) ; len = strlen(com) ;
  work[len++] = '\t' ;
  if ( dict == 'B')
    sprintf(&work[len], "CPC%07d\t", rid) ;
  else
    sprintf(&work[len], "TCPC%07d\t", rid) ;

  len += strlen(&work[len]) ;
  if ( from != NULL && *from != '\0' ) {
    strcpy( &work[len], from ); len += strlen(from) ;
    work[len++] = '/' ;
  }
  strcpy( &work[len], child ); len += strlen(child) ;
  work[len++] = '\t' ;

  if ( to != NULL && *to != '\0' ) {
    strcpy( &work[len], to ); len += strlen(to) ;
    work[len++] = '/' ;
    work[len++] = '.' ;
    work[len++] = '\t' ;
  }

  user = getenv( "USER" ) ;
  strcpy( &work[len], user ); len += strlen(user) ;
  work[len++] = '\0' ;
    
  ret = Add_IXT_DATAV( UpdLogConc, (char *)&dhash, 4, work , len) ;
  //printf("Key=%x      UpdateInfo.=[%s]\n", dhash, work) ; 
  return ret ;
}





/* ǰФ Ǽ */
int PutCPHLOG( char *com, char dict, int rid, char *cid, char *eh, char *jh, char *eexp, char *jexp)
{
  int bdate, dhash ;
  int ret ;
  char work[1024] , *user ;
  int  len ;
  
  if ( UpdLogConc == NULL ) {
    return 0 ;
  }
  bdate = PackNowDateI() ;
  dhash = ConvPackDate2B( bdate ) ;

  strcpy( work, com ) ; len = strlen(com) ;
  work[len++] = '\t' ;
  if ( dict == 'B' )
    sprintf(&work[len], "CPH%07d\t%s\t%s\t%s\t%s\t%s\t", rid, cid, eh, jh, eexp, jexp) ;
  else
    sprintf(&work[len], "TCPH%07d\t%s\t%s\t%s\t%s\t%s\t", rid, cid, eh, jh, eexp, jexp) ;
  len += strlen(&work[len]) ;
  user = getenv( "USER" ) ;
  strcpy( &work[len], user );
  len += strlen(user) ;
  work[len++] = '\0' ;
    
  ret = Add_IXT_DATAV( UpdLogConc, (char *)&dhash, 4, work , len) ;
  // printf("Key=%x   UpdateInfo.=[%s]\n", dhash, work) ; 
  return ret ;
}





/* ܸ쳵ǰФ ǧ */
int CphJHdwd( char *out, int size, char *in)
{
  char work[1024], buff[1024] ;
  char *ini = out ;
  char *st, *yo, *cp ;
  int  ret, len ;
  
  *out = '\0' ;
  st = skip_non_sp( in ) ;
  if ( st == NULL )
    return ( -1 ) ;
  cp = skip_ptr( '[', st ) ;
  if ( cp == NULL ) {
    fprintf(stderr,"ERROR(CphJHdwd)1:ܸ쳵ǰФɤʬεҤ¸ߤʤ\n") ;
    return ( -1 ) ;
  }
  len = copy_word( work, 1024, st, cp ) ;
  work[len] = '\0' ;
  ret = Conv2Small(buff, work) ;
  len = EDR_StrCapsule( out, buff, size ) ;
  out += len ;
  *out = '[' ; out++ ;
  st = skip_non_sp( cp +1 ) ; /* ɤʬȼ */
  if ( st == NULL || *st == '\0' ) {
    fprintf(stderr,"ERROR(CphJHdwd)2:ܸ쳵ǰФɤʬεҤ¸ߤʤ\n") ;
    return ( -1 ) ;
  }
  cp = skip_ptr( ']', st ) ;
  if ( cp == NULL ) {
    fprintf(stderr,"ERROR(CphJHdwd)3:ܸ쳵ǰФɤʬεҤ¸ߤʤ\n") ;
    return ( -1 ) ;
  }
  len = copy_word( work, 1024, st, cp ) ;
  work[len] = '\0' ;
  ret = Conv2Small(buff, work) ;
  len = EDR_StrCapsule( out , buff, size ) ;
  out += len ;
  *out = ']' ; out++ ;
  *out = '\0' ;
  return ( out - ini ) ;
}








/* ꤵ줿ǰηϾˤ뤫å */
char ExistCPC( char *node )
{
  int  len ;

  if ( CCID2CPRecID != NULL ) {
    len = Get_DataLeng(CCID2CPRecID, node, strlen(node) ) ;
    if ( len != 0 )
      return( 'B' ) ;
  }
  if ( TCCID2CPRecID != NULL ) {
    len = Get_DataLeng(TCCID2CPRecID, node, strlen( node ) ) ;
    if ( len != 0 )
      return( 'T' ) ;
  }

  return ( '\0' ) ;
}



/* ꤵ줿ǰǰФDBˤ뤫å */
char ExistCPH( char *node )
{
  int  len ;

  if ( CHID2CPRecID != NULL ) {
    len = Get_DataLeng( CHID2CPRecID, node, strlen(node) ) ;
    if ( len != 0 )
      return( 'B' ) ;
  }
  if ( TCHID2CPRecID != NULL ) {
    len = Get_DataLeng( TCHID2CPRecID, node, strlen( node ) ) ;
    if ( len != 0 )
      return( 'T' ) ;
  }

  return ( '\0' ) ;
}







/*
 Ϳ줿ǰξ̳ǰ,γǰ̻Ҥ줿Ƥο֤
*/
int  GetParentCPC( char dict, char *cid, char *parents, int *rids ) 
{
  int flag ;
  char data[4096], *datap ;
  char work[1024] , *cary[32] ;
  int  ii, len, msz ;
  int  ret, slen, rct ;

  len = 0 ;
  if ( dict == 'B' && CCID2CPRecID != NULL)
    len = Get_DataLeng(CCID2CPRecID, cid, strlen(cid) ) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    len = Get_DataLeng(TCCID2CPRecID, cid, strlen( cid ) ) ;
  if ( len == 0 )
    return 0;
  if ( len > 4096 ) {
    ret = len / 4096 ;
    msz = ( ret +1 ) * 4096 ;
    if ( (datap = (unsigned char *)malloc( msz ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return 0 ;
    }
  }
  else {
    datap = &data[0] ;
    msz = 4096 ;
  }

  ret = 0 ;                                /* ǰηϥǥå */
  if ( dict == 'B' && CCID2CPRecID != NULL )
    ret = Get_IXT(CCID2CPRecID, cid, strlen(cid), datap, msz) ;
  else if ( dict == 'T' && TCCID2CPRecID != NULL)
    ret = Get_IXT(TCCID2CPRecID, cid, strlen(cid), datap, msz) ;

  rct = 0 ;
  for( ii = 0 ; ii < ret ; ii += 5 ) {
    if ( (*(datap + ii + 4) & 0x01) == 0 ) 
      continue ;
    if ( dict == 'B' && CPCRecId2Val != NULL ) {
      slen = Get_IXT(CPCRecId2Val, (datap+ii), 4, work,1024) ;
      if ( slen <= 0 ) 
        continue ;
      //        | Rec-ID | ̳ǰID\0 | ̳ǰID\0 | \0 |
      //        |  (4)   | (n)          | (n)          | (n)        |
      StartPtsCPC( work, slen, cary)  ;
      strcpy( parents, cary[1] ) ;
      parents += strlen( cary[1] ) +1 ;
      rids[rct] = get4byte(cary[0]) ;
      rct++ ;
    }
    else if ( dict == 'T' && TCPCRecId2Val != NULL) {
      slen = Get_IXT(TCPCRecId2Val, (datap+ii), 4, work,1024) ;
      if ( slen <= 0 ) 
        continue ;
      StartPtsCPC( work, slen, cary)  ;
      strcpy( parents, cary[1] ) ;
      parents += strlen( cary[1] ) +1 ;
      rids[rct] = get4byte(cary[0]) ;
      rct++;
    }
  }
  if ( len > 4096 )
    free( datap ) ;
  return rct ;
}


