#include <stdio.h>
#include <fcntl.h>
#include "fconst.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/

/****************************************************************
    ţģҼ˴ؤؿ
****************************************************************/

/****************************************************************
*   " "ǰϤޤ줿ʸ󤫤顢" "
*   USAGE:		EDR_StrStrip(  char *out, char *str )
*   SYNOPSIS:           char  *out (OUT)  å򳰤ʸ
*  	 	        char  *str (IN)   оʸ
*                       
*   DESCRIPTION:	
*	Ϳ줿ʸ󤬡" "ǰϤޤƤϡΥå
*       Τ֤
*       " "ǰϤޤƤʤΤϡΤޤ֤
*
*   RETURN:		ȥव줿ʸĹ
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int  EDR_StrStrip( char *out, char *str )
{
  int   len, i = 0 ;

  len = strlen(str) ;
  if ( *str != '\"' || *(str + len - 1) != '\"') {
    strcpy(out,str) ;
    return( len ) ;
  }
  str++ ; 
    /*  \\  \ Ѵ */
    /*  \"  " Ѵ */

  while( *str != '"' || *(str+1) != '\0' ) {
    if ( ( *str & 0x80 ) == 0 ) {
      i++ ;
      if ( *str == '\\' ) {
        *out = *(str+1) ; out++ ;
        str += 2 ;
        continue ;
      }
      *out = *str ; out++ ; str++ ;
      continue ;
    }
    else {
      *out = *str ; out++ ; str++ ;
      *out = *str ; out++ ; str++ ;
      i += 2 ;
    }
  }
  *out = '\0' ;
  return  i ;
}






/****************************************************************
*   üʸޤʸ " "ǰϤࡣ
*   USAGE:		EDR_StrCapsule(  char *out, char *str, int osize )
*   SYNOPSIS:           char  *out (OUT)  åդʸ
*  	 	        char  *str (IN)   оʸ
*                       int   osize(IN)   ϰ礭
*                       
*   DESCRIPTION:	
*	Ϳ줿ʸüʸޤ硢" "ǰϤࡣ
*
*   RETURN:		" "ޤΤʸĹ
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int EDR_StrCapsule(char *out, char *str, int osize )
{
  int len , ii;
  char *st = out ;

  len = strlen(str) ;
  if (*str == '"' && *(str+len-1) == '"') {
    if (( len + 1) >= osize ) {
      fprintf( stderr,"ERROR(EDR_StrCapsule):Output buffer is too small!\n") ;
      *out = '\0' ;
      return 0 ;
    }
    strcpy(out,str) ;
    return len ;
  }
  if ( EDR_ChkStr( str ) == 0 ) {
    if (( len + 1) >= osize ) {
      fprintf( stderr,"ERROR(EDR_StrCapsule):Output buffer is too small!\n") ;
      *out = '\0' ;
      return 0 ;
    }
    strcpy(out,str) ;
    return len ;
  }
  *out = '"' ;
  ii = 0 ;
  for ( out++ ; *str != '\0' ; str++) {
    if ( (ii + 4) >= osize) {
      fprintf( stderr,"ERROR(EDR_StrCapsule):Output buffer is too small!\n") ;
      *st = '\0' ;
      return 0 ;
    }
    if ( *str == '\\' ) {
      *out = '\\' ; out++ ;
      *out = '\\' ; out++ ;
      ii += 2 ;
      continue ;
    }
    if ( *str == '"' ) {
      *out = '\\' ; out++ ;
      *out = '"' ; out++ ;
      ii += 2 ;
      continue ;
    }
    *out = *str ; out++ ;
    ii++ ;
  }
  *out = '"' ; out++ ;
  *out = '\0' ;
  return( out - st ) ;
}


/* üʸ return (-1) ;   */
int EDR_ChkStr( char *str )
{
  unsigned short xx ;
  while( *str != '\0' ) {
    if ( (*str & 0x80 ) == 0 ) {
      if( ( *str >= '0' && *str <= '9' ) ||
          ( *str >= 'a' && *str <= 'z' ) ||
          ( *str >= 'A' && *str <= 'Z' ) ) {
        str++ ;
        continue ;
      }
      return ( -1 ) ;
    }
    xx = get2byte( str ) ;
    if ( xx >= 0xa1a1 /*''*/ ) {
      if ( xx == 0xa1bc /*''*/ ||
           xx == 0xa1a6 /*''*/ ||
           xx == 0xa1b9 /*''*/ ) {
        str += 2 ;
	continue ;
      }
      if ( xx < 0xa3b0 /*''*/ || 
           (xx >= 0xa6a1 /*''*/  && xx <= 0xa7f1 /*''*/ ) ) {
	return( -1 ) ;
      }
      str += 2 ;
      continue ;
    }
    return ( -1 ) ;
  }
  return( 0 ) ;
}




/****************************************************************
*   ʡҤ餬Ѵ
*   USAGE:		EDR_KanaHira( char *out, char  *str )
*   SYNOPSIS:		char   *str (IN)   ʸ
*                       char   *out (OUT)  ʸ
*                       
*   DESCRIPTION:	
*	Ϳ줿ʸΥʬҤ餬ʤѴ
*       ֤
*
*   RETURN:		ʸĹ
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int  EDR_KanaHira( unsigned char *out, unsigned char *str )
{
  int   len, i = 0 ;

  while( *str != '\0' ) {
    if ( ( *str & 0x80 ) == 0 ) {
      i++ ;
      *out = *str ; out++ ; str++ ;
      continue ;
    }
    else {
      if ( *str == 0xa5 &&
           ( *(str + 1) < 0xf4 ) ) {  /* ֥ס֥ס֥פϽ */
        *out = 0xa4 ; out++ ; str++ ;
        *out = *str ; out++ ; str++ ;
      }
      else {
        *out = *str ; out++ ; str++ ;
        *out = *str ; out++ ; str++ ;
      }
      i += 2 ;
    }
  }
  *out = '\0' ;
  return  i ;
}



/****************************************************************
*   Ҥ餬ʡ䥫Ѵ
*   USAGE:		EDR_HiraKana( char  *out, char *str )
*   SYNOPSIS:		char   *str (IN)   ʸ
*                       char   *out (OUT)  ʸ
*                       
*   DESCRIPTION:	
*	Ϳ줿ʸΤҤ餬ʬ򥫥ʤѴ
*       ֤
*
*   RETURN:		ʸĹ
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int  EDR_HiraKana( unsigned char *out, unsigned char *str )
{
  int   len, i = 0 ;

  while( *str != '\0' ) {
    if ( ( *str & 0x80 ) == 0 ) {
      i++ ;
      *out = *str ; out++ ; str++ ;
      continue ;
    }
    else {
      if ( *str == 0xa4 ) {
        *out = 0xa5 ; out++ ; str++ ;
        *out = *str ; out++ ; str++ ;
      }
      else {
        *out = *str ; out++ ; str++ ;
        *out = *str ; out++ ; str++ ;
      }
      i += 2 ;
    }
  }
  *out = '\0' ;
  return  i ;
}


/****************************************************************
*   Ҥ餬ʡ䥫Ѵ
*   USAGE:		EDR_HiraKanaS( char  *out, char *str )
*   SYNOPSIS:		char   *str (IN)   ʸ
*                       char   *out (OUT)  ʸ
*                       
*   DESCRIPTION:	
*	Ϳ줿ʸΤҤ餬ʬ򥫥ʤѴ
*       ֤
*       Ҥ餬ʤʸʳʸиȤޤǤѴʤ
*
*   RETURN:		ѴʸĹ
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int  EDR_HiraKanaS( unsigned char *out, unsigned char *str )
{
  int   len, i = 0 ;

  while( *str != '\0' ) {
    if ( ( *str & 0x80 ) == 0 ) {
      break ;
    }
    else {
      if ( *str == 0xa4 ) {
        *out = 0xa5 ; out++ ; str++ ;
        *out = *str ; out++ ; str++ ;
      }
      else {
        break ;
      }
      i += 2 ;
    }
  }
  *out = '\0' ;
  return  i ;
}


/****************************************************************
*   ʤ
*   USAGE:		EDR_KanaP( char  *str )
*   SYNOPSIS:		char   *str (IN)   ʸ
*                       
*   DESCRIPTION:	
*	Ϳ줿ʸ󤬥ʬΩäƤ뤫
*       Ĵ٤롣
*
*   RETURN:		1 : ƥ
*                       0 : ʤǤʤʸ¸ߤ
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int  EDR_KanaP( unsigned char *str )
{
  int   len, i = 0 ;

  while( *str != '\0' ) {
    if ( ( *str & 0x80 ) == 0 ) {
      return 0 ;
    }
    else {
      if ( *str != 0xa5 ) {
        return 0 ;
      }
      str += 2 ;
    }
  }
  return  i ;
}


/****************************************************************
*   ʸ󤫡
*   USAGE:		HEXvalP( char  *str )
*   SYNOPSIS:		char   *str (IN)   ʸ
*                       
*   DESCRIPTION:	
*	Ϳ줿ʸ󤬣ʸĴ٤롣
*
*   RETURN:		1 : ʸϣ
*                       0 : ʤǤʤʸ¸ߤ
*
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int  HEXvalP( unsigned char *str )
{

  if ( *str == '\0' )
    return -1 ;
  while( *str != '\0' ) {
    if ( ( *str & 0x80 ) != 0 ) {
      return -1 ;
    }
    if ( (*str >= '0' && *str <= '9') ||
         (*str >= 'A' && *str <= 'F') ||
         (*str >= 'a' && *str <= 'f') ) {
      str++ ;
      continue ;
    }
    return -1 ;
  }
  return  1 ;
}



/****************************************************************
*   ţģҼκǽΥեɤ쥳ɼ̻Ҥȥ쥳ֹ
*   ʬ򤹤롣
*   USAGE:		GetCode2Wid( char  *str, char *type, char *num)
*   SYNOPSIS:		char   *str  (IN)  ʸ
*                       char   *type (OUT) 쥳ɼ̻
*                       char   *num  (OUT) 쥳ֹ
*                       
*   DESCRIPTION:	
*	Ϳ줿ʸʣţģҼκǽΥեɡˤ
*       쥳ɼ̻Ҥȥ쥳ֹʬΤ줾ʸ
*       åȤ롣
*       ꥿󥳡ɤϥ쥳ֹ͡
*       ۾郎С쥳ɼ̻Ҥȥ쥳ֹ򶦤 "" ˤ롣
*
*   RETURN:		쥳ֹ
*                       
*   SEE ALSO:	      
*   ERRORS:
****************************************************************/
int  GetCode2Wid( char  *str, char *rtype, char *num)
{
  int  ret = 0 ;
  char c1 ;

  *rtype = *num = '\0' ;
  while( *str != '\0') {
    if ( *str >= '0' && *str <= '9' ) {
      break ;
    }
    c1 = *str ;
    *rtype = *str ; str++ ; rtype++ ;
  }

  *rtype = '\0' ;
  while( *str >= '0' && *str <= '9' ) {
    ret = ret * 10 + ( *str - '0' ) ;
    *num = *str ; str++ ; num++ ;
  }
  *num = '\0' ;
  
  if ( c1 == 'X' ) {
    ret *= ( -1 ) ;
  }
  return ret ;
}







int GetTblIX( char *val, char **tbl )
{
  int ii ;

  for ( ii = 0 ; tbl != NULL ; ii++,tbl++) {
    if ( *val == **tbl && strcmp(val, *tbl) == 0 ) {
      return ii ;
    }
  }
  return -1 ;
}


int GetCharTableIX( char *val, CharTable *tbl )
{
  int ii ;

  for ( ii =0 ; tbl->type1 != NULL ; ii++,tbl++) {
    if ( strcmp(val, tbl->type1) == 0 ) {
      return ii ;
    }
  }
  return -1 ;

}



int GramMemp0( char *val, CharTable *tbl )
{
  int ii ;

  for ( ii =0 ; tbl->type1 != NULL ; ii++,tbl++) {
    if ( strcmp(val, tbl->type1) == 0 ) {
      return ii ;
    }
  }
  return -1 ;
}

int GramMemp2( char *val, CharTable *tbl )
{
  int ii ;
  char ch2 = *(val+2) ;

  for ( ii =0 ; tbl->type1 != NULL ; ii++,tbl++) {
    if ( ch2 == *(tbl->type1+2) && strcmp(val,tbl->type1) == 0 ) {
      return ii ;
    }
  }
  return -1 ;
}

int GramMemp3( char *val, CharTable *tbl )
{
  int  ii ;
  char ch3 = *(val+3) ;

  for ( ii =0 ; tbl->type1 != NULL ; ii++,tbl++) {
    if ( ch3 == *(tbl->type1+3) && strcmp(val,tbl->type1) == 0 ) {
      return ii ;
    }
  }
  return -1 ;
}

