#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/




int Create_HIndex( char *FileName, CFile  *fpt )
{
  FILE *fp ;
  int    ret ;
  int    dct, wct, tb ;
  unsigned char   buff[1024] ; 
  char   *bptr[64] ;
  char   save[1024], work[500000] ;

    if ( ( fp = fopen( FileName, "r" )) == NULL ) {
         fprintf( stderr,"Cannot open work file[%s]\n", FileName ) ;
         return -1;
    }

    dct = 1 ;
    save[0] = '\0' ;
    wct = 0 ;
    while( fgets(buff,1024, fp ) != NULL ){
        tb = split1( '\t', buff, bptr ) ;
        if ( save[0] == '\0' || strcmp( bptr[0], save) == 0 ) {
            if ( wct >= 500000 ) {
              fprintf(stderr,"ERROR:work is too small! (word=[%s])\n",bptr[0]) ;
              continue ;
            }
            put4byte( atoi(bptr[1]) , &work[wct] ) ; /* 쥳ֹ */
            work[wct+4] = atoi(bptr[2]) ;            /* Ϣ */
            work[wct+5] = atoi(bptr[3]) ;            /* Ϣ */
            work[wct+6] = atoi(bptr[4]) ;            /* ʻ   */
            work[wct+7] = 0xff ;                 
            wct += 8 ;
            if ( save[0] == '\0' )
              strcpy( save, bptr[0] ) ;
            continue ;
        }
        if ( wct >= 10000 ) {
            fprintf(stderr,"WORD[%s] record_count=%d\n",save,wct/5) ;
        }
        ret = Put_IXT( fpt, save, strlen( save ), work, wct) ;
        if ( ret < 0 ) {
            fprintf(stderr,"ERROR(Put_IXT): word=[%s]\n",save) ;
        }
        dct++ ;
        strcpy( save, bptr[0] ) ;
        wct = 0 ;
        put4byte( atoi(bptr[1]) , &work[wct] ) ; /* 쥳ֹ */
        work[wct+4] = atoi(bptr[2]) ;            /* Ϣ */
        work[wct+5] = atoi(bptr[3]) ;            /* Ϣ */
        work[wct+6] = atoi(bptr[4]) ;            /* ʻ   */
        work[wct+7] = 0xff ;
        wct += 8 ;
    }
    ret = Put_IXT( fpt, save, strlen( save ), work, wct) ;
    if ( ret < 0 ) {
      fprintf(stderr,"ERROR(Put_IXT): word=[%s]\n",save) ;
    }
    fclose( fp ) ;
    return dct ;
}






int Create_CIndex( char *FileName, CFile  *fpt )
{
  FILE *fp ;
  int    ret ;
  int    dct, wct, tb ;
  unsigned char   buff[1024] ; 
  char   *bptr[64] ;
  char   save[1024], work[500000] ;

    if ( ( fp = fopen( FileName, "r" )) == NULL ) {
         fprintf( stderr,"Cannot open work file[%s]\n", FileName ) ;
         return -1;
    }

    dct = 1 ;
    save[0] = '\0' ;
    wct = 0 ;
    while( fgets(buff,1024, fp ) != NULL ){
        tb = split1( '\t', buff, bptr ) ;
        if ( save[0] == '\0' || strcmp( bptr[0], save) == 0 ) {
            if ( wct >= 500000 ) {
              fprintf(stderr,"ERROR:work is too small! (word=[%s])\n",bptr[0]) ;
              continue ;
            }
            put4byte( atoi(bptr[1]) , &work[wct] ) ; /* 쥳ֹ */
            wct += 4 ;
            if ( save[0] == '\0' )
              strcpy( save, bptr[0] ) ;
            continue ;
        }
        if ( wct >= 10000 ) {
            fprintf(stderr,"WORD[%s] record_count=%d\n",save,wct/5) ;
        }
        ret = Put_IXT( fpt, save, strlen( save ), work, wct) ;
        if ( ret < 0 ) {
            fprintf(stderr,"ERROR(Put_IXT): word=[%s]\n",save) ;
        }
        dct++ ;
        strcpy( save, bptr[0] ) ;
        wct = 0 ;
        put4byte( atoi(bptr[1]) , &work[wct] ) ; /* 쥳ֹ */
        wct += 4 ;
    }
    ret = Put_IXT( fpt, save, strlen( save ), work, wct) ;
    if ( ret < 0 ) {
      fprintf(stderr,"ERROR(Put_IXT): word=[%s]\n",save) ;
    }
    fclose( fp ) ;
    return dct ;
}






