#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/



/**********************************************************
*   оʸ伭쥳ֹ
*   USAGE:		GetRecIDFromHdwd(int flag, CFile  *ix, char *str, MorInfo *ary, int sz)
*   SYNOPSIS:		int       flag  (IN) ե饰
*                       CFile     *ix   (IN) ǥåե뼱̻
*                       char      *str  (IN) ʸ
*                       MorInfo   *ary  (OUT)ʸˡǼƬɥ쥹
*                       int       sz    (IN) ʸˡǼο(Ǽǿ)
*
*   DESCRIPTION:	
*       θե饰ˤä֤󤬰ۤʤ롣
*         ե饰ᣰʴץ⡼ɡ
*           Ȱפ쥳ɤ롣
*         ե饰ᣱץ⡼ɡ
*           ꤵ줿ʸƬƱʼɽޤޤ
*           ñ켭򸡺쥳ֹ롣
*       쥳ɤֹʸˡǼꥢΥ쥳ֹ楻å
*       ꥢ˥åȤ롣
*
*   RETURN:		쥳ɿ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int GetRecIDFromHdwd(int flag, CFile  *ix, char *key, MorphInfo *md, int size)
{
   char data[32768] ;
   int  len, klen, i ,j ;
   int  Rid, rct, ret ;
   int  hsz ;


   if ( ix == NULL )    /* Σģ¤ץ󤵤Ƥʤ */
     return 0 ;

   //printf("start GetRecIDFromHdwd : flag = %d\n",flag) ;
   klen = strlen(key) ;
   if ( flag == 0 ) {   /* פΤߵ */
     len = Get_IXT(ix, key, klen, data, 32768) ;
     if ( ( len / 4 )  >= size ) {
       fprintf( stderr ,"ERROR:Morph buffer overflow!\n") ;
       return 0 ;
     }
     for( i = j = 0 ; i < len  ; i += 8 ) {
       (md+j)->rno = get4byte( &data[i] ) ;
       (md+j)->lcon = data[i+4] ;   /* Ϣܾ              */
       (md+j)->rcon = data[i+5] ;   /* Ϣܾ              */
       (md+j)->pos  = data[i+6] ;   /* ʻ                    */
       (md+j)->leng = klen ;
       j++ ;
     }
     return j ;
   }

   /* ǲ Ƭʬ˴ޤޤ쥳ɤ򥲥åȡ */
   hsz = ix->hsize ;  /* ϥå奵 */
   rct = 0 ;
   if ( klen >= hsz ) {
     rct = Get_IXTS(ix, key, strlen(key), md, size) ;
     SortMorLeng(md,rct) ;
     hsz -= 2 ;
   }
   else {
     hsz = klen ;
   }
   //printf("(GetRecIDFromHdwd)key[%s](%d)\n",key,strlen(key)) ;
   //printf("(GetRecIDFromHdwd)hsz=%d\n",hsz) ;
   for(  ; hsz > 0 ; hsz -= 2) {
     if ( (len = Get_IXT(ix, key, hsz, data, 8192) ) <= 0 )
       continue ; 
     if ( ( rct + ( len / 4 ) ) >= size ) {
       fprintf( stderr ,"ERROR:Morph buffer overflow!\n") ;
       return rct ;
     }
     for( i = 0 ; i < len  ; i += 8 ) {
       (md+rct)->rno = get4byte( &data[i] ) ;
       (md+rct)->lcon = data[i+4] ;   /* Ϣܾ              */
       (md+rct)->rcon = data[i+5] ;   /* Ϣܾ              */
       (md+rct)->pos  = data[i+6] ;   /* ʻ                    */
       (md+rct)->leng = hsz ;
       rct++ ;
     }
   }
   return rct ;
}

/* ̤ϿģѸؿ */
int GetRecIDFromNEWW(int flag, CFile  *ix, char *key, MorphInfo *md, int size)
{
   char data[32768] ;
   int  len, klen, i ,j ;
   int  Rid, rct, ret ;
   int  hsz ;


   if ( ix == NULL )    /* Σģ¤ץ󤵤Ƥʤ */
     return 0 ;

   klen = strlen(key) ;
   if ( flag == 0 ) {   /* פΤߵ */
     len = Get_IXT(ix, key, klen, data, 32768) ;
     if ( ( len / 4 )  >= size ) {
       fprintf( stderr ,"ERROR:Morph buffer overflow!\n") ;
       return 0 ;
     }
     for( i = j = 0 ; i < len  ; i += 4 ) {
       (md+j)->rno = get4byte( &data[i] ) ;
       (md+j)->leng = klen ;
       j++ ;
     }
     return j ;
   }

   /* ǲ Ƭʬ˴ޤޤ쥳ɤ򥲥åȡ */
   hsz = ix->hsize ;  /* ϥå奵 */
   rct = 0 ;
   if ( klen > hsz ) {
     rct = Get_IXTS(ix, key, strlen(key), md, size) ;
     SortMorLeng(md,rct) ;
   }
   else {
     hsz = klen ;
   }
   // printf("(GetRecIDFromHdwd)[%s](%d)\n",key,strlen(key)) ;
   for(  ; hsz > 0 ; hsz -= 2) {
     if ( (len = Get_IXT(ix, key, hsz, data, 8192) ) <= 0 )
       continue ; 
     if ( ( rct + ( len / 4 ) ) >= size ) {
       fprintf( stderr ,"ERROR:Morph buffer overflow!\n") ;
       return rct ;
     }
     for( i = 0 ; i < len  ; i += 4 ) {
       (md+rct)->rno = get4byte( &data[i] ) ;
       (md+rct)->leng = hsz ;
       rct++ ;
     }
   }
   return rct ;
}


int SortMorLeng(MorphInfo *md, int rct)
{
  int ii, jj ;
  int worki ;

  for( ii = 0 ; ii < rct ;ii++ ) {
    for ( jj = ii+1 ; jj < rct ; jj++ ) {
      if ( (md+ii)->leng < (md+jj)->leng ) {
        worki = (md+ii)->leng ;  /* ǡĹ */
        (md+ii)->leng = (md+jj)->leng ;
        (md+jj)->leng = worki ;
        worki = (md+ii)->rno ;   /* 쥳ֹ */
        (md+ii)->rno = (md+jj)->rno ;
        (md+jj)->rno = worki ;
        worki = (md+ii)->lcon ;  /* Ϣ */
        (md+ii)->lcon = (md+jj)->lcon ;
        (md+jj)->lcon = worki ;
        worki = (md+ii)->rcon ;  /* Ϣ */
        (md+ii)->rcon = (md+jj)->rcon ;
        (md+jj)->rcon = worki ;
        worki = (md+ii)->pos ;   /* ʻ */
        (md+ii)->pos = (md+jj)->pos ;
        (md+jj)->pos = worki ;
      }
    }
  }
  return ii ;
}





/**********************************************************
*   ʸκǽʬפ쥳ֹ롣
*   USAGE:	        Get_IXTS(CFile  *fp, char *str, int ksz, MorphInfo *md, int size)
*   SYNOPSIS:           CFile  *fp    (IN)  ե뼱̻ҥݥ
*            		char      *str   (IN)  ʸ
*            		int       ksz    (IN)  ʸΥ
*                       MorphInfo *md    (IN)  ʸˡǼƬɥ쥹
*                       int       size   (IN)  ʸˡǼοʳǼǿ
*
*   DESCRIPTION:	
*       ؿϡ
*	ʸƬʬʲĹˤȥե˳Ǽ줿쥳
*     ɤθפ쥳ɤƸΥ쥳ɤ˳Ǽ
*     줿ͤ򤹤٤ƽϥǡꥢ˥åȤ롣
*       
*
*   RETURN:		Х塼ʥ쥳ɡĹ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  Get_IXTS(CFile  *fp, char *str, int ksz, MorphInfo *md, int size)
{
  unsigned char buff[BSIZE];       /* ɤ߹ߥХåե */
  char work[16384] ;
  int  hid ;
  int  bno, pno, nextp ;
  int  len ,i , rct = 0 ;
  int  klen ;

  //printf("str[%s] ksz=%d\n",str,ksz) ;
  hid = hash((unsigned char *)str,ksz,fp->flag,fp->hmax,fp->hsize) ;
  /* ǡγǼ֤η׻ */
  bno = ( hid / PTCOUNT ) * CBSIZE  ;
  //lseek( fp->fd, bno+CBSIZE , 0 ) ;
  //read( fp->fd, buff, CBSIZE ) ;
  fseek( fp->fd, bno+CBSIZE, 0 ) ;
  fread( buff, 1, CBSIZE, fp->fd ) ;

  pno = ( hid % PTCOUNT ) * 4;
  nextp = *(int *)&buff[pno] ;
  if ( nextp == NULL) {              
    return 0 ;
  }
  /*** TRACE COLLISION CHAIN ***/
  rct = 0 ;
  while( nextp != NULL  ) {
    //lseek( fp->fd, nextp , 0 ) ;
    //read( fp->fd, &buff[0], fp->rbsz ) ;
    fseek( fp->fd, nextp , 0 ) ;
    fread( &buff[0], 1, fp->rbsz, fp->fd ) ;

    if ( (klen = SubCompKey(fp, str, ksz, buff)) > 0 ) { /* ʸƬ */
      len = get_rec(fp,nextp,buff,work,16384 ) ;
      if ( (rct + ( len / 8 ) ) >= size ) {
        fprintf( stderr,"ERROR(Get_IXTS):Output buffer is too small!\n") ;
        return rct ;
      }
      for( i = 0 ; i < len  ; i += 8 ) {
        (md+rct)->rno = get4byte( &work[i] ) ;
        (md+rct)->lcon = work[i+4] ;   /* Ϣܾ              */
        (md+rct)->rcon = work[i+5] ;   /* Ϣܾ              */
        (md+rct)->pos  = work[i+6] ;   /* ʻ                    */
        (md+rct)->leng = klen ;
        rct++ ;
      }
    } 
    nextp = *(int *)&buff[0] ;
  }
  //printf("rct=%d\n",rct) ;
  return rct ;
}




/**********************************************************
*   ʸκǽʬפ쥳ɤ롣
*   USAGE:	        Get_IX_SubStr(CFile  *fp, char *str, int ksz, char *out, int size)
*   SYNOPSIS:           CFile  *fp    (IN)  ե뼱̻ҥݥ
*            		char      *key   (IN)  
*            		int       ksz    (IN)  Υ
*                       char      *val   (OUT) ϥǡåȥꥢ
*                       int       size   (IN)  ϥǡåȥꥢ
*
*   DESCRIPTION:	
*       ؿϡʸƬʬʲĹˤȥե˳Ǽ줿쥳
*     ɤθפ쥳ɤƸΥ쥳ɤ˳Ǽ
*     줿ͤ򤹤٤ƽϥǡꥢ˥åȤ롣
*
*       ϥǡ:
*
*        +-------------------------------------------------
*        | 쥳ֹ | Ϣ | Ϣ | ʻ | ʸ | ....
*        |     (4)      | (1)    | (1)    | (1)  | (1)    |
*        +---------------------------------------------------
*          쥳ֹ桧EDRΥ쥳ֹ
*          Ϣ      ɽκϢܾ
*          Ϣ      ɽαϢܾ
*          ʻ        ɽʻ
*          ʸ      ɽʸʸƬʸ
*
*       
*
*   RETURN:		Х塼ʥ쥳ɡĹ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  Get_IX_SubStr(CFile  *fp, char *str, int ksz, char *out, int size)
{
  unsigned char buff[BSIZE];       /* ɤ߹ߥХåե */
  char work[16384] ;
  int  hid, hsz ;
  int  bno, pno, nextp ;
  int  len ,i , off ;
  int  klen ;
  int  rno ;

  //printf("str[%s] ksz=%d\n",str,ksz) ;
  hid = hash((unsigned char *)str,ksz,fp->flag,fp->hmax,fp->hsize) ;
  /* ǡγǼ֤η׻ */
  bno = ( hid / PTCOUNT ) * CBSIZE  ;
  //lseek( fp->fd, bno+CBSIZE , 0 ) ;
  //read( fp->fd, buff, CBSIZE ) ;
  fseek( fp->fd, bno+CBSIZE, 0 ) ;
  fread( buff, 1, CBSIZE, fp->fd ) ;

  pno = ( hid % PTCOUNT ) * 4;
  nextp = *(int *)&buff[pno] ;
  if ( nextp == NULL) {              
    return 0 ;
  }
  off = 0 ;
  /*** TRACE COLLISION CHAIN ***/
  hsz = fp->hsize ;  /* ϥå奵 */
  if ( ksz >= hsz ) {
    while( nextp != NULL  ) {
      //lseek( fp->fd, nextp , 0 ) ;
      //read( fp->fd, &buff[0], fp->rbsz ) ;
      fseek( fp->fd, nextp , 0 ) ;
      fread( &buff[0], 1, fp->rbsz, fp->fd ) ;
      if ( (klen = SubCompKey(fp, str, ksz, buff)) > 0 ) { /* ʸƬ */
        len = get_rec(fp,nextp,buff,work,16384 ) ;
        if ( (off + len) >= size ) {
          fprintf( stderr,"ERROR(Get_Get_IX_SubStr):Output buffer is too small!\n") ;
          return off ;
        }
        for( i = 0 ; i < len  ; i += 8 ) {
          rno = get4byte( &work[i] ) ;
          put4byte( rno, out+off) ;
          *(out+off+4) = work[i+4] ;   /* Ϣܾ              */
          *(out+off+5) = work[i+5] ;   /* Ϣܾ              */
          *(out+off+6) = work[i+6] ;   /* ʻ                    */
          *(out+off+7) = klen ;
          off += 8 ;
        }
      } 
      nextp = *(int *)&buff[0] ;
    }
    hsz -= 2 ;
  }
  else {
    hsz = ksz ;
  }
  for(  ; hsz > 0 ; hsz -= 2) {
    if ( (len = Get_IXT(fp, str, hsz, work, 16384) ) <= 0 )
      continue ; 
    if ( ( off + len ) >= size ) {
      fprintf( stderr,"ERROR(Get_Get_IX_SubStr):Output buffer is too small!\n") ;
      return off ;
    }
    for( i = 0 ; i < len  ; i += 8 ) {
       rno = get4byte( &work[i] ) ;
      put4byte( rno, out+off) ;
      *(out+off+4) = work[i+4] ;   /* Ϣܾ              */
      *(out+off+5) = work[i+5] ;   /* Ϣܾ              */
      *(out+off+6) = work[i+6] ;   /* ʻ                    */
      *(out+off+7) = hsz ;
      off += 8 ;
    }
  }
  return off ;
}



/***********************************************************
*    쥳ֹǾ
*   USAGE:		SetMorFromRID(CFile  *dt, int id, MorInfo *mp)
*   SYNOPSIS:		CFile  *ix  ǥåե뼱̻
*                       int    id   쥳ɣɣ
*                       MorInfo *mp ǾǼꥢ
*
*   DESCRIPTION:	
*	ꤵ줿˰פǥ쥳ɤξ
*     깽¤Τ˥åȤ롣
*
*   RETURN:		
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
void SetMorFromRID(CFile *dt, int id, MorphInfo *mp)
{
  char data[8192], hyoki[512] ,hyoki2[512];
  int  ret ;
  int i , j , kk;
  char *cary[64] ;


  ret = Get_IXT(dt, (char *)&id, 4, data, 8192) ;

  //printf("START StartPts\n") ;
  //ret = StartPts( data, ret, cary) ;
  //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
  //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
  //*
  //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
  //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

  mp->lcon = data[4] ;      /* Ϣܾ              */
  mp->rcon = data[5] ;      /* Ϣܾ              */
  mp->pos  = data[6] ;      /* ʻ                    */
  i = *(int *)data ;
  j = get4byte( &data[7] ) ;
  mp->grmid  = j ;          /* ʸˡɣ                */

  /**** GET˥򥻥åȤ褦ѹ
  * ret = GetFirstWd( cary[6] , hyoki, 1024) ;
  * ret = EDR_StrStrip(hyoki2,hyoki) ;
  * ret = Conv2Big(hyoki, hyoki2) ;
  * if ( ret < 0 ) {
  *   ret = 0 ;
  * }
  * printf(" mp->leng=%d  ret = %d\n",mp->leng,ret) ;
  * mp->leng =  ret        ;  // ʸĹ               
  ***/
  mp->cid = SetCidValue( &data[11] ) ; /* ǰɣ       */

  //mp->flag = wdflagset_etc( cary[10] ) ; /* ե饰å   */
}






/***********************************************************
*    쥳ֹǾ
*   USAGE:		SetMorFromRID(CFile  *dt, int id, MorInfo *mp, char **cary, char data, int size)
*   SYNOPSIS:		CFile  *dt   ǥåե뼱̻
*                       int    id    쥳ɣɣ
*                       MorInfo *mp  ǾǼꥢ
*                       char   *data 쥳ɳǼꥢ
*                       int    size  쥳ɳǼꥢ
*
*   DESCRIPTION:	
*	ꤵ줿˰פǥ쥳ɤξ
*     깽¤Τ˥åȤ롣
*
*   RETURN:		顼  : 
*                       ｪλ:եɿ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  SetMorFromRID2(CFile *dt, int id, MorphInfo *mp, char **cary, char *data, int size)
{
  int  ret ;
  int i , j , kk;


  ret = Get_IXT(dt, (char *)&id, 4, data, size) ;
  if ( ret <= 0 ) {
    return ret ;
  }
  //printf("START StartPts\n") ;
  ret = StartPts( data, ret, cary) ;
  //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
  //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
  //*
  //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
  //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

  mp->lcon = data[4] ;      /* Ϣܾ              */
  mp->rcon = data[5] ;      /* Ϣܾ              */
  mp->pos  = data[6] ;      /* ʻ                    */
  i = *(int *)data ;
  j = get4byte( &data[7] ) ;
  mp->grmid  = j ;          /* ʸˡɣ                */
  mp->cid = SetCidValue( &data[11] ) ; /* ǰɣ       */

  //mp->flag = wdflagset_etc( cary[10] ) ; /* ե饰å   */
  return ret ;
}






/***********************************************************
*    쥳ֹ䳵ǰɣ
*   USAGE:		GetCidfromWREC(CFile *fpt, int rid, char *cid ) 
*   SYNOPSIS:		CFile  *ix  ƥե뼱̻
*                       int    rid  쥳ɣɣ
*                       char   *cid ǰɣĳǼꥢ
*
*   DESCRIPTION:	
*	ꤵ줿쥳ɤγǰɣĤФ롣
*
*   RETURN:		ʤ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
void GetCidfromWREC(CFile *fpt, int rid, char *cid )
{
  char data[8192] ;
  int  ret ;
  char *cary[64] ;

  if ( fpt == NULL )
    return ;
  ret = Get_IXT(fpt, (char *)&rid, 4, data, 8192) ;
  ret = StartPts( data, ret, cary) ;
  //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
  //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
  //*
  //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
  //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

  strcpy(cid, cary[5] ) ; /* ǰɣ       */
  return ;

}


/***********************************************************
*   줫ñ줫
*   USAGE:		SingleWord(CFile *fpt, int rid ) 
*   SYNOPSIS:		CFile  *ix  ƥե뼱̻
*                       int    rid  쥳ɣɣ
*
*   DESCRIPTION:	
*	ñ줫줫١ξϡ֤
*       ñξϣ֤
*
*   RETURN:		ñξϣ
*                       ξϡ
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int SingleWord(CFile *fpt, int rid )
{
  char data[8192] ;
  int  ret ;
  char *cp, *cary[64] ;

  if ( fpt == NULL )
    return 0 ;
  ret = Get_IXT(fpt, (char *)&rid, 4, data, 8192) ;
  ret = StartPts( data, ret, cary) ;
  //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
  //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
  //*
  //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
  //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

  cp = skip_ptr( '/', cary[6] ) ;
  if ( cp == NULL )
    return 1 ;
  return -1 ;
}


