/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"

void pushlog_DBUPD( char *keywd, char *com, char *rec) ;


/**********************************************************
*   롼ID/쥳IDʬ򤹤
*   USAGE:	        Get_Gid_Rid( char *gr , int *gid, int *rid )
*   SYNOPSIS:           char   *gr     (IN)  GRPnnnnnnn/JWDnnnnnnnʸ
*                       int    *gid   (OUT)  롼ID򥻥åȤ륨ꥢ
*                       int    *rid   (OUT)  쥳ID򥻥åȤ륨ꥢ
*
*   DESCRIPTION:	
*	롼ףɣġ쥳ɣɣĤηʸ󤫤ɣʬᡢ
*     Ǽꥢ˥åȤ롣
*
*   RETURN:		ｪλ: return 1
*                       ʾ彪λ: ͤʤ -1 
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int Get_Gid_Rid( char *gr , int *gid, int *rid )
{
  char *cp ;
  char dict[8], rnum[12] ;

  *gid = *rid = -1 ;
  if ( strncmp( gr, "GRP", 3) != 0 ) 
    return -1 ;
  *gid = atoi( gr + 3 ) ;
  cp = skip_ptr( '/', gr ) ;
  cp++ ;
  cp = skip_non_sp( cp ) ;
  *rid = GetCode2Wid( cp, dict, rnum) ;
  if ( dict[0] == '\0' && rnum[0] == '\0' ) 
    return -1 ;
  return 1 ;
}


/**********************************************************
*   롼IDοʬФ
*   USAGE:	        Get_GroupNum( char *gr )
*   SYNOPSIS:           char   *gr     (IN)  GRPnnnnnnnʸ
*
*   DESCRIPTION:	
*	롼ףɣĤηʸ󤫤ɣʬᡢ
*     ֤ͤ
*
*   RETURN:		ｪλ: 1ʾο
*                       ʾ彪λ: ͤʤ -1 
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int Get_GroupNum( CFile *g2r, char *gr )
{
  int ret ;

  if ( strncmp( gr, "GRP", 3) != 0 ) 
    return -1 ;
  if (  strcmp( gr+3, "new" ) == 0 ) {
    ret = Get_NewRecordNo( g2r ) ;
    return ret ;
  }
  ret = atoi( gr + 3 ) ;
  return ret ;
}



/**********************************************************
*   롼ףģ        ɲϿؿ
*   USAGE:	        Add_GRP_DB( CFile  *r2g , CFile *g2r, char *rec )
*   SYNOPSIS:           CFile  *r2g    (IN)  쥳=>롼ץե뼱̻ҥݥ
*                       CFile  *g2r    (IN)  롼=>쥳ɥե뼱̻ҥݥ
*                       char   *rec    (IN)  GRPnnnnnnn/JWDnnnnnnnη
*
*   DESCRIPTION:	
*	롼״ѣģ¤˿ɲäԤʤ
*       쥳ɣɣĤ֥쥳ɡ䥰롼פΣģ¡פ˴
*     ȥ꡼Ƥϥ顼ȤԤʤʤ
*
*   RETURN:		ｪλ return 1
*                       ʾ彪λ:˳쥳ɤϿƤ -1 
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int Add_GRP_DB( CFile  *r2g , CFile *g2r, char *rec )
{
  int  gid, rid ;
  int  ret ;
  int  work ;

  //printf("IN>[%s](%d)\n",rec,strlen(rec)) ;
  if ( Get_Gid_Rid( rec , &gid, &rid ) < 0 )
    return -1 ;

  ret = Get_IXT( r2g, (char *)&rid, 4, (char *)&work, 4) ;
  if ( ret != 0 ) {
    fprintf( stderr,"ERROR(Add_GRP_DB): RECORD-ID[%d] ϴ¸ߤƤ롪In GRP%07d\n",rid,work) ;
    return -1 ;
  }
  /* 쥳ֹ椫饰롼ףɣĤΣģ¤ */
  ret = Put_IXT( r2g, (char *)&rid, 4, (char *)&gid, 4) ;

  ret = Add_IXT_DATA2( g2r, (char *)&gid, 4, (char *)&rid, 4) ;

  pushlog_DBUPD("GDB","ADD", rec) ;
  return 1 ;
}




/**********************************************************
*   롼ףģ        ؿ
*   USAGE:	        Update_GRP_DB( CFile  *r2g , CFile *g2r, char *rec )
*   SYNOPSIS:           CFile  *r2g    (IN)  쥳=>롼ץե뼱̻ҥݥ
*                       CFile  *g2r    (IN)  롼=>쥳ɥե뼱̻ҥݥ
*                       char   *rec    (IN)  
*                                     GRPnnnnnnn/JWDnnnnnnn\tGRPmmmmmmmη
*
*
*   DESCRIPTION:	
*	롼״ѣģ¤Υ쥳ɤν°ѹԤʤ
*
*   RETURN:		ｪλ return 1
*                       ʾ彪λ return -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int Update_GRP_DB( CFile  *r2g , CFile *g2r, char *rec )
{
  int  gid, rid, ngid ;
  int  ret ;
  int  work ;
  char *cp ;

  //printf("IN>[%s](%d)\n",buff,strlen(buff)) ;
  cp = skip_ptr( '\t', rec ) ;
  cp++ ;
  cp = skip_non_sp( cp ) ;

  if ( Get_Gid_Rid( rec , &gid, &rid ) < 0 ) {
    fprintf( stderr,"ERROR(Update_GRP_DB): FromData[%s] ۾\n", rec) ;
    return -1 ;
  }
  ngid = Get_GroupNum( g2r, cp ) ;
  if ( ngid <= 0 ) {
    fprintf( stderr,"ERROR(Update_GRP_DB): ToData[%s] ۾\n", cp) ;
    return -1 ;
  }

  /* 쥳ֹ椫饰롼ףɣĤΣģ¤ */
  ret = Put_IXT( r2g, (char *)&rid, 4, (char *)&ngid, 4) ;

  ret = Rem_IXT_DATA( g2r, (char *)&gid, 4, (char *)&rid, 4) ;
 
  ret = Add_IXT_DATA2( g2r, (char *)&ngid, 4, (char *)&rid, 4) ;
  
  pushlog_DBUPD("GDB","MOV",rec) ;
  return 1 ;
}





/**********************************************************
*   롼ףģ        ؿ
*   USAGE:	        Delete_GRP_DB( CFile  *r2g , CFile *g2r, char *rec )
*   SYNOPSIS:           CFile  *r2g    (IN)  쥳=>롼ץե뼱̻ҥݥ
*                       CFile  *g2r    (IN)  롼=>쥳ɥե뼱̻ҥݥ
*                       char   *rec    (IN)  
*                                     GRPnnnnnnn/JWDnnnnnnnη
*
*   DESCRIPTION:	
*	롼״ѣģ¤˿ɲäԤʤ
*       쥳ɣɣĤ֥쥳ɡ䥰롼פΣģ¡פ˴
*     ȥ꡼Ƥϥ顼ȤԤʤʤ
*
*   RETURN:		ｪλ return 1
*                       ʾ彪λ return -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int Delete_GRP_DB( CFile  *r2g , CFile *g2r, char *rec )
{
  int  gid, rid ;
  int  ret ;

  //printf("IN>[%s](%d)\n",buff,strlen(buff)) ;
  if ( Get_Gid_Rid( rec , &gid, &rid ) < 0 ) {
    fprintf( stderr,"ERROR(Update_GRP_DB): FromData[%s] ۾\n", rec) ;
    return -1 ;
  }

  /* 쥳ֹ䥰롼ףɣĤγ쥳ɺ */
  ret = Rem_IXT( r2g, (char *)&rid, 4) ;

  ret = Rem_IXT_DATA( g2r, (char *)&gid, 4, (char *)&rid, 4) ;
 
  pushlog_DBUPD("GDB","DEL",rec) ;
  return 1 ;
}





void pushlog_DBUPD( char *keywd, char *com, char *rec)
{

  fprintf( stderr,"%s:\t%s\t%s\n",keywd,com,rec) ;
}






/****************************************************************
*   ϢСʥ롼ףɣĥꥹȤ
*   USAGE:		GetGidsfromCid( char *cid, int  *gids, int sz)
*   SYNOPSIS:  		char  *cid     (IN)   ǰ̻
*          		int   *gids    (OUT)  롼ףɣĳǼꥢ
*                       int    sz      (IN)   롼ףɣĳǼꥢΥ
*
*   DESCRIPTION:	
*	쥳ɤγǰ̻ҤȤꡢγǰĥ쥳ID롣
*       Υ쥳ID顢롼ףɣĤƥåȤ롣
*
*       ǰ̻ҥǥåե򻲾Ȥ롣
*
*   RETURN:		ｪλ:   롼ףɣĤǿ
*                       ۾ｪλ:   -1
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int GetGidsfromCid( char *cid, int  *gids, int sz)
{
  char  buff[8192], buff2[8192] ;
  int   ii, id, jj, kk, ll, ret = 0 ;
  int   len, gid ;

  if ( CID2WdRID == NULL )
    return 0 ;
  if ( RID2GrpID == NULL )
    return 0 ;
  len = Get_IXT(CID2WdRID, cid, strlen(cid), buff, 8192) ;
  if ( len == 0 )
    return 0 ;

  for( ii = 0 ; ii < len  ; ii += 4 ) {
    id = get4byte( &buff[ii] ) ;
    ll = Get_IXT( RID2GrpID , (char *)&id, 4, buff2, 8192 ) ;
    if ( ll == 0 ) {
      printf("RID[%d]=>Gid ??????\n", id) ;
      continue ;
    }
    gid = get4byte( buff2 ) ;
    for ( jj = 0 ; jj < ret ;  jj++ ) {
      if ( gid == *(gids+jj) )
        break ;
    }
    if ( jj == ret ) {
      *(gids+jj) = gid ;
      ret++ ;
    } 
    if ( ret >= sz ) {
      fprintf(stderr,"ERROR(GetGidsfromCid):Output buffer is too small!\n") ;
      break ;
    }
  }     
  return ret ;
}




/****************************************************************
*   Ʊ쥰롼ףɣĤΥꥹȤ
*   USAGE:		SelectGids( char **fd, int  *gids, int sz)
*   SYNOPSIS:           char   **fd    (IN)      쥳
*                       int   *gids    (IN/OUT)  롼ףɣĤΥꥹ
*                       int    sz      (IN)      ǿ
*
*   DESCRIPTION:	
*	쥳ɤǼȤʤ륰롼ףɣĤ롣
*
*   RETURN:		ｪλ:   Ʊ쥰롼פο
*                                   ĤʤУ
*                       ۾ｪλ:   -1
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int SelectGids( char **fd, int  *gids, int sz)
{
  char  buff[8192], buff2[8192] ;
  int   ii, id, jj, kk, ll, ret = 0 ;
  int   len ;
  char *cary[64] ;
  char  yomi1[1024], yomi2[1024] ;


  if ( WdRID2Val == NULL )
    return 0 ;
  if ( GrpID2RID == NULL )
    return 0 ;

  for ( jj = 0 ; jj < sz ;  jj++ ) {
    //printf("*(gids+%d)=%d\n", jj, *(gids+jj)) ;
    len = Get_IXT( GrpID2RID, (char *)(gids+jj) , 4, buff, 8192) ;
    if ( len == 0 ) {
      printf("GID[%d]=>Rid ??????\n", id) ;
      continue ;
    }
    for( ii = 0 ; ii < len  ; ii += 4 ) {
      id = get4byte( &buff[ii] ) ; 
      //printf("RID[%d]\n", id) ;
      ll = Get_IXT( WdRID2Val, (char *)&id, 4, buff2, 8192) ;
      if ( ll == 0 ) {
        printf("RID[%d]=>Record ??????\n", id) ;
        continue ;
      }
      kk = StartPts( buff2, ll, cary) ;
      //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
      //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
      //*
      //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
      //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |
      
      /* ʻγǧ  */
      if ( *fd[3] != *cary[3] ) {
        continue ;
      }
      strcpy(yomi1, fd[7]) ;
      SyukutaiYomi(yomi1) ;
      strcpy(yomi2, cary[7]) ;
      SyukutaiYomi(yomi2) ;
      if ( strcmp( yomi1, yomi2 ) == 0 ) {
        *(gids+ret) = *(gids+jj) ;
        ret++ ;
        break ;
      }
      GetSyuushi( fd, yomi1, 1024 ) ;
      GetSyuushi( cary, yomi2, 1024 ) ;
      if ( strcmp( yomi1, yomi2 ) == 0 ) {
        *(gids+ret) = *(gids+jj) ;
        ret++ ;
        break ;
      }
    } 
  }     
  return ret ;
}




/****************************************************************
*   Ʊ쥰롼ףɣĤΥꥹȤ
*   USAGE:		ChkSameRecord( char **fd, int *gids, int ct)
*   SYNOPSIS:           char   **fd    (IN)      쥳
*                       int   *gids    (IN/OUT)  롼ףɣĤΥꥹ
*                       int    sz      (IN)      ǿ
*
*   DESCRIPTION:	
*	쥳ɤƱΥ쥳ɤ뤫ǧ롣
*
*   RETURN:		:   Ʊ쥳ɤ
*                     :   Ʊ쥳ɤʤ
*
*   SEE ALSO:	        
*   ERRORS:
****************************************************************/
int ChkSameRecord( char **fd, int *gids, int ct)
{
  char  buff[8192], buff2[8192] ;
  int   ii, id, jj, kk, ll, ret ;
  int   len, curid ;
  char *cary[64] ;
  char  yomi1[1024], yomi2[1024] ;


  if ( WdRID2Val == NULL )
    return 0 ;
  if ( GrpID2RID == NULL )
    return 0 ;

  curid = get4byte( fd[0] ) ;
  for ( jj = 0 ; jj < ct ;  jj++ ) {
    len = Get_IXT( GrpID2RID, (char *)(gids+jj) , 4, buff, 8192) ;
    if ( len == 0 ) {
      printf("GID[%d]=>Rid ??????\n", id) ;
      continue ;
    }

    for( ii = 0 ; ii < len  ; ii += 4 ) {
      id = get4byte( &buff[ii] ) ;
      if ( curid == id )
        continue ;
      ll = Get_IXT( WdRID2Val, (char *)&id, 4, buff2, 8192) ;
      if ( ll == 0 ) {
        printf("RID[%d]=>Record ??????\n", id) ;
        continue ;
      }
      ret = StartPts( buff2, ll, cary) ;
      //        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
      //        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
      //
      //           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
      //           |  (n)           | (n)    | (n)    | (n)    | (n)        |

      /* ʻγǧ  */
      if ( *fd[3] != *cary[3] ) {
        //printf("DIFF 1  fd[3]=%d   cary[3]=%d\n",*fd[3], *cary[3]) ;
        continue ;
      }
      /* ʸˡγǧ  */
      
      if ( *(fd[4] + 3) != *(cary[4] + 3) || *(fd[4] + 2) != *(cary[4] + 2) ||
           *(fd[4] + 1) != *(cary[4] + 1) || *fd[4] != *cary[4]  ) {
        //printf("DIFF 2 *fd[4]=%d, *cary[4]=%d\n", *fd[4], *cary[4]) ;
        continue ;
      }
      /* ǰ̻Ҥγǧ  */
      if ( strcmp( fd[5], cary[5] ) != 0 ) {
        //printf("DIFF 3\n") ;
        continue ;
      }
      /* ѲϢФγǧ */
      if ( strcmp(fd[6], cary[6] ) != 0 ) {
        //printf("DIFF 4\n") ;
        continue ;
      }
      /* ɤߤγǧ */
      if ( strcmp(fd[7], cary[7] ) != 0 ) {
        //printf("DIFF 5\n") ;
        continue ;
      }
      /* Ϣܤγǧ */
      if ( *fd[2] != *cary[2] ) {
        //printf("DIFF 6\n") ;
        continue ;
      }
      /* Ϣܤγǧ */
      if ( *fd[1] != *cary[1] ) {
        //printf("DIFF 7\n") ;
        continue ;
      }
      /* Ʊ쥳ɤꡪ */
      fprintf( stderr,"ERROR(CHKSameRec):ʲϿμϡƱƤΤΤ¸ߤޤ\n") ;
      PrEDRJWDsub( stderr, 'B', fd[0], fd) ;
      fprintf( stderr ," ===> RECORD_ID[ JWD%07d ]\n",id) ;
      fprintf( stderr ,"\n") ;
      return 1 ;
    } 
  }     
  return -1 ;


}


