/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"

CharTable  E_lcon[]= {
	{ "ELB1",	 "	Blank" },
	{ "ELN1",	 "ƬҲ̾	Noun beginning with a consonant sound" },
	{ "ELN2",	 "Ƭ첻̾	Noun beginning with a vowel sound" },
	{ "ELP1",	 "̾	Pronoun" },
	{ "ELP2",	 "Ƶ̾	Reflexive pronoun" },
	{ "ELA1",	 "ƬҲƻ	Adjective beginning with a consonant sound" },
	{ "ELA3",	 "Ƭ첻ƻ	Adjective beginning with a vowel sound" },
	{ "ELD1",	 "ƬҲ	Adverb beginning with a consonant sound" },
	{ "ELD3",	 "Ƭ첻	Adverb beginning with a vowel sound" },
	{ "ELV1",	 "ƬҲư	Verb beginning with a consonant sound" },
	{ "ELV2",	 "Ƭ첻ư	Verb beginning with a vowel sound" },
	{ "ELT1",	 "ƬҲ괧ֲĸ	Determiner beginning with consonant sound that can follow indefinite article" },
	{ "ELT2",	 "Ƭ첻괧ֲĸ	Determiner beginning with vowel sound that can follow indefinite article" },
	{ "ELW1",	 "괧ܸ	Words that cannot be preceded by indefinite article" },
	{ "ESN1",	 "̾ s	Noun ending s" },
	{ "ESN2",	 "̾ es	Noun ending es" },
	{ "ESN3",	 "̾ y/ies	Noun endings y/ies" },
	{ "ESN4",	 "̾ fe/ves	Noun endings fe/ves" },
	{ "ESN5",	 "̾ f/ves	Noun endings f/ves" },
	{ "ESN6",	 "̾ s/es	Noun endings s/es" },
	{ "ESN7",	 "̾ 's	Plural noun form ending 's" },
	{ "ESN8",	 "̾ s/'s	Plural noun form endings s/ 's" },
	{ "ESF1",	 "̾ñ³ 's	Singular form noun possessive ending 's" },
	{ "ESF2",	 "̾üñ '	Special singular form noun possessive ending  '" },
	{ "ESF3",	 "̾ʣ³ '	Plural form noun possessive ending  '  " },
	{ "ESF8",	 "̾üʣ 's	Special plural form noun possessive ending  's" },
	{ "ESF4",	 ";̾ñʸܥݥȥե '	Contracted verb form that follows 1st person pronoun (singular nominative)" },
	{ "ESF5",	 ";̾ʣ̾ʸܥݥȥե'	Contracted verb form that follows 2nd person pronoun and plural pronoun (nominative)" },
	{ "ESF6",	 ";̾ñʸܥݥȥե '	Contracted verb form that follows 3rd person pronoun (singular nominative)" },
	{ "ESF7",	 "ưܥݥȥե '	Contracted  negation 'n't' " },
	{ "ESV1",	 "ư s/d/ing	Verb endings s/d/ing" },
	{ "ESV2",	 "ư s/ed/ing	Verb endings s/ed/ing" },
	{ "ESV3",	 "ư es/ed/ing	Verb endings es/ed/ing" },
	{ "ESV4",	 "ư e/es/ed/ing	Verb endings e/es/ed/ing" },
	{ "ESV5",	 "ư y/ies/ied/ying	Verb endings y/ies/ied/ying" },
	{ "ESV6",	 "ư ie/ies/ied/ying	Verb endings ie/ies/ied/ying" },
	{ "ESV7",	 "ư s/ing	Verb endings s/ing" },
	{ "ESV8",	 "ư es/ing	Verb endings es/ing" },
	{ "ESV9",	 "ư e/es/ing	Verb endings e/es/ing" },
	{ "ESVA",	 "ư y/ies/ying	Verb endings y/ies/ying" },
	{ "ESVB",	 "ư s	Verb ending s" },
	{ "ESPB",	 "ư s/bed/bing	Verb endings s/bed/bing" },
	{ "ESPD",	 "ư s/ded/ding	Verb endings s/ded/ding" },
	{ "ESPF",	 "ư s/fed/fing	Verb endings s/fed/fing" },
	{ "ESPG",	 "ư s/ged/ging	Verb endings s/ged/ging" },
	{ "ESPK",	 "ư s/ked/king	Verb endings s/ked/king" },
	{ "ESPL",	 "ư s/led/ling	Verb endings s/led/ling" },
	{ "ESPM",	 "ư s/med/ming	Verb endings s/med/ming" },
	{ "ESPN",	 "ư s/ned/ning	Verb endings s/ned/ning" },
	{ "ESPP",	 "ư s/ped/ping	Verb endings s/ped/ping" },
	{ "ESPR",	 "ư s/red/ring	Verb endings s/red/ring" },
	{ "ESPT",	 "ư s/ted/ting	Verb endings s/ted/ting" },
	{ "ESPV",	 "ư s/ved/ving	Verb endings s/ved/ving" },
	{ "ESA1",	 "ƻ er/est	Adjective endings er/est" },
	{ "ESA2",	 "ƻ r/st	Adjective endings r/st" },
	{ "ESA3",	 "ƻ y/ier/iest	Adjective endings y/ier/iest" },
	{ "ESAB",	 "ƻ ber/best	Adjective endings ber/best" },
	{ "ESAD",	 "ƻ der/dest	Adjective endings der/dest" },
	{ "ESAF",	 "ƻ fer/fest	Adjective endings fer/fest" },
	{ "ESAG",	 "ƻ ger/gest	Adjective endings ger/gest" },
	{ "ESAK",	 "ƻ ker/kest	Adjective endings ker/kest" },
	{ "ESAL",	 "ƻ ler/lest	Adjective endings ler/lest" },
	{ "ESAM",	 "ƻ mer/mest	Adjective endings mer/mest" },
	{ "ESAN",	 "ƻ ner/nest	Adjective endings ner/nest" },
	{ "ESAP",	 "ƻ per/pest	Adjective endings per/pest" },
	{ "ESAR",	 "ƻ rer/rest	Adjective endings rer/rest" },
	{ "ESAS",	 "ƻ ser/sest	Adjective endings ser/sest" },
	{ "ESAT",	 "ƻ ter/test	Adjective endings ter/test" },
	{ "ESAV",	 "ƻ ver/vest	Adjective endings ver/vest" },
	{ "ESAZ",	 "ƻ zer/zest	Adjective endings zer/zest" },
	{ "ESD1",	 " er/est	Adverb endings er/est" },
	{ "ESD2",	 " r/st	Adverb endings r/st" },
	{ "ESD3",	 " y/ier/iest	Adverb endings y/ier/iest" },
	{ "ESDB",	 " ber/best	Adverb endings ber/best" },
	{ "ESDD",	 " der/dest	Adverb endings der/dest" },
	{ "ESDF",	 " fer/fest	Adverb endings fer/fest" },
	{ "ESDG",	 " ger/gest	Adverb endings ger/gest" },
	{ "ESDK",	 " ker/kest	Adverb endings ker/kest" },
	{ "ESDL",	 " ler/lest	Adverb endings ler/lest" },
	{ "ESDM",	 " mer/mest	Adverb endings mer/mest" },
	{ "ESDN",	 " ner/nest	Adverb endings ner/nest" },
	{ "ESDP",	 " per/pest	Adverb endings per/pest" },
	{ "ESDR",	 " rer/rest	Adverb endings rer/rest" },
	{ "ESDS",	 " ser/sest	Adverb endings ser/sest" },
	{ "ESDT",	 " ter/test	Adverb endings ter/test" },
	{ "ESDV",	 " ver/vest	Adverb endings ver/vest" },
	{ "ESDZ",	 " zer/zest	Adverb ndings zer/zest" },
	{ "ELS1",	 "Ѿʸ	Uncapitalized Roman letter" },
	{ "ELS2",	 "ʸ	Capitalized Roman letter" },
	{ "ELS3",	 "άޡ	Abbreviation mark" },
	{ "ELS4",	 "Ϣ뵭	Connection symbol" },
	{ "ELS5",	 "	Decimal point" },
	{ "ELS6",	 "ʸ	SI-prefix" },
	{ "ELS7",	 "ñ	Unit of measure" },
	{ "ELS8",	 "	Numeral" },
	{ "ELS9",	 "ڤ국	Punctuation mark of separation" },
	{ "ELSA",	 "ԥꥪ	Fullstop punctuation mark" },
	{ "ELSB",	 "	Special symbol" },
	{ "ELSC",	 "޿	Roman numeral" },
        { NULL,  NULL }} ;



