/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"

CharTable  E_wform[]= {
	{ "ECN1",	 "̾Ѳʬʸ s	Noun (inflection pattern s)" },
	{ "ECN2",	 "̾Ѳʬʸ es	Noun (inflection pattern es)" },
	{ "ECN3",	 "̾Ѳʬʸ y/ies	Noun (inflection pattern y)" },
	{ "ECN4",	 "̾Ѳʬʸ fe/ves	Noun (inflection pattern fe)" },
	{ "ECN5",	 "̾Ѳʬʸ f/vesve	Noun (inflection pattern f)" },
	{ "ECN6",	 "̾Ѳʬʸ s/es	Noun (inflection pattern s&es)" },
	{ "ECN7",	 "̾Ѳʬʸ 's	Noun (inflection pattern 's)" },
	{ "ECN8",	 "̾Ѳʬʸ s/'s	Noun (inflection pattern s&'s)" },
	{ "ECV1",	 "s-d ѲưѲʬ	Verb (inflection pattern s-d)" },
	{ "ECV2",	 "s-ed ѲưѲʬ	Verb (inflection pattern s-ed)" },
	{ "ECV3",	 "es-ed ѲưѲʬ	Verb (inflection pattern es-ed)" },
	{ "ECV4",	 "e ѲưѲʬ	Verb (inflection pattern e)" },
	{ "ECV5",	 "y ѲưѲʬ	Verb (inflection pattern y)" },
	{ "ECV6",	 "ie ѲưѲʬ	Verb (inflection pattern ie)" },
	{ "EPVB",	 "s-bb ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVD",	 "s-dd ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVF",	 "s-ff ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVG",	 "s-gg ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVK",	 "s-kk ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVL",	 "s-ll ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVM",	 "s-mm ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVN",	 "s-nn ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVP",	 "s-pp ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVR",	 "s-rr ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVT",	 "s-t ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "EPVV",	 "s-vv ѲưѲʬ	Verb (inflection pattern s-C+ed)" },
	{ "ECV7",	 "s-ing ѲưѲʬ	Verb (inflection pattern s-ing)" },
	{ "ECV8",	 "es-ing ѲưѲʬ	Verb (inflection pattern es-ing)" },
	{ "ECV9",	 "e-ing ѲưѲʬ	Verb (inflection pattern e-ing)" },
	{ "ECVA",	 "y-ing ѲưѲʬ	Verb (inflection pattern y-ying)" },
	{ "ECVB",	 "s-Ե§ѲưѲʬ	Verb (inflection pattern s-irreg.)" },
	{ "ECA1",	 "er Ѳƻ	Adjective (inflection pattern er)" },
	{ "ECA2",	 "r Ѳƻ	Adjective (inflection pattern r)" },
	{ "ECA3",	 "ier Ѳƻ	Adjective (inflection pattern ier)" },
	{ "ECAB",	 "bb Ѳƻ	Adjective (inflection pattern C+er)" },
	{ "ECAD",	 "dd Ѳƻ	Adjective (inflection pattern C+er)" },
	{ "ECAF",	 "ff Ѳƻ	Adjective (inflection pattern C+er)" },
	{ "ECAG",	 "gg Ѳƻ	Adjective (inflection pattern C+er)" },
	{ "ECAK",	 "kk Ѳƻ	Adjective (inflection pattern C+er)" },
	{ "ECAL",	 "ll Ѳƻ	Adjective (inflection pattern C+er)" },
	{ "ECAM",	 "mm Ѳƻ	Adjective (inflection pattern C+er)" },
	{ "ECAN",	 "nn Ѳƻ	Adjective (inflection pattern C+er)" },
	{ "ECAP",	 "pp Ѳƻ	Adjective (inflection pattern C+er)" },
	{ "ECAR",	 "rr Ѳƻ	Adjective (inflection pattern C+er)" },
	{ "ECAS",	 "ss Ѳƻ	Adjective (inflection pattern C+er)" },
	{ "ECAT",	 "t Ѳƻ	Adjective (inflection pattern C+er)" },
	{ "ECAV",	 "vv Ѳƻ	Adjective (inflection pattern C+er)" },
	{ "ECAZ",	 "zz Ѳƻ	Adjective (inflection pattern C+er)" },
	{ "ECD1",	 "er Ѳ	Adverb (inflection pattern er)" },
	{ "ECD2",	 "r Ѳ	Adverb (inflection pattern r)" },
	{ "ECD3",	 "ier Ѳ	Adverb (inflection pattern ier)" },
	{ "ECDB",	 "bb Ѳ	Adverb (inflection pattern C+er)" },
	{ "ECDD",	 "dd Ѳ	Adverb (inflection pattern C+er)" },
	{ "ECDF",	 "ff Ѳ	Adverb (inflection pattern C+er)" },
	{ "ECDG",	 "gg Ѳ	Adverb (inflection pattern C+er)" },
	{ "ECDK",	 "kk Ѳ	Adverb (inflection pattern C+er)" },
	{ "ECDL",	 "ll Ѳ	Adverb (inflection pattern C+er)" },
	{ "ECDM",	 "mm Ѳ	Adverb (inflection pattern C+er)" },
	{ "ECDN",	 "nn Ѳ	Adverb (inflection pattern C+er)" },
	{ "ECDP",	 "pp Ѳ	Adverb (inflection pattern C+er)" },
	{ "ECDR",	 "rr Ѳ	Adverb (inflection pattern C+er)" },
	{ "ECDS",	 "ss Ѳ	Adverb (inflection pattern C+er)" },
	{ "ECDT",	 "t Ѳ	Adverb (inflection pattern C+er)" },
	{ "ECDV",	 "vv Ѳ	Adverb (inflection pattern C+er)" },
	{ "ECDZ",	 "zz Ѳ	Adverb (inflection pattern C+er)" },

	{ "EPC1",	 "	Subjective" },
	{ "EPC2",	 "ͭ	Determinative possesive " },
	{ "EPC3",	 "Ū	Objective" },
	{ "EPC4",	 "Ωͭ	Independent possessive " },
	{ "EPC5",	 "Ƶ	Reflexive pronoun" },
	{ "EPP1SG",	 ";ñ	1st person singular" },
	{ "EPP1PL",	 ";ʣ	1st person plural" },
	{ "EPP2SG",	 ";ñ	2nd person singular" },
	{ "EPP2PL",	 ";ʣ	2nd person plural" },
	{ "EPP3SG",	 ";ñ	3rd person singular" },
	{ "EPP3PL",	 ";ʣ	3rd person plural" },

	{ "EVSTM",	 "Ѳʬ	Uninflected part" },
	{ "EVB",	 "	Infinitive" },
	{ "EVS",	 ";ñ߷	3rd person singular present tense" },
	{ "EVED",	 "	Past tense" },
	{ "EVEN",	 "ʬ	Past participle" },
	{ "EVING",	 "ʬ졦ư̾	Present participle, gerund form" },
	{ "ENSTM",	 "Ѳʬ	Uninflected part" },
	{ "ENSG",	 "ñ	Singular form" },
	{ "ENPL",	 "ʣ	Plural form" },
	{ "ENHM",	 "ñʣƱ	Common form for singular and plural" },
	{ "ENPOS",	 "ͭ	Possessive case" },
	{ "EASTM",	 "Ѳʬ	Uninflected part" },
	{ "EAPOS",	 "	Positive degree" },
	{ "EACMP",	 "ӵ	Comparative degree" },
	{ "EASUP",	 "Ǿ	Superlative degree" },
	{ "EDSTM",	 "Ѳʬ	Uninflected part" },
	{ "EDPOS",	 "	Positive degree" },
	{ "EDCMP",	 "ӵ	Comparative degree" },
	{ "EDSUP",	 "Ǿ	Superlative degree" },



	{ "EVIRG",	 "Ե§Ѳ	Irregular" },
	{ "EDIRG",	 "Ե§Ѳ	Irregular" },
	{ "ENIRG",	 "Ե§Ѳ	Irregular" },
	{ "EAIRG",	 "Ե§Ѳ	Irregular" },
        { NULL,  NULL }} ;



