/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"

CharTable  J_lcon[]= {
	{ "*",	 "*	*" },
	{ "JLN1",	 "̾	Common nouns" },
	{ "JLN2",	 "ͭ̾	Proper nouns" },
	{ "JLN3",	 "̾	Verbal nouns (`Suru'-verb stem) " },
	{ "JLN4",	 "̾	Pronouns " },
	{ "JLN5",	 "̾	Formal nouns" },
	{ "JLN6",	 "	Numerals" },
	{ "JLN7",	 "	Temporal nouns" },
	{ "JLN8",	 "	Symbols" },
	{ "JLV1",	 "ư	Verbs" },
	{ "JLA1",	 "ƻ	Adjectives (`I'-adjectives)" },
	{ "JLM1",	 "ư	Adjectival nouns (`Na'-adjectives)" },
	{ "JLD2",	 "	Adverbs" },
	{ "JLR1",	 "Ϣλ	Adnouns" },
	{ "JLC1",	 "ʸиǽ³	Conjunctions  that can appear in the middle of a sentence" },
	{ "JLC3",	 "ʸƬ³	Conjunctions that can appear at the head of a sentence " },
	{ "JLT1",	 "ư	Exclamations " },
	{ "JSF1",	 "̾	Nominal suffixes" },
	/**/{ "XXXXX",	 "̾	Verbal noun suffixes" },
	{ "JSF4",	 "ͭ̾	Proper noun suffixes" },
	{ "JSF5",	 ";̾	Personal noun suffixes" },
	{ "JSF7",	 "ñֽ̡	Units and counter  suffixes" },
	{ "JSF8",	 "	Temporal noun suffixes" },
	{ "JSF9",	 "ñ	Units" },
	{ "JSFA",	 "ֽ졦ӣƬ	Counter suffixes and SI-prefixes " },
	{ "JLS1",	 "	Commas" },
	{ "JLS2",	 "	Periods" },
	/**/{ "XXXXX",	 "θܽ	Particles 1" },
	/**/{ "XXXXX",	 "ưϢѷܽ	Particles 2" },
	/**/{ "XXXXX",	 "ưϢѷءظܽ	Particles 3" },
	/**/{ "XXXXX",	 "ư콪߷ܽ	Particles 4 " },
	/**/{ "XXXXX",	 "θư̿ܽ	Particles 5 " },
	/**/{ "XXXXX",	 "̾졦ưϢ߷ܽ	Particles 7 " },
	/**/{ "XXXXX",	 "̾졦ư콪߷ܽ	Particles 8 " },
	/**/{ "XXXXX",	 "ƻϢѷưϢѷǸܽ	Particles 9" },
	/**/{ "XXXXX",	 "ƻϢѷưϢѷ˸ܽ	Particles A" },
	/**/{ "XXXXX",	 "ưϢѷ¥ءƻϢѷܽ	Particles B" },
	/**/{ "XXXXX",	 "ư줿	Particles W" },
	/**/{ "XXXXX",	 "Ѹ߷ܽ	Particles D" },
	/**/{ "XXXXX",	 "ưϢηƻϢηưϢηʸܽ	Particles E" },
	/**/{ "XXXXX",	 "Ѹܽ	Particles F" },
	/**/{ "XXXXX",	 "ѸܡΩԲĽ	Particles G" },
	/**/{ "XXXXX",	 "θưϢѷƻ콪߷ư촴ܽ	Particles H" },
	/**/{ "XXXXX",	 "θ	Particles I" },
	/**/{ "XXXXX",	 "θư콪Ϣηƻ콪ϢηưϢηܽ	Particles J " },
	/**/{ "XXXXX",	 "θư콪Ϣηƻ콪Ϣηư촴ܽ	Particles K" },
	/**/{ "XXXXX",	 "̾졦ʸܽ	Particles L" },
	/**/{ "XXXXX",	 "ʸνꡦʸڤܸܽ	Particles M" },
	/**/{ "XXXXX",	 "ʽܽ	Particles N" },
	/**/{ "XXXXX",	 "ܽ	Particle  that follows adverbs" },
	/**/{ "XXXXX",	 "ܽ	Particle that follows adverbs " },
	/**/{ "XXXXX",	 "ܽ	Particle  that follows adverbs" },
	{ "JLW1",	 "̤̤ư촴ܽư	Aux. verb" },
	{ "JLW2",	 "̤̤ư촴ܽư	Aux. verb" },
	{ "JLW3",	 "̤̤̤̤ܽư	Aux.verb" },
	{ "JLW4",	 "ư̤ƻϢѷưϢѷܽư	Aux. verbʤ" },
	{ "JLW5",	 "ư췿̤ܽư	Aux. verb " },
	{ "JLW6",	 "̤ܽư	Aux. verb" },
	{ "JLW7",	 "ʰʳ̤ܽư	Aux. verb 褦" },
	{ "JLW8",	 "ư콪߷ưޤ߷̤ϢηʳϢηܽư	Aux. verb ޤ" },
	{ "JLW9",	 "ư췿Ϣѷܽư	Aux. verb ޤ" },
	{ "JLWA",	 "ư줿	Aux. verb  " },
	{ "JLWB",	 "ư(λ)	Aux. verb  marking perfect tense" },
	{ "JLWC",	 "ֽư줽	Aux. verb  to convey manner" },
	{ "JLWD",	 "ư줿	Aux. verb " },
	{ "JLWE",	 "ʹư줽	Aux. verb  for reported speech " },
	{ "JLWF",	 "ư餷	Aux. verb 餷" },
	{ "JLWG",	 "ư()	Aux. verb  marking the speaker's conclusion" },
	{ "JLWH",	 "ư()	Aux. verb " },
	{ "JLWI",	 "ưǤ	Aux. verb Ǥ" },
	{ "JLWJ",	 "ưǤ礦	Aux. verb Ǥ礦" },
	{ "JLWK",	 "ư褦	Aux. verb 褦" },
	{ "JSVK",	 "ԸʳѸ	K-consonant `go-dan' conjugation endings" },
	{ "JSVG",	 "ԸʳѸ	G-consonant `go-dan' conjugation endings" },
	{ "JSVS",	 "ԸʳѸ	S-consonant `go-dan' conjugation endings " },
	{ "JSVT",	 "ԸʳѸ	T-consonant `go-dan' conjugation endings" },
	{ "JSVN",	 "ʹԸʳѸ	N-consonant `go-dan' conjugation endings" },
	{ "JSVB",	 "йԸʳѸ	B-consonant `go-dan' conjugation endings" },
	{ "JSVM",	 "޹ԸʳѸ	M-consonant `go-dan' conjugation endings" },
	{ "JSVR",	 "ԸʳѸ	R-consonant `go-dan' conjugation endings" },
	{ "JSVW",	 "ԸʳѸ	W-consonant `go-dan'  conjugation endings" },
	{ "JSV1",	 "ưѸ	`Ichi-dan' conjugation endings" },
	{ "JSV2",	 "ѳʳѸ	S-consonant irregular conjugation endings" },
	{ "JSV3",	 "ѳʳѸ	Z-consonant  irregular conjugation endings" },
	{ "JSV4",	 "ѳʳѸ	K-consonant  irregular conjugation endings " },
	{ "JSV5",	 "Ѹ	`Iku' conjugation endings" },
	{ "JSV6",	 "Ѹ	`Aru' conjugation  endings " },
	{ "JSV7",	 "åѸ	`Ossharu' conjugation endings" },
	{ "JSA0",	 "ƻ촴ܸ	Words that follow adjective stems" },
	{ "JSA1",	 "ƻѸ	Adjective  conjugation endings 1 " },
	{ "JSA2",	 "ʽ߷ƻ촴ܸ	Adjective  conjugation endings 2 " },
	{ "JSA3",	 "ưʥѸ	Aux.verb ʤ conjugation endings" },
	{ "JSM0",	 "ư촴ܸ	Words that follow  adjectival noun stems" },
	{ "JSM1",	 "ѷưѸ	Adjectival noun  d-consonant conjugation endings" },
	{ "JSM2",	 "ѷưѸϢѡ֤ˡפʤ	Adjectival noun d-consonant  conjugation endings 2" },
	{ "JSM3",	 "ѷưѸϢΡ֤Ρפ	Adjectival noun d-consonant conjugation endings 3" },
	{ "JSM4",	 "ѷưѸϢѡ֤ˡפʤϢΡ֤Ρפ	Adjectival noun d-consonant conjugation endings 4" },
	{ "JSMA",	 "ѷưѸϢΡ֤ΡפꡦϢΡ֤ʡפʤ	Adjectival noun d-consonant conjugation endings A" },
	{ "JSM5",	 "ľϢνǽѷưѸϢΡ֤ʡפʤ	Adjectival noun d-consonant conjugation endings 5" },
	{ "JSM7",	 "ȳѷưѸ	Adjectival noun `taruto' conjugation endings 7" },
	{ "JSM8",	 "ȳѷưѸϢΡ֤Ρפʤ	Adjectival noun `taruto' conjugation endings 8" },
        /***** NEW *****/
 	{ "JSF6",	 "̾	Verbal noun suffixes" },
 	{ "JL00H",	 "Ω줫" },
 	{ "JL00E",	 "줫" },
 	{ "JL00F",	 "줫" },
 	{ "JL01S",	 "³줫" },
 	{ "JL02E",	 "줫" },
 	{ "JL03K",	 "줫" },
 	{ "JL04C",	 "ʽ줫" },
 	{ "JL04H",	 "Ω줫" },
 	{ "JL04S",	 "³줫" },
 	{ "JL04F",	 "줫" },
 	{ "JL05C",	 "ʽ줬" },
  	{ "JL05S",	 "³줬" },
  	{ "JL05E",	 "줬" },
  	{ "JL06K",	 "줭" },
  	{ "JL07F",	 "줯餤" },
  	{ "JL08S",	 "³줱" },
  	{ "JL08E",	 "줱" },
  	{ "JL09S",	 "³줱ɤ" },
  	{ "JL09E",	 "줱ɤ" },
  	{ "JL10K",	 "줳" },
  	{ "JL11I",	 "줵" },
  	{ "JL12F",	 "줵" },
  	{ "JL13S",	 "³줷" },
  	{ "JL14K",	 "줷" },
  	{ "JL15F",	 "줷" },
  	{ "JL16F",	 "줹" },
  	{ "JL17F",	 "줺" },
  	{ "JL18E",	 "줼" },
  	{ "JL19E",	 "줾" },
  	{ "JL20S",	 "³줿ä" },
  	{ "JL21F",	 "줿" },
  	{ "JL21E",	 "줿" },
  	{ "JL22H",	 "Ω줿" },
  	{ "JL23F",	 "" },
  	{ "JL24H",	 "Ω" },
  	{ "JL24F",	 "" },
  	{ "JL25S",	 "³Ĥ" },
  	{ "JL26S",	 "³" },
  	{ "JL27K",	 "Ƥ" },
  	{ "JL28S",	 "³Ƥ" },
  	{ "JL29C",	 "ʽ" },
  	{ "JL29S",	 "³" },
  	{ "JL30C",	 "ʽ" },
  	{ "JL30H",	 "Ω" },
  	{ "JL30S",	 "³" },
  	{ "JL31H",	 "ΩȤ" },
  	{ "JL31F",	 "Ȥ" },
  	{ "JL32S",	 "³Ȥ" },
  	{ "JL33S",	 "³Ȥ" },
  	{ "JL34S",	 "³Ȥ" },
  	{ "JL34F",	 "Ȥ" },
  	{ "JL35K",	 "Ȥ" },
  	{ "JL36E",	 "Ȥ" },
  	{ "JL36S",	 "³Ȥ" },
  	{ "JL37S",	 "³" },
  	{ "JL38F",	 "ɤ" },
  	{ "JL39S",	 "³ɤ" },
  	{ "JL40S",	 "³ɤ" },
  	{ "JL41E",	 "" },
  	{ "JL41I",	 "" },
  	{ "JL42S",	 "³ʤ" },
  	{ "JL43H",	 "Ωʤ" },
  	{ "JL43F",	 "ʤ" },
  	{ "JL44S",	 "³ʤ" },
  	{ "JL45H",	 "Ωʤ" },
  	{ "JL45S",	 "³ʤ" },
  	{ "JL45F",	 "ʤ" },
  	{ "JL46H",	 "Ωʤ" },
  	{ "JL46F",	 "ʤ" },
  	{ "JL47F",	 "ʤ" },
  	{ "JL48C",	 "ʽ" },
  	{ "JL48S",	 "³" },
  	{ "JL49C",	 "ʽˤ" },
  	{ "JL50E",	 "" },
  	{ "JL50I",	 "" },
  	{ "JL51N",	 "ʽ" },
  	{ "JL51J",	 "ν" },
  	{ "JL51E",	 "" },
  	{ "JL52S",	 "³Τ" },
  	{ "JL53S",	 "³Τ" },
  	{ "JL53E",	 "Τ" },
  	{ "JL54F",	 "Τ" },
  	{ "JL55K",	 "" },
  	{ "JL56S",	 "³" },
  	{ "JL57H",	 "ΩФ" },
  	{ "JL57F",	 "Ф" },
  	{ "JL58C",	 "ʽ" },
  	{ "JL59F",	 "ۤ" },
  	{ "JL60F",	 "ۤ" },
  	{ "JL61C",	 "ʽޤ" },
  	{ "JL61H",	 "Ωޤ" },
  	{ "JL62K",	 "" },
  	{ "JL63E",	 "" },
  	{ "JL64S",	 "³Τ" },
  	{ "JL65S",	 "³Τ椨" },
  	{ "JL66H",	 "Ω" },
  	{ "JL66S",	 "³" },
  	{ "JL66F",	 "" },
  	{ "JL66E",	 "" },
  	{ "JL66I",	 "" },
  	{ "JL67S",	 "³䤤ʤ" },
  	{ "JL68H",	 "Ω" },
  	{ "JL68F",	 "" },
  	{ "JL68E",	 "" },
  	{ "JL69S",	 "³椨" },
  	{ "JL70E",	 "" },
  	{ "JL71C",	 "ʽ" },
  	{ "JL72E",	 "" },
  	{ "JL73C",	 "ʽ" },
  	{ "JL74J",	 "ν" },
  	{ "JL75S",	 "³줯" },
  	{ "JL76S",	 "³줵" },
  	{ "JL77S",	 "³줸" },
  	{ "JL78S",	 "³ä" },
  	{ "JL79H",	 "Ω" },
  	{ "JL80K",	 "" },
  	{ "JL80E",	 "" },
  	{ "JL81C",	 "ʽä" },
  	{ "JL82F",	 "äƤ" },
  	{ "JL82E",	 "äƤ" },
  	{ "JL83K",	 "Ǥ" },
  	{ "JL84F",	 "Ǥ" },
  	{ "JL84S",	 "³Ǥ" },
  	{ "JL85K",	 "ʤǤ" },
  	{ "JL86E",	 "Τ" },
  	{ "JL87F",	 "etc." },
 	{ "JLWL",	 "ư콪߷˸ܤư٤" },
 	{ "JLWM",	 "θư̿˸ܤ줬" },
 	{ "JLWN",	 "̾졦ưϢ߷˸ܤѸǤ" },
 	{ "JLWP",	 "ƻϢѷ֤סưϢѷ֤ˡפ˸ܤѸ" },
 	{ "JSFV",	 "̾졦ư콪߷˸ܤ" },
 	{ "JLNA",	 "ϢλˤäƽŪˡ" },
        /***** NEW *****/
        { NULL,  NULL }} ;


