/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"

CharTable  J_rcon[]= {
	{ "*",	 "*	*" },
	{ "JRN1",	 "̾	Common nouns" },
	{ "JRN2",	 "ͭ̾	Proper nouns" },
	{ "JRN3",	 ";̾	Personal nouns" },
	{ "JRN4",	 "̾	Verbal nouns" },
	{ "JRN5",	 ";̾	Personal pronouns" },
	{ "JRN6",	 "ؼ̾	Demonstrative pronouns" },
	{ "JRN7",	 "̾	Formal nouns" },
	{ "JRN8",	 "	Numerals" },
	{ "JRN9",	 "	Temporal nouns" },
	{ "JRNA",	 "	Symbols" },
	{ "JRNB",	 "ñֽ̡	Units" },
	{ "JRND",	 "	Base ten unit place figures in the decimal system" },
	{ "JRNE",	 "ֽ	Counter suffixes" },
	{ "JRNF",	 "ӣƬ	SI-prefixes" },
	{ "JRVK",	 "Ըư촴	K-consonant `go-dan' conjugation verb stems" },
	{ "JRVG",	 "Ըư촴	G-consonant `go-dan' conjugation verb stems" },
	{ "JRVS",	 "Ըư촴	S-consonant `go-dan' conjugation verb stem" },
	{ "JRVT",	 "Ըư촴	T-consonant `go-dan' conjugation verb stems" },
	{ "JRVN",	 "ʹԸư촴	N-consonant `go-dan' conjugation verb stems" },
	{ "JRVB",	 "йԸư촴	B-consonant `go-dan' conjugation verb stems" },
	{ "JRVM",	 "޹Ըư촴	M-consonant `go-dan' conjugation verb stems" },
	{ "JRVR",	 "Ըư촴	R-consonant `go-dan' conjugation verb stems" },
	{ "JRVW",	 "Ըư촴	W-consonant `go-dan' conjugation verb stems" },
	{ "JRV1",	 "ư촴	`Ichi-dan' conjugation verb stems " },
	{ "JRV2",	 "ư촴	S-consonant irregular conjugation verb stems" },
	{ "JRV3",	 "ư촴	Z-consonant irregular conjugation verb stems" },
	{ "JRV4",	 "ư촴	K-consonant irregular conjugation verb stems" },
	{ "JRV5",	 "Ѹ촴	`Iku' conjugation verb stems" },
	{ "JRV6",	 "Ѹ촴	`Aru' conjugation verb stems" },
	{ "JRV7",	 "åѸ촴	`Ossharu ' conjugation verb stems" },
	{ "JRA1",	 "ƻ촴	Adjective stems" },
	{ "JRA2",	 "촴ʤǽƻ촴	Adjective stems endingin the `i'-vowel" },
	{ "JRA3",	 "ưʥ촴	Stems of the Aux. verbʤ" },
	{ "JRM1",	 "ѷư촴	D-consonant conjugation adjectival noun stems 1" },
	{ "JRM2",	 "ѷư촴Ϣѡ֤ˡפʤ	D-consonant conjugation adjectival noun stems 2 " },
	{ "JRM3",	 "ѷư촴ϢΡ֤Ρפ	D-consonant conjugation  adjectival noun stems 3" },
	{ "JRM4",	 "ѷư촴Ϣѡ֤ˡפʤϢΡ֤Ρפ	D-consonant conjugation  adjectival noun stems 4" },
	{ "JRMA",	 "ѷư촴ϢΡ֤ΡפꡦϢΡ֤ʡפʤ	D-consonant conjugation  adjectival noun stems A" },
	{ "JRM5",	 "ľϢνǽѷư촴ϢΡ֤ʡפʤ	D-consonant conjugation  adjectival noun stems 5" },
	{ "JRM9",	 "ľϢνǽѷư촴θܡ֤ʡײǽ	D-consonant conjugation adjectival noun stems 9" },
	{ "JRM7",	 "ȳ	`Taruto' conjugation adjectival noun stems" },
	{ "JRM8",	 "ȳѷư촴ϢΡ֤Ρפʤ	`Taruto' conjugation adjectival noun stems 8 ending in " },
	{ "JRD2",	 "Բ	Adverbs that do not precede any particles" },
	{ "JRD3",	 "ȸ	Adverbs that can precede the particle " },
	{ "JRD4",	 "˸	Adverbs that can precede the particle " },
	{ "JRD5",	 "ȡ˸	Adverbs that can precede the particle  or " },
	{ "JRD6",	 "θ	Adverbs that can precede the particle " },
	{ "JRD7",	 "Ρȸ	Adverbs that can precede the particle  or " },
	{ "JRD8",	 "Ρ	Adverbs that can precede the particle  or " },
	{ "JRD9",	 "Ρȡ˸	Adverbs that can precede the particle , , or " },
	{ "JRDA",	 "ư	Adverbs that can precede the auxiliary verb  " },
	{ "JRDB",	 "ưȸ	Adverbs that can precede the auxiliary verb  or the particle  " },
	{ "JRDC",	 "ư˸	Adverbs that can precede the auxiliary verb  or the particle " },
	{ "JRDD",	 "ưȡ˸	Adverbs that can precede the auxiliary verb  or the particle  or  " },
	{ "JRDE",	 "ưθ	Adverbs that can precede the auxiliary verb  or the particle " },
	{ "JRDF",	 "ưΡȸ	Adverbs that can precede the auxiliary verb  or the particle  or " },
	{ "JRDG",	 "ưΡ˸	Adverbs that can precede the auxiliary verb  or the particle  or " },
	{ "JRDH",	 "ưΡȡ˸	Adverbs that can precede the auxiliary verb  or the particle , , or   " },
	{ "JRR1",	 "Ϣλ	Adnouns" },
	{ "JRC1",	 "³	Conjunctions 1" },
	{ "JRC2",	 "ܤˤ³	Conjunctions 2" },
	{ "JRT1",	 "ư	Exclamations" },
	{ "JRP1",	 "θƬ	Prefixes preceding nominals" },
	{ "JRP2",	 "ưƬ	Prefixes preceding verbs" },
	{ "JRP3",	 "ֽ	Counter prefixes" },
	{ "JRP4",	 "ƻ졦ưƬ	Prefixes preceding both adjectives and adjectival nouns" },
	{ "JRP5",	 "ƻƬ	Prefixes preceding adjectives" },
	{ "JRP6",	 "ưƬ	Prefixes preceding ajectival nouns" },
	{ "JRP7",	 "̾Ƭ	Prefixes preceding verbal nouns" },
	{ "JRS1",	 "	Commas" },
	{ "JRS2",	 "	Periods" },
	/**/{ "XXXXX",	 "Բĳʽ	Particles 1 (case marker)" },
	/**/{ "XXXXX",	 "ܳʽ	Particles 2 (case marker)" },
	/**/{ "XXXXX",	 "ʽ	Particles 3 (case marker)  " },
	/**/{ "XXXXX",	 "ν	Particles 4 (nominalizer)" },
	/**/{ "XXXXX",	 "Ω	Particles 5 (coordinator)" },
	/**/{ "XXXXX",	 "³	Particles 6 (conjunction)" },
	/**/{ "XXXXX",	 "	Particles 7 (indicatestheme)" },
	/**/{ "XXXXX",	 "	Particles 8 (adverbial)" },
	/**/{ "XXXXX",	 "	Particles 9 (ends a sentence)" },
	/**/{ "XXXXX",	 "	Particles A (interjection) " },
	{ "JEM1",	 "̤̤	Subjunctive form  of s-consonant irregular conjugation verbs and  of z-consonant irregular conjugation verbs" },
	{ "JEM2",	 "̤	Subjunctive form  of s-consonant irregular conjugation verbs" },
	{ "JEM3",	 "̤	Subjunctive form  of s-consonant irregular conjugation verbs" },
	{ "JEM4",	 "̤	Subjunctive form of k-consonant irregular conjugation verbs" },
	{ "JEM5",	 "̤	Subjunctive form of `go-dan' conjugation verbs" },
	{ "JEM6",	 "̤	Subjunctive form preceding " },
	{ "JEM7",	 "̤	`Aru' conjugation subjunctive form " },
	{ "JEM8",	 "̤	Subjunctive form  of z-consonant irregular conjugation verbs" },
	{ "JED1",	 "ѡѡϢѷ	Infinitive form of s-, z-, and k-consonant irregular conjugation verbs" },
	{ "JED2",	 "Ϣѷ	Infinitive form of `go-dan' conjugation  verbs" },
	{ "JED3",	 "ƤܤưϢѲط	Euphonic infinitive form of `go-dan' conjugation verbs preceding the particle " },
	{ "JED4",	 "ǤܤưϢѲط	Euphonic infinitive form of `go-dan' conjugation verbs preceding the particle " },
	{ "JED5",	 "ƻϢѷ	Infinitive form  of adjectives" },
	{ "JED6",	 "ưϢѷ	Infinitive form  of adjectival nouns" },
	{ "JED7",	 "ƻ졦ưϢѷ	Infinitive form of adjectives and adjectival nouns" },
	{ "JED8",	 "ưϢѷ	Infinitive form  of adjectival nouns" },
	{ "JED9",	 "üϢѷ	Infinitive form of the irregular conjugation auxiliary verb " },
	{ "JEDA",	 "ưʥüϢѲط	Euphonic infinitive form of the irregular  conjugation  auxiliary verb ʤ" },
	{ "JEE1",	 "ư콪Ϣη	Predicative and adnominal forms of verbs" },
	{ "JEE2",	 "ƻ콪ߡϢηư콪ߡϢη	Predicative and adnominal forms of adjectives, and the auxiliary verbs  and " },
	{ "JEE3",	 "ư콪߷	Predicative form of adjectival nouns" },
	{ "JEE4",	 "ü콪(Ϣη)褦ޤ	Predicative (and adnominal) form of the irregular conjugation auxiliary verbs,, 褦, and ޤ" },
	{ "JEE5",	 "ü콪(Ϣη)Ǥ	Predicative (and adnominal) form the irregular conjugation auxiliary verb, Ǥ" },
	{ "JEE6",	 "ü콪ߡϢηޤ	Predicative and adnominal forms of the irregular conjugation auxiliary verb,ޤ" },
	{ "JEA1",	 "ưϢη	Adnominal form  of  adjectival nouns" },
	{ "JEA2",	 "ưϢη(Τ)	Adnominal form  (Τ) of adjectival nouns " },
	{ "JEC1",	 "	Conditional form" },
	{ "JEC2",	 "Ω	Independent conditional form" },
	{ "JEI1",	 "̿	Imperative form" },
	{ "JEI2",	 "֤פǽ̿	Imperative form ending in " },
        /***** NEW *****/
 	{ "JR00H",	 "Ω줫" },
 	{ "JR00E",	 "줫" },
 	{ "JR00F",	 "줫" },
 	{ "JR01S",	 "³줫" },
 	{ "JR02E",	 "줫" },
 	{ "JR03K",	 "줫" },
 	{ "JR04C",	 "ʽ줫" },
 	{ "JR04H",	 "Ω줫" },
 	{ "JR04S",	 "³줫" },
 	{ "JR04F",	 "줫" },
 	{ "JR05C",	 "ʽ줬" },
 	{ "JR05S",	 "³줬" },
 	{ "JR05E",	 "줬" },
 	{ "JR06K",	 "줭" },
 	{ "JR07F",	 "줯餤" },
 	{ "JR08S",	 "³줱" },
 	{ "JR08E",	 "줱" },
 	{ "JR09S",	 "³줱ɤ" },
 	{ "JR09E",	 "줱ɤ" },
 	{ "JR10K",	 "줳" },
 	{ "JR11I",	 "줵" },
 	{ "JR12F",	 "줵" },
 	{ "JR13S",	 "³줷" },
 	{ "JR14K",	 "줷" },
 	{ "JR15F",	 "줷" },
 	{ "JR16F",	 "줹" },
 	{ "JR17F",	 "줺" },
 	{ "JR18E",	 "줼" },
 	{ "JR19E",	 "줾" },
 	{ "JR20S",	 "³줿ä" },
 	{ "JR21F",	 "줿" },
 	{ "JR21E",	 "줿" },
 	{ "JR22H",	 "Ω줿" },
 	{ "JR23F",	 "" },
 	{ "JR24H",	 "Ω" },
 	{ "JR24F",	 "" },
 	{ "JR25S",	 "³Ĥ" },
 	{ "JR26S",	 "³" },
 	{ "JR27K",	 "Ƥ" },
 	{ "JR28S",	 "³Ƥ" },
 	{ "JR29C",	 "ʽ" },
 	{ "JR29S",	 "³" },
 	{ "JR30C",	 "ʽ" },
 	{ "JR30H",	 "Ω" },
 	{ "JR30S",	 "³" },
 	{ "JR31H",	 "ΩȤ" },
 	{ "JR31F",	 "Ȥ" },
 	{ "JR32S",	 "³Ȥ" },
 	{ "JR33S",	 "³Ȥ" },
 	{ "JR34S",	 "³Ȥ" },
 	{ "JR34F",	 "Ȥ" },
 	{ "JR35K",	 "Ȥ" },
 	{ "JR36E",	 "Ȥ" },
 	{ "JR36S",	 "³Ȥ" },
 	{ "JR37S",	 "³" },
 	{ "JR38F",	 "ɤ" },
 	{ "JR39S",	 "³ɤ" },
 	{ "JR40S",	 "³ɤ" },
 	{ "JR41E",	 "" },
 	{ "JR41I",	 "" },
 	{ "JR42S",	 "³ʤ" },
 	{ "JR43H",	 "Ωʤ" },
 	{ "JR43F",	 "ʤ" },
 	{ "JR44S",	 "³ʤ" },
 	{ "JR45H",	 "Ωʤ" },
 	{ "JR45S",	 "³ʤ" },
 	{ "JR45F",	 "ʤ" },
 	{ "JR46H",	 "Ωʤ" },
 	{ "JR46F",	 "ʤ" },
 	{ "JR47F",	 "ʤ" },
 	{ "JR48C",	 "ʽ" },
 	{ "JR48S",	 "³" },
 	{ "JR49C",	 "ʽˤ" },
 	{ "JR50E",	 "" },
 	{ "JR50I",	 "" },
 	{ "JR51N",	 "ʽ" },
 	{ "JR51J",	 "ν" },
 	{ "JR51E",	 "" },
 	{ "JR52S",	 "³Τ" },
 	{ "JR53S",	 "³Τ" },
 	{ "JR53E",	 "Τ" },
 	{ "JR54F",	 "Τ" },
 	{ "JR55K",	 "" },
 	{ "JR56S",	 "³" },
 	{ "JR57H",	 "ΩФ" },
 	{ "JR57F",	 "Ф" },
 	{ "JR58C",	 "ʽ" },
 	{ "JR59F",	 "ۤ" },
 	{ "JR60F",	 "ۤ" },
 	{ "JR61C",	 "ʽޤ" },
 	{ "JR61H",	 "Ωޤ" },
 	{ "JR62K",	 "" },
 	{ "JR63E",	 "" },
 	{ "JR64S",	 "³Τ" },
 	{ "JR65S",	 "³Τ椨" },
 	{ "JR66H",	 "Ω" },
 	{ "JR66S",	 "³" },
 	{ "JR66F",	 "" },
 	{ "JR66E",	 "" },
 	{ "JR66I",	 "" },
 	{ "JR67S",	 "³䤤ʤ" },
 	{ "JR68H",	 "Ω" },
 	{ "JR68F",	 "" },
 	{ "JR68E",	 "" },
 	{ "JR69S",	 "³椨" },
 	{ "JR70E",	 "" },
 	{ "JR71C",	 "ʽ" },
 	{ "JR72E",	 "" },
 	{ "JR73C",	 "ʽ" },
 	{ "JR74J",	 "ν" },
 	{ "JR75S",	 "³줯" },
 	{ "JR76S",	 "³줵" },
 	{ "JR77S",	 "³줸" },
 	{ "JR78S",	 "³ä" },
 	{ "JR79H",	 "Ω" },
 	{ "JR80K",	 "" },
 	{ "JR80E",	 "" },
 	{ "JR81C",	 "ʽä" },
 	{ "JR82F",	 "äƤ" },
 	{ "JR82E",	 "äƤ" },
 	{ "JR83K",	 "Ǥ" },
 	{ "JR84F",	 "Ǥ" },
 	{ "JR84S",	 "³Ǥ" },
 	{ "JR85K",	 "ʤǤ" },
 	{ "JR86E",	 "Τ" },
 	{ "JR87F",	 "etc." },
 	{ "JRW3",	 "ưϢη롦" },
 	{ "JRW4",	 "ν֤ΡפΤ褦θư줶" },
 	{ "JRW9",	 "ʸư줴Ȥ" },
 	{ "JRNG",	 "" },
 	{ "JRP8",	 "̾Ƭ" },
        /***** NEW *****/
        { NULL,  NULL }} ;


