/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include "fconst.h"
#include "ftemp.h"
#include "fextern.h"
#include "aconst.h"

static int   WORK_POS ;     /* ʻ쥳ꥨꥢ */
static FILE *WORK_FILE ;    /* ե̾ꥨꥢ */

/**************************************************************
 ѼԤȲäʤ顢쥳ɤɽ
**************************************************************/
int  CurRecIDs[32768] ;  /*** ȥ쥳ֹǼꥢ ***/
int  CurRecCt = 0;       /*** ȥ쥳ɿ             ***/
int  BakRecIDs[32768] ;  /*** Υȥ쥳ֹǼꥢ ***/
int  BakRecCt = 0;       /*** Υȥ쥳ɿ             ***/

int  ENV_FLAGS ;         /*** оݡʴܸ졿Ѹˤλ ***/


/*** Template ***/
void  HelpInput() ;
void SetAccessDict( char *cp ) ;
void SetPrintMode( char *cp ) ;
void print_CurRecord( CFile *bjwd, CFile *tjwd, char *recid, char *file ) ;
void print_CurRecords( CFile *bjwd, CFile *tjwd, char *file ) ;
int  Select_by_cat( CFile *bjwd, CFile *tjwd, char *cat ) ;
int  Select_by_lr( CFile *bjwd, CFile *tjwd, char *cat ) ;
int  Access_by_date( CFile *log, char *date ) ;


void
main(int argc,  char **argv)
{
      int   vflag = 2 ,ret1, ret2 ;
      int   ii, jj , com;
      char  work[1024], work1[1024], work2[1024] ;
      CFile *lpt2  ;
      char  *wdenv ;
      char  file[512] ;
      MorphInfo  morph[4096] ;
      char  *ary[64] ;

      /*
         ưĶ
      */

      InitEnv() ;                /* ɽ⡼ɤʤɴĶ */
      DB_FileOpen() ;
      InitEdrTbl() ;             /* EDRʸˡ°ơ֥ɤ߹ */


      WORD_DB_Open() ;
      TWORD_DB_Open() ;

      lpt2 = NULL ;              /* Ѹѥեݥ󥿡 */

      if ( argc > 1 )  {
        ret1 = Conv2Big(work1, *(argv+1)) ;
        ret1 = BackUpCurentRec() ;
        CurRecCt = 0 ;
        ret1 = AccessEDRIDX( Hdwd2WdRID, work1 ) ;
        ret2 = AccessEDRIDX( THdwd2WdRID, work1 ) ;
        if ( argc > 2 ) {
           ret1 = BackUpCurentRec() ;
           CurRecCt = 0 ;
           ret1 = AccessEDRIDX( CID2WdRID, *(argv+2) ) ;
           ret1 = AccessEDRIDX( TCID2WdRID, *(argv+2) ) ;
           ret2 = IntersectEDRIDX() ;
	 }
         ENV_FLAGS &= ~( OUT_V | OUT_FV ); 
         ENV_FLAGS |= OUT_EDR ;
         print_CurRecords( WdRID2Val, TWdRID2Val, ary[1] ) ;

         DB_FileClose() ;

         if ( WdRID2Val != NULL ) Close_IXT( WdRID2Val ) ;
         if ( Yomi2WdRID != NULL ) Close_IXT( Yomi2WdRID ) ;
         if ( Hdwd2WdRID != NULL ) Close_IXT( Hdwd2WdRID ) ;
         if ( CID2WdRID != NULL ) Close_IXT( CID2WdRID ) ;
         if ( TWdRID2Val != NULL ) Close_IXT( TWdRID2Val ) ;
         if ( TYomi2WdRID != NULL ) Close_IXT( TYomi2WdRID ) ;
         if ( THdwd2WdRID != NULL ) Close_IXT( THdwd2WdRID ) ;
         if ( TCID2WdRID != NULL ) Close_IXT( TCID2WdRID ) ;
         return ;
      }

      while( 1 ) {
          fprintf( stderr,">>> Input command  (Current Record = %d)\n",CurRecCt) ;
          if ( gets( work ) == NULL )
            break ;
          if ( (com = InputCom(work,ary)) == 0 )
            continue ;
          if ( ( com > 10 && com < 20 ) && CurRecCt <= 0 )  /* ǥȤʤ */
              continue ;
          if ( com == 20 ) {  /* 쥳ɣɣĤˤ븡ɽ */
            print_CurRecord(WdRID2Val, TWdRID2Val, ary[1], ary[2]) ;
            continue ;
          }
          else if ( com == 21 ) { /* ̤ɽ */
            print_CurRecords( WdRID2Val, TWdRID2Val, ary[1] ) ;
            continue ;
          }
          switch( com ) {   /* Find & Select records */
            case   1 :  /* ɽˤ븡 */
            case  11 :  /* ɽˤ룲 */
                ret1 = Conv2Big(work1, ary[1]) ;
                ret1 = BackUpCurentRec() ;
                CurRecCt = 0 ;
                ret1 = AccessEDRIDX( Hdwd2WdRID, work1 ) ;
                ret2 = AccessEDRIDX( THdwd2WdRID, work1 ) ;
                if ( com == 11 )
                  ret2 = IntersectEDRIDX() ;
                break ;
            case   2 :  /* ɤߤˤ븡 */
            case  12 :  /* ɤߤˤ룲 */
                ret1 = Conv2Big(work2, ary[1]) ;
                ret1 = EDR_HiraKana( work1, work2 ) ;
                //ret1 = EDR_KanaHira( work1, work2 ) ;
                //ret1 = EDR_HiraKana( work2, work1 ) ;
                ret1 = BackUpCurentRec() ;
                CurRecCt = 0 ;
                ret1 = AccessEDRIDX( Yomi2WdRID, work1 ) ;
                //ret1 = AccessEDRIDX( Yomi2WdRID, work2 ) ;
                ret2 = AccessEDRIDX( TYomi2WdRID, work1 ) ;
                //ret2 = AccessEDRIDX( TYomi2WdRID, work2 ) ;
                if ( com == 12 )
                  ret2 = IntersectEDRIDX() ;
                break ;
            case   3 :  /* ǰIDˤ븡 */
            case  13 :  /* ǰIDˤ룲 */
                ret1 = BackUpCurentRec() ;
                CurRecCt = 0 ;
                ret1 = AccessEDRIDX( CID2WdRID, ary[1] ) ;
                ret1 = AccessEDRIDX( TCID2WdRID, ary[1] ) ;
                if ( com == 13 )
                  ret2 = IntersectEDRIDX() ;
                break ;
            case   4 :   /* ˤ븡 */
            case  14 :   /* ˤ룲 */
                ret1 = BackUpCurentRec() ;
                CurRecCt = 0 ;
                ret1 = Access_by_date( UpdLogWord, ary[1] ) ;
                ret2 = Access_by_date( lpt2, ary[1] ) ;
                if ( com == 14 )
                  ret2 = IntersectEDRIDX() ;
                break ;
            case  15 :   /* ʻˤ룲 */
                ret1 = BackUpCurentRec() ;
                CurRecCt = 0 ;
                ret1 = Select_by_cat( WdRID2Val, TWdRID2Val, ary[1] ) ;
                break ;
            case  16 :   /* Ϣܾˤ룲 */
                ret1 = BackUpCurentRec() ;
                CurRecCt = 0 ;
                ret1 = Select_by_lr( WdRID2Val, TWdRID2Val, ary[1] ) ;
                break ;
            case  70 :   /* ʻˤ룱ɽʴμѸ */
                ret1 = Dump_by_cat( WdRID2Val, TWdRID2Val, ary[1], ary[2] ) ;
                break ;
            case  71 :   /* ʻˤ룱ɽ */
                ret1 = Dump_by_cat( WdRID2Val, NULL, ary[1], ary[2] ) ;
                break ;
            case  72 :   /* ʻˤ룱ɽѸμ */
                ret1 = Dump_by_cat( NULL, TWdRID2Val, ary[1], ary[2] ) ;
                break ;
          }
      }

      DB_FileClose() ;

      if ( WdRID2Val != NULL ) Close_IXT( WdRID2Val ) ;
      if ( Yomi2WdRID != NULL ) Close_IXT( Yomi2WdRID ) ;
      if ( Hdwd2WdRID != NULL ) Close_IXT( Hdwd2WdRID ) ;
      if ( CID2WdRID != NULL ) Close_IXT( CID2WdRID ) ;
      if ( TWdRID2Val != NULL ) Close_IXT( TWdRID2Val ) ;
      if ( TYomi2WdRID != NULL ) Close_IXT( TYomi2WdRID ) ;
      if ( THdwd2WdRID != NULL ) Close_IXT( THdwd2WdRID ) ;
      if ( TCID2WdRID != NULL ) Close_IXT( TCID2WdRID ) ;
}



int BackUpCurentRec()
{
  int ii ;

  for( ii = 0 ; ii < CurRecCt ; ii++ ) 
    BakRecIDs[ii] = CurRecIDs[ii] ; 
  BakRecCt = CurRecCt ;
  return BakRecCt ;
}


int RecoverCurentRec()
{
  int ii ;
  for( ii = 0 ; ii < BakRecCt ; ii++ )
    CurRecIDs[ii] = BakRecIDs[ii] ;
  CurRecCt = BakRecCt ;
  return BakRecCt ;
}


int AccessEDRIDX( CFile *hpt, char *key ) 
{
  int ret ;
  int ii ;
  MorphInfo  morph[4096] ;

  if ( hpt == NULL )
    return 0 ;
  ret = GetRecIDFromHdwd(0, hpt, key, &morph[0], 4096) ;
  if ( ret == 0 )
    return ret ;
  for( ii = 0 ; ii < ret ; ii++ ) {
    CurRecIDs[ CurRecCt++ ] = morph[ii].rno ;
  }
  return ret ;
}


int IntersectEDRIDX()
{
  int ii, jj, kk ;

  kk = 0 ;
  for( ii = 0 ; ii < CurRecCt ; ii++ ) {
    for ( jj = 0 ; jj < BakRecCt ; jj++ ) {
      if ( CurRecIDs[ii] == BakRecIDs[jj] ) {
        CurRecIDs[kk++] = CurRecIDs[ii] ;
        break ;
      }
    }
  }
  CurRecCt = kk ;
}



/* ȥ쥳ɤ򥢥ʻΤΤ򤹤 */
int  Select_by_cat( CFile *bjwd, CFile *tjwd, char *cat )
{
  int id, ii, kk ;


  id = GetJPoSID( cat ) ;

  if ( id == 255 ) {
    fprintf(stderr,"ERROR(Select_by_cat):Unknown cat[%s]\n",cat) ;
    RecoverCurentRec() ;
    return 0 ;    
  }

  kk = 0 ;  
  for ( ii = 0 ; ii < BakRecCt ; ii++) {
    if ( bjwd != NULL ) {
      if ( ChkRecByCat( bjwd, BakRecIDs[ii], id)  > 0 ) 
        CurRecIDs[kk++] = BakRecIDs[ii] ;
    }
    if ( tjwd != NULL ) {
      if ( ChkRecByCat( tjwd, BakRecIDs[ii], id)  > 0 ) 
        CurRecIDs[kk++] = BakRecIDs[ii] ;
    }
  }
  CurRecCt = kk ;
  return 1;
}




int print_by_cat_JWD(char *key, int klen, char *data, int dlen)
{
  int  ret ;
  unsigned char *cary[64] ;

  ret = StartPts( data, dlen, cary) ;
  //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
  //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
  //*
  //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
  //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

  if ( *cary[3] != WORK_POS )
    return 1 ;

  ret = PrEDRJWDsub( WORK_FILE, 'B', key, cary) ;

  return ret ;
}



int print_by_cat_TJWD(char *key, int klen, char *data, int dlen)
{
  int  ret ;
  unsigned char *cary[64] ;

  ret = StartPts( data, dlen, cary) ;
  //*        | Rec-ID | L-Con | R-Con | JPoS | Gid | Cid\0 |
  //*        |  (4)   | (1)   | (1)   | (1)  | (4) | (n)   |
  //*
  //*           | ѲϢ\0 | ɤ\0 | ȯ\0 | \0 | \0 |
  //*           |  (n)           | (n)    | (n)    | (n)    | (n)        |

  if ( *cary[3] != WORK_POS )
    return 1 ;

  ret = PrEDRJWDsub(WORK_FILE, 'T', key, cary) ;

  return ret ;
}



int Dump_by_cat( CFile *bjwd, CFile *tjwd, char *cat, char *file )
{
  int  ret ;
  FILE *fp = NULL ;

  WORK_POS = GetJPoSID( cat ) ;

  if ( file == NULL || *file == '\0' )
    WORK_FILE = stdout ;
  else {
    if ( ( fp = fopen( file, "w" ) ) == NULL ) {
      fprintf( stderr,"ERROR:Cannot open output file[%s]\n", file) ;
      WORK_FILE = stdout ;
    }
    else 
      WORK_FILE = fp ;
  }

  if ( bjwd != NULL ) {   /* μDBե뤫鳺ʻΥ쥳ɤ */
    ret = ScanExec_IXT( bjwd, print_by_cat_JWD ) ;

  }
  if ( tjwd != NULL ) {   /* μDBե뤫鳺ʻΥ쥳ɤ */
    ret = ScanExec_IXT( tjwd, print_by_cat_TJWD ) ;
  }

  if ( fp != NULL ) 
    fclose( fp) ;

  return ret ;
}




/* ȥ쥳ɤ򥢥ꤵ줿Ϣ°ΤΤ򤹤 */
int Select_by_lr( CFile *bjwd, CFile *tjwd, char *lrcon )
{
  int id, ii, kk, lcon, rcon ;
  char work[32], *cp ;

  cp = skip_ptr( ',', lrcon ) ;
  if (cp == NULL) {
    fprintf(stderr,"ERROR(Select_by_lr):Unknown L,R[%s]\n",lrcon) ;
    RecoverCurentRec() ;
    return 0 ;    
  }
  copy_word( work, 32, lrcon, cp ) ;
  if ( work[0] == '\0' || work[0] == '*' ) 
    lcon = -1 ;
  else 
    lcon = GetLconID( work ) ;
  cp = skip_non_sp( cp +1 ) ;
  if ( cp == NULL || *cp == '*' ) 
    rcon = -1 ;
  else
    rcon = GetRconID( cp ) ;

  //printf("Select_by_lr start lcon =%d rcon=%d\n",lcon,rcon) ;
  if ( lcon == 255 || rcon == 255 ) {
    fprintf(stderr,"ERROR(Select_by_lr):Unknown L,R[%s](%d,%d)\n",lrcon,lcon,rcon) ;
    RecoverCurentRec() ;
    return 0 ;    
  }

  kk = 0 ;  
  for ( ii = 0 ; ii < BakRecCt ; ii++) {
    if ( bjwd != NULL ) {
      if ( ChkRecByLRcon( bjwd, BakRecIDs[ii], lcon, rcon)  > 0 ) 
        CurRecIDs[kk++] = BakRecIDs[ii] ;
    }
    if ( tjwd != NULL ) {
      if ( ChkRecByLRcon( tjwd, BakRecIDs[ii], lcon, rcon)  > 0 ) 
        CurRecIDs[kk++] = BakRecIDs[ii] ;
    }
  }
  CurRecCt = kk ;
  return 1;
}



int Access_by_date( CFile *log, char *date )
{
/* DB򥢥ꤵ줿֤˹줿Τ򤹤 */
  int  ret ;
  int  i, len, hdate, Rid ;
  int  cdate,fromb,tob, dhash ;
  char work[32768], wk[32] ;
  char *ary[16] ;

  if ( log == NULL )
    return 1 ;

  ret = split1( '-', date, ary) ;
  //printf("from=[%s]\n",ary[0]) ;
  //printf("to=[%s]\n",ary[1]) ;

  if ( *ary[0] == '\0' ) { /*  1997.1.1 */
    fromb = PStrDate2PI( "19970101" ) ;
  }
  else
    fromb = PStrDate2PI( ary[0] ) ;

  if ( ret == 1) {
    tob = PackNowDateI() ;
  }
  else if ( *ary[1] == '\0' ) { /*  1997.1.1 */
    tob = PackNowDateI() ;
  }
  else {
    tob = PStrDate2PI( ary[1] ) ;
  }
  printf("from[%x], to=[%x]\n",fromb,tob) ;
  ret = 0 ;
  for( cdate = fromb ; cdate <= tob ;  cdate = next_Pdate( cdate ) ) {
    dhash = ConvPackDate2B( cdate ) ;
    len = Get_IXT( log, (char *)&dhash, 4, work, 32768) ;
    if ( len <= 0 )
      continue ;
    CDATEFromETC4byte( wk, (char *)&cdate ) ;
    printf("################# DATE [ %s ] #################\n",wk) ;
    for( i = 0 ; i < len  ; i += 4 ) {
      Rid = get4byte(work + i) ;
      printf("JWD%07d\n", Rid ) ;
      if ( ret >= 32768 ) {
        continue ;
      }
      CurRecIDs[ret++] = Rid ;
    }
  }
  if ( ret >= 32768 ) {
    fprintf( stderr,"ERROR(Access_by_date):ϥ쥳ɤο¿ޤ\n") ;
    fprintf( stderr,"                      ꤹ֤ûƲ\n") ;
  }    
  CurRecCt = ret ;

  return 1;
}








/*** Ϥ줿ʸʬϤ ***/
int InputCom(char *work, char **ary) 
{
  char *cp ;
  int  ret ;

  cp = skip_non_sp( work ) ;
  if ( cp == NULL)
    return 0 ;
  if ( *cp == '?' ) {
    HelpInput() ;
    return 0 ;
  }
  ary[0] = cp ;
  if (*cp == 'F' || *cp == 'f' ) {
    cp++ ;
    switch( *cp ) {
      case  'H' :          /* headword   ɽˤ룱 */
      case  'h' :  ret = 1 ; break ;
      case  'R' :          /* reading    ɤߤˤ룱 */
      case  'r' :  ret = 2 ; break ;
      case  'C' :          /* ConceptID  ǰɣĤˤ룱 */
      case  'c' :  ret = 3 ; break ;
      case  'D' :          /* from-to    ˤ룱 */
      case  'd' :  ret = 4 ; break ;
      default   :  return 0 ;
    }
    cp++ ;
    if ( *cp == '\0'|| ( *cp != '\t' && *cp != ' ') ) {
      fprintf(stderr,"Input error!\n") ;
      return 0 ; 
    }
    ary[1] = skip_non_sp( cp ) ;
    return ( ret ) ;
  }
  if (*cp == 'S' || *cp == 's' ) {
    cp++ ;
    switch( *cp ) {
      case  'H' :          /* headword   ɽˤ룲 */
      case  'h' :  ret = 11 ; break ;
      case  'R' :          /* reading    ɤߤˤ룲 */
      case  'r' :  ret = 12 ; break ;
      case  'C' :          /* ConceptID  ǰɣĤˤ룲 */
      case  'c' :  ret = 13 ; break ;
      case  'D' :          /* from-to    ˤ룲 */
      case  'd' :  ret = 14 ; break ;
      case  'P' :          /* POS        ʻˤ룲 */
      case  'p' :  ret = 15 ; break ;
      case  'L' :          /* Lcon,Rcon  Ϣܾˤ룲 */
      case  'l' :  cp++ ;
                   if ( *cp != 'R' && *cp != 'r')
                     return 0 ;
                   ret = 16 ; break ;
      default   :  return 0 ;
    }
    cp++ ;
    if ( *cp == '\0'|| ( *cp != '\t' && *cp != ' ') ) {
      fprintf(stderr,"Input error!\n") ;
      return 0 ; 
    }
    ary[1] = skip_non_sp( cp ) ;
    return ( ret ) ;
  }
  if (*cp == 'P' || *cp == 'p' ) {
    cp++ ;
    if ( *cp == '\0' || *cp <= ' ' )  {
      ary[1] = skip_non_sp( cp ) ;
      return 21 ;          /* ȥ쥳ɤξɽؼ */
    }
    switch( *cp ) {
      case  'M' :          /* ץȥ⡼ɤ */
      case  'm' : cp++ ;
                  SetPrintMode(cp) ;   
                  return 0 ;
      case  'P' :          /* ʻˤ븡ɽ */
      case  'p' :  if ( *(cp +1) <= ' ' ) ret = 70 ;
                   else if ( *(cp +1) == 'B' || *(cp +1) == 'b' ) { cp++ ; ret = 71 ; }
                   else if ( *(cp +1) == 'T' || *(cp +1) == 't' ) { cp++ ; ret = 72 ; }
                   break ;
    }
    cp++ ;
    if ( *cp == '\0'|| ( *cp != '\t' && *cp != ' ') ) {
      fprintf(stderr,"Input error!\n") ;
      return 0 ; 
    }
    ary[1] = skip_non_sp( cp ) ;
    cp = skip_a_word(ary[1]) ;
    if ( cp != NULL ) {
      *cp = '\0' ; 
      cp++ ;
    }
    ary[2] = skip_non_sp( cp ) ;
    return ( ret ) ;

  }
  if (*cp == 'I' || *cp == 'i' ) {
    ary[1] = skip_non_sp( cp + 1 ) ;
    if ( ary[1] == NULL ) {
      fprintf(stderr,"ERROR(InputCom): 쥳ֹλ꤬ޤ\n") ;
      return 0 ;
    }  
    cp = skip_a_word(ary[1]) ;
    ary[2] = skip_non_sp( cp ) ;
    return 20 ;            /* ꤵ줿쥳ɣɣĤξɽ */
  }
  if (*cp == 'A' || *cp == 'a' ) {
    cp++ ;
    SetAccessDict(cp) ;
    return 0 ;
  }
  if ( *cp == 'B' || *cp == 'b' ) {
    cp++ ;
    if ( *cp == '\0' || skip_non_sp( cp ) == NULL ) 
      RecoverCurentRec() ;
    return 0 ;
  }
  /* Default FH */
  ary[1] = skip_non_sp( cp ) ;
  return 1 ;
}






/********************************************************/
void  HelpInput()
{
  fprintf( stderr,"*** COMMANDS ****************(Current Record = %d)\n",CurRecCt) ;
  fprintf( stderr,"FH  headword   ɽˤ룱\n") ;
  fprintf( stderr,"FR  reading    ɤߤˤ룱\n") ;
  fprintf( stderr,"FC  ConceptID  ǰ̻Ҥˤ룱\n") ;
  fprintf( stderr,"\n") ;    
  fprintf( stderr,"SH  headword   ɽˤ룲\n") ;
  fprintf( stderr,"SR  reading    ɤߤˤ룲\n") ;
  fprintf( stderr,"SC  ConceptID  ǰ̻Ҥˤ룲\n") ;
  fprintf( stderr,"SP  POS        ʻˤ룲\n") ;
  fprintf( stderr,"SLR left,right Ϣܾˤ룲\n") ;
  fprintf( stderr,"\n") ;    
  fprintf( stderr,"PP  POS [file] ʻˤ븡ɽ\n") ;
  fprintf( stderr,"I   RID [file] 쥳IDˤɽؼ\n") ;
  fprintf( stderr,"P   [file]     ȥ쥳ɤɽ\n") ;
  fprintf( stderr,"PM  {V}/FV/EDR ץȥ⡼ɤ\n") ;
  fprintf( stderr,"A   {BT}/B/T   \n") ;
  fprintf( stderr,"B              θ̤᤹\n") ;
  fprintf( stderr,"FD  from-to    ˤ󸡺\n") ;
  fprintf( stderr,"---------------------------------------------------\n") ;
  fprintf( stderr," Ƽ拾ޥɤϾʸǤɤ\n") ;
  fprintf( stderr,"  from,to yyyymmdd ϡ\n") ;
  fprintf( stderr,"\n") ;
}




int InitEnv()
{
  ENV_FLAGS = 0 ;
  ENV_FLAGS |= ACCE_B | ACCE_T ;   /* ܸѸξ򥢥 */
  ENV_FLAGS |= OUT_V ;             /* ɽ⡼:VALUEΤߤɽ⡼ɤ */
  return 1 ;
}



/* ɽ⡼ɤ */
void SetPrintMode( char *cp )
{
  cp = skip_non_sp( cp ) ;

  if ( ( *cp == 'V' || *cp == 'v') && *(cp+1) <= ' ') {
    ENV_FLAGS &= ~( OUT_FV | OUT_EDR ); 
    ENV_FLAGS |= OUT_V ;
    return ;
  }
  if ( ( strncmp(cp,"FV",2) == 0 ||
         strncmp(cp,"fv",2) == 0 ) && *(cp+2) <= ' ') {
    ENV_FLAGS &= ~( OUT_V | OUT_EDR ); 
    ENV_FLAGS |= OUT_FV ;
    return ;
  }
  if ( ( strncmp(cp,"EDR",3) == 0 ||
         strncmp(cp,"edr",3) == 0 ) && *(cp+3) <= ' ') {
    ENV_FLAGS &= ~( OUT_V | OUT_FV ); 
    ENV_FLAGS |= OUT_EDR ;
    return ;
  }
  fprintf( stderr,"ERROR(SetPrintMode):Unknown[%s]\n",cp) ;
}



/* 뼭ꤹ */
void SetAccessDict( char *cp )
{
  if ( ( *cp == 'B' || *cp == 'b') && *(cp+1) <= ' ') {
    ENV_FLAGS &= ~ACCE_T ; 
    ENV_FLAGS |= ACCE_B ;
    return ;
  }
  if ( ( *cp == 'T' || *cp == 't') && *(cp+1) <= ' ') {
    ENV_FLAGS &= ~ACCE_B ; 
    ENV_FLAGS |= ACCE_T ;
    return ;
  }
  if ( ( strncmp(cp,"BT",3) == 0 ||
         strncmp(cp,"bt",3) == 0 ||
         strncmp(cp,"TB",3) == 0 ||
         strncmp(cp,"tb",3) == 0   ) && *(cp+3) <= ' ') {
    ENV_FLAGS |= ACCE_B | ACCE_T ;
    return ;
  }
  fprintf( stderr,"ERROR(SetAccessDict):Unknown[%s]\n",cp) ;
}




void print_CurRecord( CFile *bjwd, CFile *tjwd, char *recid, char *file )
{
  FILE *fp ;
  int  flag = 0 ;
  char dict[32], ids[32] ;
  int  ret , id ;

  if ( file == NULL )
    fp = stdout ;
  else {
    if ( (fp = fopen(file,"w")) == NULL ) {
      fprintf(stderr,"ERROR(print_Record):Cannot open [%s]\n",file) ;
      fp = stdout ;
    }
    else
      flag = 1 ;
  }
  if ( *recid == 'J' || *recid == 'T' )
    id = GetCode2Wid( recid, dict, ids) ;
  else 
    id = atoi( recid ) ;

  if ( bjwd != NULL ) {
    if ( (ENV_FLAGS & OUT_EDR ) != 0 ) 
      PrnRecFromRID(fp, bjwd,id) ;  /* ţģҼɽ */
    if ( (ENV_FLAGS & OUT_FV ) != 0 ) 
      PrnFVRecFromRID(fp, bjwd,id) ;/* FIELDVALUEɽ */
    if ( (ENV_FLAGS & OUT_V ) != 0 )  
      PrnVRecFromRID(fp, bjwd,id) ; /* VALUEɽ */
  }
  if ( tjwd != NULL ) {
    if ( (ENV_FLAGS & OUT_EDR ) != 0 ) 
      PrnRecFromRIDT(fp, tjwd,id) ;  /* ţģҼɽ */
    if ( (ENV_FLAGS & OUT_FV ) != 0 ) 
      PrnFVRecFromRIDT(fp, tjwd,id) ;/* FIELDVALUEɽ */
    if ( (ENV_FLAGS & OUT_V ) != 0 )  
      PrnVRecFromRIDT(fp, tjwd,id) ; /* VALUEɽ */
  }
  fprintf(fp,"\n") ;
  if ( flag != 0 )
    fclose( fp ) ;
}



void print_CurRecords( CFile *bjwd, CFile *tjwd, char *file )
{
  FILE *fp ;
  int  flag = 0 ;
  int  ret , ii ;

  if ( file == NULL )
    fp = stdout ;
  else {
    if ( (fp = fopen(file,"w")) == NULL ) {
      fprintf(stderr,"ERROR(print_CurRecord):Cannot open [%s]\n",file) ;
      fp = stdout ;
    }
    else
      flag = 1 ;
  }

  for ( ii = 0 ; ii < CurRecCt ; ii++) {
    if ( bjwd != NULL ) {
      if ( (ENV_FLAGS & OUT_EDR ) != 0 ) 
        PrnRecFromRID( fp, bjwd,CurRecIDs[ii]) ;  /* ţģҼɽ */
      if ( (ENV_FLAGS & OUT_FV ) != 0 ) 
        PrnFVRecFromRID( fp, bjwd,CurRecIDs[ii]) ;/* FIELDVALUEɽ */
      if ( (ENV_FLAGS & OUT_V ) != 0 ) 
        PrnVRecFromRID( fp, bjwd,CurRecIDs[ii]) ; /* VALUEɽ */
    }
    if ( tjwd != NULL ) {
      if ( (ENV_FLAGS & OUT_EDR ) != 0 ) 
        PrnRecFromRIDT( fp, tjwd,CurRecIDs[ii]) ;  /* ţģҼɽ */
      if ( (ENV_FLAGS & OUT_FV ) != 0 ) 
        PrnFVRecFromRIDT( fp, tjwd,CurRecIDs[ii]) ;/* FIELDVALUEɽ */
      if ( (ENV_FLAGS & OUT_V ) != 0 ) 
        PrnVRecFromRIDT( fp, tjwd,CurRecIDs[ii]) ; /* VALUEɽ */
    }
  }

  if ( flag != 0 )
    fclose( fp ) ;


}







