#include <stdio.h>
#include <time.h>
#include "fconst.h"
#include "ftemp.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/


char PackChar2( int char2 ) ;
int  PropDate(char *date) ;
int  PHEXtoBIN( unsigned char h2) ;



/****	ߤդ򣴥Хȿͤɽ롣
*   USAGE:		PackNowDateC(char *date)
*   SYNOPSIS:		date	(OUT) ճǼ
*   DESCRIPTION:	
*			ߤդᡢ19YYMMDDͤѥå
*                       ХȤͤȤ֤
*
*   RETURN:		
*
*   SEE ALSO:
* 			
*****************************************************************/
int PackNowDateI()
{
  time_t  a, b ;
  struct tm      *tinfo ;
  int ret ;
  char wk[4], buff[3] ;

  b = time(&a) ;

  tinfo = localtime(&a) ;

  wk[0] = 0x19 ;
  wk[1] = PackChar2(tinfo->tm_year) ;
  wk[2] = PackChar2(tinfo->tm_mon +1) ;
  wk[3] = PackChar2(tinfo->tm_mday) ;

  ret = get4byte(wk) ;
  return ret ; 
}



char PackChar2( int char2 )
{
  char buff[3]  ;
  char ret ;

  sprintf(buff,"%02d", char2) ;
  ret = buff[0] - '0' ;
  ret <<= 4 ;
  ret |= ( buff[1] - '0' ) ; 
  return ret ;
}




/****	ߤդʸ롣
*   USAGE:		PackNowDateC(char *date)
*   SYNOPSIS:		date	(OUT) ճǼ
*   DESCRIPTION:	
*			ߤդᡢYY/MM/DDʸ롣
*                       MMDDξϡΤޤޣʸȤ롣
*
*   RETURN:		ʸĹ
*
*   SEE ALSO:
* 			
*****************************************************************/
int PackNowDateC(char *wk)
{
  time_t  a, b ;
  struct tm      *tinfo ;
  int ret ;
  char wky[4], wkm[4], wkd[4] ;

  b = time(&a) ;
  tinfo = localtime(&a) ;

  sprintf(wk,"%d/%d/%d",tinfo->tm_year,tinfo->tm_mon + 1,tinfo->tm_mday) ;
  return (strlen(wk)) ; 
}









/****	ˤ DATE°Фѥå줿֤ͤ
*   USAGE:		PackDateFromETC(char *date)
*   SYNOPSIS:		etc	(IN) 
*
*   DESCRIPTION:	ˤ DATE°ФХȤ
*                       ѥå줿͡YYYYMMDDˤˤ֤
*
*   RETURN:		YYYYMMDDˤѥå
*                       0: DATE°¸ߤʤ
*
*   SEE ALSO:
* 			
*****************************************************************/
int PackDateFromETC(char *etc)
{
  int  ret ;

  while ( etc != NULL ) {
    etc = skip_non_sp( etc ) ;
    if ( strncmp( etc, "DATE", 4) == 0 ) {
      ret = PropDate(etc) ;
      return ret ;
    }
    etc = skip_ptr( ';', etc ) ;
    if ( etc != NULL )
      etc++ ;
  }
  return ( 0 ) ;
}


int PropDate(char *date)
{
  int  yy, mm , dd ;
  char wk[4] ;
  int  ret ;

  date += 4 ;
  date = skip_non_sp( date ) ;
  if ( *date != '=' )
    return 0 ;
  date++ ;
  date = skip_non_sp( date ) ;
  if ( *date == '"' )
    date++ ;
  yy = atoi(date) ;
  date = skip_ptr( '/', date ) ;
  date++ ;
  mm = atoi(date) ;
  date = skip_ptr( '/', date ) ;
  date++ ;
  dd = atoi(date) ;
  wk[0] = 0x19 ;
  wk[1] = PackChar2(yy) ;
  wk[2] = PackChar2(mm) ;
  wk[3] = PackChar2(dd) ;

  ret = get4byte(wk) ;
  return ret ; 
}


/* ʸäơΤޤޥѥåΥХʥ꡼֤ */
int PStrDate2PI( char *date )
{
  int  yy1, yy2 , mm , dd ;
  char wk[8] ;
  int  ret ;

  strncpy( wk, date, 2 ) ;
  yy1 = atoi( wk) ;
  strncpy( wk, date+2, 2 ) ;
  yy2 = atoi( wk) ;

  strncpy( wk, date+4, 2) ;
  mm = atoi( wk) ;

  strncpy( wk, date+6, 2 ) ;

  dd = atoi( wk) ;
  wk[0] = PackChar2(yy1) ;
  wk[1] = PackChar2(yy2) ;
  wk[2] = PackChar2(mm) ;
  wk[3] = PackChar2(dd) ;

  ret = get4byte(wk) ;
  return ret ; 
}

/****	ˤCDATEꥢ˳Ǽ줿ͤʸˤ롣
*   USAGE:		CDATEFromETC4byte(char *out, char *pdata)
*   SYNOPSIS:		char  *out      (IN) YY/MM/DDǼ
*                       char  &date4	(IN) ⣴Хȥꥢ
*
*   DESCRIPTION:	ιꥢʣХȡˤ˳Ǽ
*                       Ƥѥå줿͡YYYYMMDDˤʸɽ
*                       YY/MM/DDˤˤ֤
*
*   RETURN:		ʸĹ
*
*   SEE ALSO:
* 			
*****************************************************************/
int CDATEFromETC4byte(char *out, unsigned char *pdate)
{
  int wky, wkm, wkd ;
  int wk ;

  wky = PHEXtoBIN( *(pdate + 1) ) ;
  wkm = PHEXtoBIN( *(pdate + 2) ) ;
  wkd = PHEXtoBIN( *(pdate + 3) ) ;
  sprintf(out,"%d/%d/%d",wky,wkm,wkd) ;
  return (strlen(out)) ; 
}

int  PHEXtoBIN( unsigned char h2)
{
  int wk ;

  wk = 0xF0 & h2 ;
  wk = ( wk >> 4 ) * 10 ;
  wk += ( 0x0F & h2 ) ;
  return wk ;
}




/****	(Хȿ)ϥåɤ褦Ѵ롣
*   USAGE:		ConvPackDate2B( int date)
*   SYNOPSIS:		date	(IN) (YYYYMMDDΥѥåХʥ꡼
*   DESCRIPTION:	
*			Ϳ줿ա19YYMMDDˤͤХʥ
*                       Ѵ롣
*
*   RETURN:		б
*
*   SEE ALSO:
* 			
*****************************************************************/
int ConvPackDate2B( int date )
{
  int  ii, jj , dd , mm ;
  int ret ;

 
  ret = 0xffff0000 & date ; /* yyyyʬ */

  ii = 0x0000ff00 & date ; /* mmʬ */
  ii = ii >> 8 ;
  jj = ii & 0xf0 ;
  jj = jj >> 4 ;
  mm = jj*10 + (ii & 0x0f) ;
  ret += 31*mm ;

  ii = 0x000000ff & date ; /* ddʬ */
  jj = ii & 0xf0 ;
  jj = jj >> 4 ;
  dd = jj*10 + (ii & 0x0f) ;
  ret += dd ;


  //printf("DATE1 IN[ %x ]==>ret=%x\n",date,ret) ;
  return ret ; 
}



/****	ϥåͤѥå(Хȿ)Ѵ롣
*   USAGE:		ConvB2PacDate( int datebin)
*   SYNOPSIS:		datebin	(IN) դΥϥåѥХʥ꡼
*   DESCRIPTION:	
*			Ϳ줿ϥåѥХʥ꡼դѥå
*                       դѴ롣
*
*   RETURN:		б
*
*   SEE ALSO:
* 			
*****************************************************************/
int ConvB2PackDate( int datebin )
{
  int  ii, jj , dd , mm ;
  int ret ;

  ret = 0xffff0000 & datebin ; /* yyyyʬ */

  ii = 0x0000ffff & datebin ;    /* mmʬ */
  mm = ii / 31 ;
  jj = mm / 10 ;
  jj = jj << 4 ;
  mm = jj | (mm % 10) ;
  ret += (mm << 8) ;

  dd = ii % 31 ;              /* ddʬ */
  jj = dd / 10 ;
  jj = jj << 4 ;
  mm = jj | (dd % 10) ;
  ret += mm ;

  //printf("DATE2 IN[ %x ]==>ret=%x\n",datebin,ret) ;
  return ret ; 
}








/****	(Хȿ)ˣä롣
*   USAGE:		next_Pdate( int date)
*   SYNOPSIS:		date	(IN) (YYYYMMDDΥѥåХʥ꡼
*   DESCRIPTION:	
*			Ϳ줿ա19YYMMDDˤμͤ롣
*
*   RETURN:		б
*
*   SEE ALSO:
* 			
*****************************************************************/
int next_Pdate( int date )
{
  int  yy, mm, dd ;
  int ret ;

 
  yy = 0xffff0000 & date ; /* yyyyʬ */

  mm = 0x0000ff00 & date ; /* mmʬ */

  dd = 0x000000ff & date ; /* ddʬ */

  dd = dd_Add1( dd ) ;
  if ( dd != 0 ) {
    ret = yy | mm | dd ;
    return ret ;
  }
  
  dd = 1 ;
  mm = mm_Add1( mm) ;
  if ( mm != 0 ) {
    ret = yy | mm | dd ;
    return ret ;
  }
  mm = 0x000100 ;
  yy = yy_Add1( yy ) ;
  ret = yy | mm | dd ;

  //printf("DATE1 IN[ %x ]==>ret=%x\n",date,ret) ;
  return ret ; 
}


int dd_Add1( int dd )
{
  int ret ;

  ret = dd + 1 ;
  if ( ( 0x0f & ret ) >= 0x0a ) {
    ret += 0x0010 ;
    ret &= 0x00f0 ;
    return ret ;    
  }
  if ( ( 0x0f0 & ret ) >= 0x0030 &&
       ( 0x00f & ret ) >= 2) {
    return 0 ;
  }
  return ret ;
}


int mm_Add1( int mm )
{
  int ret ;

  ret = mm + 0x0100 ;
  if ( ( 0x0f00 & ret ) >= 0x0a00 ) {
    ret += 0x001000 ;
    ret &= 0x00f000 ;
    return ret ;    
  }
  if ( ( 0x0f000 & ret ) >= 0x001000 &&
       ( 0x00f00 & ret ) >= 0x000300) {
    return 0 ;
  }
  return ret ;
}



int yy_Add1( int yy )
{
  int ret ;

  ret = yy + 0x00010000 ;
  if ( ( 0x000f0000 & ret ) >= 0x000a0000 ) {
    ret += 0x00100000 ;
    ret &= 0xfff00000 ;
  }
  if ( ( 0x00f00000 & ret ) >= 0x00a00000 ) {
    ret += 0x01000000 ;
    ret &= 0xff000000 ;
  }
  if ( ( 0x0f000000 & ret ) >= 0x0a000000 ) {
    ret += 0x10000000 ;
    ret &= 0xf0000000 ;
  }
  return ret ;
}



        
