#include <stdio.h>
#include <fcntl.h> 
#include "fconst.h"
#include "ftemp.h"
/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/

/*------------------------*/
/* եɤ߹ߥե饰 */
/*------------------------*/
#define RDOPN_FLAG "r+"
#define WROPN_FLAG "w+"


/**********************************************************
*   ***	ѥǥåեؿ
*   USAGE:		Create_IXT( char *fname, char ktype, int hmax, int hsize, int rbsize)
*   SYNOPSIS:		char  *fname  ե̾
*                       char  ktype   סs:ʸ,b:Хʥ꡼
*                       int   hmax    ϥå奨ȥ꡼
*                       int   hsize   ϥå奵
*                       int   rbsize  쥳ɥ֥å
*   DESCRIPTION:	
*	ѥǥåեؿ
*	եκʽˤ˼Ԥ硢顼֤
*	˥ե뤬줿ϡե
*       ̻ҤΥݥ󥿤֤
*
*   RETURN:		NULLʳ : ｪλ
*                       NULL     : ۾ｪλ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
CFile *Create_IXT( char *fname, char ktype, int hmax, int hsize, int rbsize )
{
  CFile  *fPtr;                 /* ¤ */
  unsigned char cont[CBSIZE];   /* ȥ֥åꥨꥢ */
  int   i, bct, set_flag;

  if ( ktype == 's' )
    set_flag = IX_TYPE | STR_TYPE ;
  else if ( ktype == 'b' )
    set_flag = IX_TYPE | BIN_TYPE ;
  else {
    fprintf( stderr,"ERROR:(Create_IXT) פְäƤ\n"); 
    return NULL ;
  }

  /* ¤Τΰݤ */
  if ( ( fPtr = (CFile *)malloc(sizeof(CFile)) ) == NULL ){
    return (CFile *)NULL;
  }

  /* եΥץ */
  //if ( ( fPtr->fd = open ( fname, O_CREAT|O_RDWR , 0644) ) < 0 ){
  if ( ( fPtr->fd = fopen( fname, WROPN_FLAG ) ) == NULL ) {
    fprintf( stderr, "ERROR:(Create_IXT)ե[%s]ץޤ\n",fname) ;
    return (CFile *)NULL;
  }

  /* ե̾ꤹ */
  if ( ( fPtr->name = (unsigned char *)malloc(strlen(fname)+1) ) == NULL ){
    return (CFile *)NULL;
  }
  strcpy(fPtr->name, fname) ;

  /* ȥ֥å */

  *(int *)&cont[0] = set_flag ;
  *(int *)&cont[4] = VAR_NO | REV_NO ;

  i = PackNowDateI() ;                    /***  ***/
  *(int *)&cont[8] = i ;  /*  */
  *(int *)&cont[12] = i ; /*  */

  bct = hmax / PTCOUNT ;                  /*** ֥å ***/
  if ( ( hmax % PTCOUNT) != 0) {
    bct++ ;
  }
  *(int *)&cont[16] = CBSIZE + (CBSIZE * bct ) ;  

  *(int *)&cont[20] =  NULL ;             /*** ե꡼֥å ***/

  *(int *)&cont[24] = hmax ;              /*** ϥå奨ȥ꡼ ***/
  fPtr->hmax = *(int *)&cont[24] ;

  *(int *)&cont[28] = hsize ;             /*** ϥå奵 ***/
  fPtr->hsize = hsize ;

  if ( rbsize == NULL)                    /*** 쥳ɥ֥å ***/
    *(int *)&cont[32] = BSIZE ;
  else if ( rbsize > BSIZE )
    *(int *)&cont[32] = BSIZE ;
  else
    *(int *)&cont[32] = rbsize ;
  fPtr->rbsz = *(int *)&cont[32] ;

  *(int *)&cont[36] = 1 ;                 /*** Ǽ쥳ID ***/
  fPtr->rct = 1 ;

  for( i = 40 ; i < CBSIZE ; i += 4 ) {
      *(int *)&cont[i] = 0 ;
  }

  //lseek( fPtr->fd, 0L, 0 ) ;
  //write( fPtr->fd, cont, CBSIZE ) ;
  fseek( fPtr->fd, 0L, 0 ) ;
  fwrite( cont, 1, CBSIZE, fPtr->fd ) ;
  fPtr->flag = set_flag ;
  fPtr->curpt = NULL ;

  for( i = 0 ; i < CBSIZE ; i += 4) {     /*** ϥå奨ȥ꡼ꥢ ***/
    *(int *)&cont[i] = NULL ;
  }  
  for( i = 0 ; i < bct ; i++) {
    //write( fPtr->fd, cont, CBSIZE ) ;
    fwrite( cont, 1, CBSIZE, fPtr->fd ) ;
  }
  fprintf( stderr, "Create [%s].\n",fPtr->name) ;
  return fPtr ;
}



/**********************************************************
*   ***	ѥǥåե򥪡ץ󤹤ؿ
*   USAGE:		Open_IXT( char *fname, char ktype )
*   SYNOPSIS:		char  *fname  ե̾
*
*   DESCRIPTION:	
*	ѥǥåե򥪡ץ󤹤ؿ
*	եΥץ˼Ԥ硢顼֤
*	˥ե뤬ץǤϡե
*       ̻ҥݥ󥿤֤
*
*   RETURN:		NULLʳ : ｪλ
*                       NULL     : ۾ｪλ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
CFile  *Open_IXT( char *fname, char ktype )
{
  CFile  *fPtr;                     /* ¤ */
  unsigned char cont[CBSIZE];       /* ɤ߹ߥХåե */

  /* ¤Τΰݤ */
  if ( ( fPtr = (CFile *)malloc(sizeof(CFile)) ) == NULL ){
    return (CFile *)NULL;
  }

  /* եΥץ */
  //if ( ( fPtr->fd = open ( fname, O_RDWR) ) < 0 ){
  if ( ( fPtr->fd = fopen( fname, RDOPN_FLAG ) ) == NULL ) {
    //fprintf( stderr, "ERROR:(Open_IXT)ե[%s]ץޤ\n", fname) ; 
    return (CFile *)NULL;
  }

  /* ȥ֥åɤ߹ */
  //lseek( fPtr->fd, 0L, 0 ) ;
  //read( fPtr->fd, cont, CBSIZE ) ;
  fseek( fPtr->fd, 0L, 0 ) ;
  fread( cont, 1, CBSIZE, fPtr->fd ) ;
  fPtr->flag = *(int *)&cont[0] ;
  fPtr->hmax = *(int *)&cont[24] ;
  fPtr->hsize = *(int *)&cont[28];
  fPtr->rbsz = *(int *)&cont[32] ;
  fPtr->rct = *(int *)&cont[36] ; /* Ǽ쥳ɣɣ */ 
  fPtr->curpt = NULL ;

  if ( ktype == 's' ) {
    if ( (fPtr->flag & STR_TYPE) == 0) {
      fprintf( stderr,"ERROR:(Open_IXT) פְäƤ\n");
      return NULL ;
    }
  }
  else if ( ktype == 'b' ) {
    if ( (fPtr->flag & BIN_TYPE) == 0) {
      fprintf( stderr,"ERROR:(Open_IXT) פְäƤ\n");
      return NULL ;
    }
  }
  else {
    fprintf( stderr,"ERROR:(Open_IXT) פְäƤ\n");
    return NULL ;
  }

  /* ե̾ꤹ */
  if ( ( fPtr->name = (unsigned char *)malloc(strlen(fname)+1) ) == NULL ){
    return (CFile *)NULL;
  }
  strcpy(fPtr->name, fname) ;
  /* fprintf( stderr, "Open [%s].\n",fPtr->name) ; */
  return fPtr ;
}



/**********************************************************
*   ***	ѥǥåե򥯥ؿ
*   USAGE:		Close_IXT( CFile *fp)
*   SYNOPSIS:		CFile  *fp  ե뼱̻ҥݥ
*   DESCRIPTION:	
*	ǥåե򥯥롣
*
*   RETURN:
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
void  Close_IXT( CFile *fp)
{
   if ( fp == NULL || fp->fd == NULL )
     return ;
   //close( fp->fd ) ;
   fclose( fp->fd ) ;
   free( fp->name ) ;
   free( fp ) ;
}



/**********************************************************
*   ***	ѥǥåե˳Ǽ뼡Υ쥳ֹ롣
*   USAGE:		Get_NewRecordNo( CFile *fp)
*   SYNOPSIS:           CFile  *fp  ե뼱̻ҥݥ
*
*   DESCRIPTION:	
*	ѥǥåեΥȥڡ鼡˳Ǽ
*     쥳ɤΣɣĤ롣
*
*   RETURN:		1ʾο
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int   Get_NewRecordNo( CFile *fPtr )
{
  unsigned char cont[CBSIZE];       /* ɤ߹ߥХåե */

  /* ȥ֥åɤ߹ */
  //lseek( fPtr->fd, 0L, 0 ) ;
  //read( fPtr->fd, cont, CBSIZE ) ;
  fseek( fPtr->fd, 0L, 0 ) ;
  fread( cont, 1, CBSIZE, fPtr->fd ) ;
  fPtr->rct = *(int *)&cont[36] ; /* Ǽ쥳ɣɣ */ 
  return ( fPtr->rct ) ;
}





/**********************************************************
*   ѥǥåե˥ǡϿؿ
*   USAGE:		Put_IXT( CFile *fp, char *key, int ksz, char *data, int size)
*   SYNOPSIS:		CFile  *fp   (IN)  ե뼱̻ҥݥ
*                       char      *key  (IN)  Ǽ֤륭
*                       int       ksz   (IN)  
*                       char      *data (IN)  Ǽǡ
*                       int       size  (IN)  Ǽǡ
*
*   DESCRIPTION:	
*	ѥǥåե˥ǡǼؿ
*
*   RETURN:		Ǽ֥åֹ : ｪλ
*                                    : ۾ｪλ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  Put_IXT(CFile *fp, char *key, int ksz, char *data, int size)
{
  unsigned char buff1[CBSIZE]; 
  unsigned char wk[2];
  char work[BSIZE] ;
  int   bp ;
  int   bno, cno, pno, nextp, tct ;
  unsigned int hid ;

  if ( size < 0 ) {
    fprintf( stderr,"ERROR:size of putdata < 0\n") ;
    return( -1 ) ;
  }
  hid = hash((unsigned char *)key,ksz,fp->flag,fp->hmax,fp->hsize) ;

  /* ǡγǼ֤η׻ */
  bno = ( hid / PTCOUNT ) * CBSIZE  ;
  //lseek( fp->fd, bno+CBSIZE , 0 ) ;
  //read( fp->fd, buff1, CBSIZE ) ;
  fseek( fp->fd, bno+CBSIZE , 0 ) ;
  fread( buff1, 1, CBSIZE, fp->fd ) ;
  pno = ( hid % PTCOUNT ) * 4;
  nextp = *(int *)&buff1[pno] ;
  if ( nextp == NULL) {                 /* Ͽ */
    cno = SetNewRecIXT(fp,key,ksz,data,size) ;
    *(int *)&buff1[pno] = cno ;         /* ȥ꡼֥å򹹿 */
    //lseek( fp->fd, bno+CBSIZE , 0 ) ;
    //write( fp->fd, buff1, CBSIZE ) ;
    fseek( fp->fd, bno+CBSIZE , 0 ) ;
    fwrite( buff1, 1, CBSIZE, fp->fd ) ;
    return cno ;
  }
  /*** TRACE COLLISION CHAIN & UPDATE DATA ***/
  bp = nextp ;
  while( nextp != NULL  ) {
    //lseek( fp->fd, nextp , 0 ) ;
    //read( fp->fd, &work[0], fp->rbsz ) ;
    fseek( fp->fd, nextp , 0 ) ;
    fread( &work[0], 1, fp->rbsz, fp->fd ) ;
    if ( CompKey(fp, key, ksz, work) == 0 ) { /*  */
      ReplRec(fp,key,ksz,data,size,nextp,work ) ;
      return ( nextp ) ;
    } 
    bp = nextp ;
    nextp = *(int *)&work[0] ;
  }
                            /* 쥳ɤɲ */
  cno = SetNewRecIXT(fp,key,ksz,data,size) ;
  *(int *)&work[0] = cno ;  /* COLLISION CHAIN κǸ³ */
  //lseek( fp->fd, bp , 0 ) ;
  //write(fp->fd, &work[0], fp->rbsz ) ;
  fseek( fp->fd, bp , 0 ) ;
  fwrite( &work[0], 1, fp->rbsz, fp->fd ) ;
  return ( cno ) ;
}




/**********************************************************
*   쥳ɤϿ(PUT_IXTʤɤؿ)
*   USAGE:		SetNewRecIXT(CFile *fp, char *key, int ksz, char *data, int size)
*   SYNOPSIS:           CFile     *fp   (IN)  ե뼱̻ҥݥ
*                       char      *key  (IN)  Ǽ֤륭
*                       int       ksz   (IN)  
*                       char      *data (IN)  Ǽǡ
*                       int       size  (IN)  ǡ
*
*   DESCRIPTION:	
*	ФͤǼƤʤˡܴؿϥ
*       롣
*       :ȥ֥åο֥åե꡼֥å
*          ͤ⹹롣
*
*   RETURN:		Ǽ         : ｪλ
*                                      : ۾ｪλ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  SetNewRecIXT(CFile  *fp,char *key, int ksz, char *data, int size)
{
  unsigned char cont[CBSIZE], buff[BSIZE]; 
  int   i, bct, rct, rlen, len, off;
  int   bno , sno, pno, nextp, ret ;
  int   brsize ;

  rlen = ksz + size + 6 ;       /* Ǽʥǡܥܥΰ */

  fseek( fp->fd, 0L, 0 ) ;      /* ȥ֥åɤ߹ */
  //read( fp->fd, cont, CBSIZE ) ;
  fread( cont, 1, CBSIZE, fp->fd ) ;

  sno = bno = *(int *)&cont[16] ;  /* ǡγǼ */
  pno = 0 ;
  len = brsize = fp->rbsz - 8 ;
  //printf("size=%d sno=%d bno=%d pno=%d\n",size,sno,bno,pno);

  fseek( fp->fd, bno, 0 ) ;         /* 쥳ɤγǼ */
  pno = NULL ;                      /* prior pointer */
  put4byte(rlen,&buff[4]) ;         /* record size */
  put2byte(ksz, &buff[8]) ;         /* key size */
  off = 6 ;
  for( i = 0 ; i < ksz ; ) {
    if ( (ksz - i) >= (brsize - off ) ) { /* ֥åκǸޤǥǼ */
      if ( size == 0 && (ksz - i) == (brsize - off ) )
         nextp = 0 ;
      else
        nextp = bno + fp->rbsz ;
      len = brsize - off ;
      ret = write_data(fp,buff,off,pno,key+i,len,nextp) ;
      pno = bno ;
      bno += fp->rbsz ;
      off = 0 ;
      i += len ;
      continue ;
    }
    len = ksz -i ;
    if ( size == 0 ) {
      ret = write_data(fp,buff,off,pno,key+i,len,0) ;
      pno = bno ;
      bno += fp->rbsz ;
      off = 0 ;
      i += len ;
      continue ;
    }
    memcpy( &buff[4+off], key+i, len ) ;
    off += len ;
    i += len ;
  }
  /* SET DATA (offǼ) */
  for( i = 0 ; i < size ; ) {
    if ( (size - i) > (brsize - off ) ) { /* ǡޤǳǼǤ */
      len = brsize - off ;
      nextp = bno + fp->rbsz ;
      ret = write_data(fp,buff,off,pno,data+i,len,nextp) ;
      pno = bno ;
      bno += fp->rbsz ;
      off = 0 ;
      i += len ;
      continue ;
    }
    len = size -i ;
    ret = write_data(fp,buff,off,pno,data+i,len,0) ;
    pno = bno ;
    bno += fp->rbsz ;
    off = 0 ;
    i += len ;
    continue ;
  }

  fseek( fp->fd, 0L, 0 ) ;      /* ȥ֥åɤ߹ */
  //read( fp->fd, cont, CBSIZE ) ;
  fread( cont, 1, CBSIZE, fp->fd ) ;
  *(int *)&cont[16] = bno ;     /* οϿ֥åֹ   */
  fp->rct = *(int *)&cont[36] ; /* Ǽ쥳ɣɣ */ 
  *(int *)&cont[36] = fp->rct+1 ;
  fseek( fp->fd, 0L, 0 ) ;      /* ȥ֥å񤭹 */
  //write( fp->fd, cont, CBSIZE ) ;
  fwrite( cont, 1, CBSIZE, fp->fd ) ;
  return sno ;
}



/**********************************************************
*   ֥åγǼ
*   USAGE:	        write_data(CFile *fp,char *buff,int off,int  pno,char *data, int len, int npo)
*   SYNOPSIS:           CFile *fp   (IN) ե뼱̻ҥݥ
*       		char  *buff (IN) Ǽǡåȥꥢ
*                       int   off   (IN) Ǽեå
*                       int   pno   (IN) ץ饤䡼ݥ
*                       char  *data (IN) Ǽǡ
*                       int   size  (IN) ǡ
*                       int   npo   (IN) ͥȥݥ
*
*   DESCRIPTION:	
*	ϥå󥰤̡ Collision¸ߤƤ
*       ˳쥳ɤǼ롣
*       :ȥ֥åο֥åե꡼֥å
*          ͤϹ롣
*
*   RETURN:		Ǽǡ : ｪλ
*                                  : ۾ｪλ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int   write_data(CFile *fp,unsigned char *buff,int off,int  pno,char *data, int len, int npo) 
{
  int  i ;

  *(int *)&buff[0] = pno ;
  memcpy( &buff[4+off], data, len ) ;
  for ( i = 4+off+len ; i < (fp->rbsz - 4)  ; i++ ) {   /*** KOBA for TEST ***/
    buff[i] = 0 ;
  }                                                     /*** KOBA For TEST ***/
  *(int *)&buff[fp->rbsz-4] = npo ;
  //write( fp->fd, buff, fp->rbsz ) ;
  fwrite( buff, 1, fp->rbsz, fp->fd ) ;
}






/**********************************************************
*   COLLISION CHAINΥӤ롣
*   USAGE:	        CompKey(CFile  *fp, char *key, int ksz, char *work)
*   SYNOPSIS:           CFile *fp   (IN) ե뼱̻ҥݥ
*            		char  *key  (IN) 
*                       int   ksz   (IN) 
*                       char  *work (IN) Ƭ֥å
*
*   DESCRIPTION:	
*	CollisionǷФ줿ǡƬ֥åȥӤ
*       η̤֤
*
*   RETURN:		             : 
*                       פ         : ʳ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  CompKey(CFile  *fp, char *key, int ksz, char *work)
{
  int  npo ,klen , i, off;
  char *cp, buff[BSIZE] ;
  int brsize ;
  int ret ;
  char *keystop ;
  char *st = key ;

  //printf("(CompKey) start!\n") ;
  brsize = fp->rbsz - 8 ;
  klen = get2byte(work+8) ;
  if ( ksz != klen ) {
    return -1 ;
  }
  cp = work ;
  off = 6 ;
  keystop = key+klen ;
  while( key < keystop) {
    if ( off >= brsize ) {
      npo = *(int *)(cp + fp->rbsz - 4) ;
      if ( npo == 0) {
        fprintf(stderr,"COLLISION CHANE ERROR!\n") ;
        fprintf(stderr,"key=[%s],ksz=%d\n",st,ksz) ;
        fprintf(stderr,"key_pt=%d stop=%d\n",key,keystop) ;
        return ( -1 ) ;
      }
      //lseek( fp->fd, npo, 0 ) ;
      //ret = read( fp->fd, buff, fp->rbsz ) ;
      fseek( fp->fd, npo, 0 ) ;
      ret = fread( buff, 1, fp->rbsz, fp->fd ) ;
      cp = buff ;
      off = 0 ;
    }
    if ( *key == *(cp+off+4) ) {
      key++ ;
      off++ ;
    }
    else {
      return ( -1 ) ;
    }
  }
  return 0 ;
}



/**********************************************************
*   COLLISION CHAINΥͿ줿ʸ˴ޤޤƤ뤫å롣
*   USAGE:	        SubCompKey(CFile  *fp, char *str, int ksz, char *work)
*   SYNOPSIS:           CFile *fp   (IN) ե뼱̻ҥݥ
*            		char  *str  (IN) Ϳ줿ʸ
*                       int   ksz   (IN) ʸ󥵥
*                       char  *work (IN) Ƭ֥å
*
*   DESCRIPTION:	
*	CollisionǷФ줿ǡΥͿ줿ʸӤ
*       ƬפǡΥ˴ޤޤƤϣ֤
*
*   RETURN:		פ            : 
*                                       : פ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  SubCompKey(CFile  *fp, char *str, int ksz, char *work)
{
  int  npo ,klen , i, off;
  char *cp, buff[BSIZE] ;
  int brsize ;
  int ret ;
  char *keystop ;

  //printf("(CompStr) start!\n") ;
  brsize = fp->rbsz - 8 ;
  klen = get2byte(work+8) ;
  if ( ksz < klen ) {
    return 0 ;
  }
  cp = work ;
  off = 6 ;
  keystop = str + klen ;
  while( str < keystop ) {
    if ( off >= brsize ) {
      npo = *(int *)(cp + fp->rbsz - 4) ;
      if ( npo == 0) {
        fprintf(stderr,"COLLISION CHANE ERROR!\n") ;
        return ( 0 ) ;
      }
      //lseek( fp->fd, npo, 0 ) ;
      //ret = read( fp->fd, buff, fp->rbsz ) ;
      fseek( fp->fd, npo, 0 ) ;
      ret = fread( buff, 1, fp->rbsz, fp->fd ) ;
      cp = buff ;
      off = 0 ;
    }
    if ( *str == *(cp+off+4) ) {
      str++ ;
      off++ ;
    }
    else {
      return ( 0 ) ;
    }
  }
  return klen ;
}






/**********************************************************
*   COLLISION CHAIN˥󥯤Ƥ쥳ɤؤ롣
*   USAGE:	        ReplRec(CFile  *fp, char *key, int ksz, char *data, int size, int curp, char *work)
*   SYNOPSIS:           CFile     *fp   (IN)  ե뼱̻ҥݥ
*            		char      *key  (IN) 
*                       int       ksz   (IN) 
*                       char      *data (IN) 쥳
*                       int       size  (IN) 쥳ɥ
*                       int       curp  (IN) 쥳ɤƬ֥åγǼ
*                       char      *work (IN) Ƭ֥å
*
*   DESCRIPTION:	
*	ꤵ줿CollisionǷФ줿쥳ɤ򿷵ǡ
*       ؤ롣ȥ֥åѹϡ
*       ֥å񤭴롣
*
*   RETURN:		ｪλ: ǼƬ֥åֹ
*                       ۾ｪλ: ο
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  ReplRec(CFile  *fp, char *key, int ksz, char *data, int size, int curp, char *work)
{
  int  rlen, nlen, klen ;     
  int  obct, nbct ;
  int  i, kb , npt, cpt, ppt, snpt, off, len;
  char buff[BSIZE] ;
  int  *ipt, newpt[1024] ,nct ;
  int  brsize ;
  int  mallen, maxct ;

  brsize = fp->rbsz - 8 ;   /* ǡǼ֥åХȿ */

  nlen = ksz + size + 6 ;   /* ǡγǼХȿ */
  nbct = nlen / brsize ;    /* ǡγǼ֥å */
  if ( ( nlen % brsize) != 0 )
    nbct++ ;          
  rlen = get4byte( &work[4] ) ; /* ǡ̾Ĺ */
  obct = rlen / brsize ;        /* ǡǼ֥å */
  if ( ( rlen % brsize) != 0 )
    obct++ ;
  //printf("nbct=%d  obct=%d\n", nbct, obct) ;
  if ( obct >= nbct ) maxct = obct ; /* ǧ */
  else maxct = nbct ;
  if ( maxct <= 1024 ) {
    maxct = 1024 ;
    ipt = &newpt[0] ;
  }
  else {
    maxct = ((maxct / 1024) + 1 ) * 1024 ;
    mallen = maxct * sizeof(int) ;
    if ( (ipt = (int *)malloc( mallen ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return -1 ;
    }
  }
                   /* ǡǼƤ֥åΥꥹȤ  */
  nct = CurBlockList( fp, curp, ipt, maxct ) ;
  if ( nct == 0 ) {
    fprintf( stderr,"ERROR:KEY[%s] ǡƤ\n",key) ;
    obct = 0 ;
  }
                      /* ǡγǼꥢ;ʬɬפå */
  if ( nbct > obct ) { /* ꥢ(ȥ֥å) */
    i = GetBlock( fp, nbct - obct, ipt+nct, maxct-nct ) ;
    if ( i != (nbct - obct) ) {
      fprintf(stderr,"ERROR:ǡν񤭹ߤ˼!\n") ;
      fprintf(stderr,"ERROR:ɬפʥ֥å %d!\n",nbct) ;
      if ( maxct > 1024 ) 
        free( (char *)ipt ) ;
      return ( -1 ) ;
    }
    nct += i ;
  }
  klen = get2byte( &work[8] ) ;
  put4byte( nlen, &work[4]) ;  /* 쥳Ĺ  */
  //lseek( fp->fd, curp, 0 ) ;
  //write( fp->fd, work, fp->rbsz ) ;
  fseek( fp->fd, curp, 0 ) ;
  fwrite( work, 1, fp->rbsz, fp->fd ) ;

  if ( klen > (brsize - 6) ) { /* ʬ򥹥å */
    off = ( klen + 6 ) % brsize ;
    kb = ( klen + 6 ) / brsize ;
    //lseek( fp->fd, *(ipt + kb), 0 ) ;
    //read( fp->fd, buff, fp->rbsz ) ;
    fseek( fp->fd, *(ipt + kb), 0 ) ;
    fread( buff, 1, fp->rbsz, fp->fd ) ;
  }
  else {
    off = klen + 6 ;
    memcpy(buff,work,fp->rbsz) ;
    kb = 0 ;
  }
  ppt = *(int *)buff ;
  if ( size == 0 ) {           /* Ǽ */
    *(int *)(buff + fp->rbsz - 4) = 0 ;  /* Next Pointer NULL */
    //lseek( fp->fd, *(ipt + kb), 0 ) ;
    //write( fp->fd, buff, fp->rbsz ) ;
    fseek( fp->fd, *(ipt + kb), 0 ) ;
    fwrite( buff, 1, fp->rbsz, fp->fd ) ;
    if ( ( kb + 1) <  nct ) { /* ;ä֥åե꡼ꥹȤϿ */
      SetFreeBlock(fp, ipt+kb+1, nct - kb -1 ) ;
    }
    if ( maxct > 1024 ) 
      free( (char *)ipt ) ;
    return curp ;
  }

  for( i = 0  ; i < size ; i += len ) {   /* ǡʬγǼ */
    //printf(" size = %d brsize=%d off=%d: cpt=%x(%o)\n",size,brsize,off,*(ipt+kb),*(ipt+kb)) ;       
    //lseek( fp->fd, *(ipt+kb), 0 ) ;
    fseek( fp->fd, *(ipt+kb), 0 ) ;
    if ( kb == ( nct -1 ) ) {        /* set next pointer */
      len = size -i ;             /* ǸΥ֥å */
      snpt = NULL ;
    }
    else {
      snpt = *(ipt +kb +1) ;         /* ޤǤΥǡǼ */
      len = brsize - off ;
    }
    write_data(fp,buff,off,ppt,data+i,len,snpt) ;
    ppt = *(ipt+kb) ;
    off = 0 ;
    kb++ ;
  }
  /* ;ä֥åե꡼ꥹȤϿ */
  if ( (kb + 1) < nct ) { /* ;ä֥åե꡼ꥹȤϿ */
    SetFreeBlock(fp, ipt +kb +1, nct - kb -1 ) ;
  }
  if ( maxct > 1024 ) 
    free( (char *)ipt ) ;

  return curp ;
}













int SetFreeBlock(CFile  *fp, int *freept, int freeblockct )
{
   /* ֥åֹΥꥹȤ˳Ǽ줿ͤե꡼֥å
      ꥹȤϿ롣 */



  return ( 1 ) ;
}





int MoveFreeBlock(CFile *fp, int nextp ) 
{
   /* ǡΥ򤿤ɤʤ顢ե꡼֥åꥹȤ
      Ͽ */



}




/**********************************************************
*   ǡǼ뤿ɬפʬΥ֥åݤ롣
*   USAGE:	        GetBlock(CFile  *fp, int gct, int *newpt, int size)
*   SYNOPSIS:           CFile  *fp      (IN) ե뼱̻ҥݥ
*                       int       gct   (IN) ɬפȤ֥å
*                       int      *newpt (OUT)ݤ줿֥åΥ֥åֹǼ
*                       int       size  (IN) ֥åֹǼ礭
*
*   DESCRIPTION:	
*	ǡǼ֥åꤵ줿ݤ롣
*
*   RETURN:		ｪλ: ݤǤ֥å
*                       ۾ｪλ: ο
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int GetBlock(CFile  *fp, int gct, int *newpt, int nsize )
{
  int nct, sno, ret;
  char cont[CBSIZE] ;

  if ( gct > nsize ) {
    fprintf( stderr,"ERROR:(GetBlock)NewBloctPointerArea is too small!\n") ;
    fprintf( stderr,"           GetCount = %d size=%d\n",gct,nsize) ;
    return ( -1 ) ;
  }
  fseek( fp->fd, 0L, 0 ) ;        /* Control block read */
  //read( fp->fd, cont, CBSIZE ) ;
  fread( cont, 1, CBSIZE, fp->fd ) ;
  sno = *(int *)&cont[16] ;       /* ǡγǼ */
  for( nct = 0 ; nct < gct ; nct++) {
    *newpt = sno ;
    newpt++ ;
    fseek( fp->fd, sno, 0 ) ;     /* 쥳ɤγǼ */
    //ret = write( fp->fd, cont, fp->rbsz ) ;
    ret = fwrite( cont, 1, fp->rbsz, fp->fd ) ;
    if ( ret != fp->rbsz) {
      fprintf( stderr,"ERROR:(GetBlock)Write error!\n") ;
      return ( -1 ) ;
    }
    sno += fp->rbsz ;
  }
  *(int *)&cont[16] = sno ;
  //lseek( fp->fd, 0L, 0 ) ;
  //write(fp->fd, cont, CBSIZE ) ;
  fseek( fp->fd, 0L, 0 ) ;
  fwrite( cont, 1, CBSIZE, fp->fd ) ;
  return nct ;
}






/**********************************************************
*   ǡǼ֥å򣱤ĳݤ롣
*   USAGE:	        GetBlock1(CFile  *fp)
*   SYNOPSIS:           CFile  *fp      (IN) ե뼱̻ҥݥ
*
*   DESCRIPTION:	
*	ǡǼ֥å򣱤ĳݤΥ֥åֹ֤
*
*   RETURN:		ｪλ: ݤǤ֥å
*                       ۾ｪλ: ο
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int GetBlock1( CFile  *fp )
{
  int nct, sno, ret, rno ;
  char cont[CBSIZE] ;


  fseek( fp->fd, 0L, 0 ) ;        /* Control block read */
  //read( fp->fd, cont, CBSIZE ) ;
  fread( cont, 1, CBSIZE, fp->fd ) ;
  rno = sno = *(int *)&cont[16] ;       /* ǡγǼ */
  fseek( fp->fd, sno, 0 ) ;     /* 쥳ɤγǼ */
  //ret = write( fp->fd, cont, fp->rbsz ) ;
  ret = fwrite( cont, 1, fp->rbsz, fp->fd ) ;
  if ( ret != fp->rbsz) {
    fprintf( stderr,"ERROR:(GetBlock)Write error!\n") ;
    return ( -1 ) ;
  }
  sno += fp->rbsz ;

  *(int *)&cont[16] = sno ;
  //lseek( fp->fd, 0L, 0 ) ;
  //write(fp->fd, cont, CBSIZE ) ;
  fseek( fp->fd, 0L, 0 ) ;
  fwrite( cont, 1, CBSIZE, fp->fd ) ;
  return rno ;
}



/**********************************************************
*   ǡγǼ˻ѤƤ֥å롣
*   USAGE:	        CurBlockList(CFile  *fp, int cur, int *newpt, int size)
*   SYNOPSIS:           CFile  *fp      (IN) ե뼱̻ҥݥ
*                       int       cur   (IN) ǡǼƤƬ֥å
*                       int      *newpt (OUT)ݤ줿֥åΥ֥åֹǼ
*                       int       size  (IN) ֥åֹǼ礭
*
*   DESCRIPTION:	
*	ǡγǼ˻ѤƤ֥åƵ롣
*
*   RETURN:		ｪλ: ݤǤ֥å
*                       ۾ｪλ: ο
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int CurBlockList(CFile  *fp, int cur, int *newpt, int nsize )
{
  int nct = 0 ;
  char buff[BSIZE] ;
  int *sp = newpt ;

  while( cur != NULL) {
    if ( nct >= nsize ) {
      fprintf( stderr, "ERROR(CurBlockList): OutBuffer is too small!\n") ;
      fprintf( stderr, "ERROR(CurBlockList): maxsize=%d!\n", nsize) ;
      *sp = NULL ;
      return 0 ;
    }
    *newpt = cur ;
    newpt++ ; nct++ ;
    //lseek( fp->fd, cur, 0) ;
    //read( fp->fd, buff, fp->rbsz ) ;
    fseek( fp->fd, cur, 0) ;
    fread( buff, 1, fp->rbsz, fp->fd ) ;
    cur = *(int *)(buff + fp->rbsz - 4) ;
    //printf("nct=%d cur=%x\n", nct, cur) ;
  }
  *newpt = NULL ; 
  return nct ;  
}




/**************** GET ********************************************/
/**********************************************************
*   ǥХ塼롣
*   USAGE:	        Get_IXT(CFile  *fp, char *key, int ksz, char *val, int size)
*   SYNOPSIS:           CFile  *fp    (IN)  ե뼱̻ҥݥ
*            		char      *key   (IN)  
*            		int       ksz    (IN)  Υ
*                       char      *val   (OUT) ϥǡåȥꥢ
*                       int       size   (IN)  ϥǡåȥꥢ
*
*   DESCRIPTION:	
*	Υ쥳ɤ򸡺֤ͤ
*       ʴס
*
*   RETURN:		Х塼ʥ쥳ɡĹ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  Get_IXT(CFile  *fp, char *key, int ksz, char *val, int  size)
{
  unsigned char  buff[BSIZE];       /* ɤ߹ߥХåե */
  int  hid ;
  int  bno, pno, nextp ;
  int  bp, off, ret ;

  /* printf("key[%s] ksz=%d\n",key,ksz) ; */
  hid = hash((unsigned char *)key,ksz,fp->flag,fp->hmax,fp->hsize) ;
  /* ǡγǼ֤η׻ */
  bno = ( hid / PTCOUNT ) * CBSIZE  ;
  //lseek( fp->fd, bno+CBSIZE , 0 ) ;
  //read( fp->fd, buff, CBSIZE ) ;
  fseek( fp->fd, bno+CBSIZE , 0 ) ;
  fread( buff, 1, CBSIZE, fp->fd ) ;
  pno = ( hid % PTCOUNT ) * 4;
  nextp = *(int *)&buff[pno] ;
  if ( nextp == NULL) {              
    *val = '\0' ;
    return 0 ;
  }
  /*** TRACE COLLISION CHAIN & UPDATE DATA ***/
  bp = nextp ;
  while( nextp != NULL  ) {
    //lseek( fp->fd, nextp , 0 ) ;
    //read( fp->fd, &buff[0], fp->rbsz ) ;
    fseek( fp->fd, nextp , 0 ) ;
    fread( &buff[0], 1, fp->rbsz, fp->fd ) ;
    if ( CompKey(fp, key, ksz, buff) == 0 ) { /*  */
      ret = get_rec(fp,nextp,buff,val,size ) ;
      return ( ret ) ;
    } 
    bp = nextp ;
    nextp = *(int *)&buff[0] ;
  }
  *val = '\0' ;
  return 0 ;
}





int get_rec(CFile *fp,int nextp, char *work, char *val, int size)
{
  int  npo ,rlen, klen , i, off;
  char *cp, buff[BSIZE] ;
  int brsize, rix, rsize ;
  int  to, kb, npt, skip, cpt ;
  int  len, ret ;

  brsize = fp->rbsz - 8 ;     /* ¥쥳ɥ */
  rlen = get4byte(work+4) ;   /* 쥳Ĺ */
  klen = get2byte(work+8) ;   /*  */
  if ( size < (rlen - klen -6) ) {
    fprintf(stderr,"ERROR(get_rec):OutputBuffer is too small!\n" ) ;
    fprintf(stderr,"         size=%d   rlen=%d klen=%d\n",size,rlen,klen) ;
    *val = '\0' ;
    return -1 ;
  }
  cp = work ;
  if ( klen > (brsize - 6) ) {
    off = ( klen + 6 ) % brsize ; /* ǡǼ׻ */
    kb = ( klen + 6 ) / brsize ;
    if ( off == 0 ) {
      kb-- ;
      off = brsize ;
    }
    npt = *(int *)&work[fp->rbsz - 4] ;
    for( i=0  ; i < kb ; i++ ) {
      cpt = npt ;
      //lseek( fp->fd, npt, 0 ) ;
      //read( fp->fd, buff, fp->rbsz ) ;
      fseek( fp->fd, npt, 0 ) ;
      fread( buff, 1, fp->rbsz, fp->fd ) ;
      npt = *(int *)&buff[fp->rbsz - 4] ;
      cp = buff ;
    }
  }
  else {
    off = klen + 6 ;
    npt = *(int *)(work + fp->rbsz - 4) ;
  }
  /* SET DATA (offǼ) */
            /*  npt : next_block_no,  cpt : current_block_no */
  if ( rlen - klen - 6 == 0 ) {
    *val = *(val+1) = *(val+2) = *(val+3) = 0 ;
    return 0 ;
  }
  else {       
    rix = 0 ;
    rsize = rlen - klen - 6 ;
    for( i = 0 ; i <  rsize ; ) {
      to = rsize - i ;
      if ( to >= (brsize - off) ) {
        len = brsize - off ;
      }
      else {
        len = to ;
      }
      memcpy( (val+rix), cp+4+off, len ) ;
      rix += len ;
      npt =  *(int *)(cp + fp->rbsz - 4) ;
      i += len ;
      off = 0 ;
      if ( npt != NULL) {
        //lseek( fp->fd, npt, 0 ) ;
        //ret = read( fp->fd, buff, fp->rbsz) ;
        fseek( fp->fd, npt, 0 ) ;
        ret = fread( buff, 1, fp->rbsz, fp->fd ) ;
        cp = buff ;
        //printf("read ret=%d:pt(%o)=>:work[4]=%x,%x,%x,%x\n",ret,npt,cp+4,cp+5,cp+6,cp+7) ;
      }
    }
  }
  *(val+rix) = '\0' ;
  return rix ;
}






/**********************************************************
*   ǥХ塼Ĺ롣
*   USAGE:	        Get_DataLeng(CFile  *fp, char *key, int ksz)
*   SYNOPSIS:           CFile     *fp    (IN)  ե뼱̻ҥݥ
*            		char      *key   (IN)  
*            		int       ksz    (IN)  Υ
*
*   DESCRIPTION:	
*	Υ쥳ɤ򸡺ΥǡΥХĹ֤
*       ʴס
*
*   RETURN:		Х塼ʥ쥳ɡĹ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  Get_DataLeng(CFile  *fp, char *key, int ksz)
{
  unsigned char  buff[BSIZE];       /* ɤ߹ߥХåե */
  int  rlen, klen, ret ;
  int  bno ;

  bno = Search_IXS( fp, key, ksz, buff) ;
  if ( bno < 0)
    return 0 ;
  rlen = get4byte( &buff[4] ) ;   /* 쥳Ĺ */
  klen = get2byte( &buff[8] ) ;   /*  */
  ret = rlen - klen - 6  ;
  return ret ;
}



/**********************************************************
*   оݤΥ쥳ɤγǼƤ֥å롣
*   USAGE:	        Search_IX(CFile  *fp, char *key, int ksz, char *bd)
*   SYNOPSIS:           CFile     *fp    (IN)  ե뼱̻ҥݥ
*            		char      *key   (IN)  ʸ
*            		int       ksz    (IN)  ʸΥ
*                       char      *bd    (OUT) ǡ֥åɤ߹ߥꥢ
*
*   DESCRIPTION:	
*	Ϳ줿Υ쥳ɤǼƤ֥å
*     롣
*       ǡγǼ֥åֹ椬꥿󤵤졢ǡ֥åɤ߹
*     ꥢˤϡǼƤƬ֥ååȤ롣
*       ǡ֥åɤ߹ߥꥢ礭ϡȥ֥å
*     ǡ֥å礭ͤǤʤФʤ餢ʤ
*
*   RETURN:		ｪλ:ǡγǼ֥åֹ
*                       ۾ｪλʳǡ¸ߤʤ: -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  Search_IXS(CFile  *fp, char *key, int ksz, char *bd)
{
  int  hid ;
  int  bno, pno, nextp ;
  int  bp, off, ret ;

  hid = hash((unsigned char *)key,ksz,fp->flag,fp->hmax,fp->hsize) ;
  /* ǡγǼ֤η׻ */
  bno = ( hid / PTCOUNT ) * CBSIZE  ;
  //lseek( fp->fd, bno+CBSIZE , 0 ) ;
  //read( fp->fd, bd, CBSIZE ) ;
  fseek( fp->fd, bno+CBSIZE , 0 ) ;
  fread( bd, 1, CBSIZE, fp->fd ) ;
  pno = ( hid % PTCOUNT ) * 4;
  nextp = *(int *)(bd + pno) ;
  if ( nextp == NULL) {              
    return -1 ;
  }
  /*** TRACE COLLISION CHAIN & UPDATE DATA ***/
  bp = nextp ;
  while( nextp != NULL  ) {
    //lseek( fp->fd, nextp , 0 ) ;
    //read( fp->fd, bd, fp->rbsz ) ;
    fseek( fp->fd, nextp , 0 ) ;
    fread( bd, 1, fp->rbsz, fp->fd ) ;
    if ( CompKey(fp, key, ksz, bd) == 0 ) { /*  */
      return ( nextp ) ;
    } 
    bp = nextp ;
    nextp = *(int *)bd ;
  }
  return -1 ;
}





/****************************************************************/
int  Add_IXT_B( CFile  *fp, char *key, int keysz, int Rid ) 
{
  char work[8192] ;
  int  ret, len ;

  len = Get_IXT( fp, key, keysz, work, 8192) ;
  if ( len < 0 ) {
    return 0 ;
  }
  ret = add_bin4( Rid, work, len) ;
  ret = Put_IXT( fp, key, keysz, work, ret ) ;
  return ret ;
}
/****************************************************************/



/**********************************************************
*   byteХ塼ΥꥹȤ˿ʣbyteХ塼ɲä롣
*   USAGE:	        Add_IXT_DATA(CFile  *fp, char *key, int ksz, char *val, int vsz)
*   SYNOPSIS:           CFile     *fp    (IN)  ե뼱̻ҥݥ
*            		char      *key   (IN)  
*            		int       ksz    (IN)  Υ
*                       char      *val   (IN)  Ǽǡ
*            		int       vsz    (IN)  ǼǡΥ
*
*   DESCRIPTION:	
*     ФơĹʣByteBinaryˤΥǡɲϿ롣
*     ǼƤͤϡNХ塼ñ̤˳ǼƤ롣
*
*   RETURN:		¸ߤƤ: 1
*                       ʤɲä: 2
*                       ۾ｪλ        : -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  Add_IXT_DATA( CFile  *fp, char *key, int keysz, char *val, int vsz) 
{
  unsigned char  buff[BSIZE];       /* ɤ߹ߥХåե */
  int  ret , ret2, dsz, len ;
  int  bno ;
  int  rlen ;
  char wk[8192] , *workp ;

  bno = Search_IXS( fp, key, keysz, buff) ;
  if ( bno < 0 ) {                  /* 쥳ɤ¸ߤʤ */
    ret = Put_IXT( fp, key, keysz, val, vsz ) ;
    return ret ;
  }
  rlen = get4byte(buff+4) ;   /* 쥳Ĺ */
  len = rlen + vsz ;
  if ( len > 8192 ) {
    ret = len / 4096 ;
    len = ( ret +1 ) * 4096 ;
    if ( (workp = (unsigned char *)malloc( len ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return -1 ;
    }
  }
  else {
    workp = &wk[0] ;
    len = 8192 ;
  }
  dsz = get_rec( fp, bno, buff, workp, len ) ; /* ǡʬ򥲥å */
  ret = add_binn( val, vsz, workp, dsz) ;
  if ( ret == 2 ) {
    ret2 = Put_IXT( fp, key, keysz, workp, dsz+vsz ) ;
  }

  if ( len > 8192 ) 
     free(workp) ;

  return ret ;
}






/**********************************************************
*   Х塼롣
*   USAGE:	        Rem_IXT_DATA(CFile  *fp, char *key, int ksz, char *val, int vsz)
*   SYNOPSIS:           CFile     *fp    (IN)  ե뼱̻ҥݥ
*            		char      *key   (IN)  
*            		int       ksz    (IN)  Υ
*                       char      *val   (IN)  ͳǼݥ
*            		int       vsz    (IN)  ͤΥ
*
*   DESCRIPTION:	
*     ФơĹʣByteBinaryˤΥǡʣϿ
*   Ƥ롣椫顢Х塼롣
*
*   RETURN:		ｪλ : 1
*                       ǡ¸ߤ: 0
*                       ۾ｪλ : -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  Rem_IXT_DATA( CFile  *fp, char *key, int keysz, char *val, int vsz) 
{
  unsigned char  buff[BSIZE];       /* ɤ߹ߥХåե */
  int  ret , ret2, dsz, len ;
  int  bno ;
  int  rlen ;
  char wk[8192] , *workp ;

  // printf("KEY=[%s]\n",key) ;
  bno = Search_IXS( fp, key, keysz, buff) ;
  if ( bno < 0 ) {                  /* 쥳ɤ¸ߤʤ */
    return 0 ;
  }

  rlen = get4byte(buff+4) ;   /* 쥳Ĺ */
  len = rlen + vsz ;
  if ( len > 8192 ) {
    if ( (workp = (unsigned char *)malloc( len ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return -1 ;
    }
  }
  else {
    workp = &wk[0] ;
    len = 8192 ;
  }
  dsz = get_rec( fp, bno, buff, workp, len ) ; /* ǡʬΥå */
  ret = rem_binn( val, vsz, workp, dsz) ;
  if ( ret == 1 ) {     /* 쥳ɥХ塼ʬ︺ */
    ret2 = Put_IXT( fp, key, keysz, workp, dsz-vsz ) ;
  }

  if ( len > 8192 ) 
     free(workp) ;
  // printf("(Rem_IXT_DATA) ret = %d\n",ret) ;
  return ret ;
}







/**********************************************************
*   byteХ塼ΥꥹȤ˿ʣbyteХ塼ɲä롣
*   USAGE:	        Add_IXT_DATA2(CFile  *fp, char *key, int ksz, char *val, int vsz)
*   SYNOPSIS:           CFile     *fp    (IN)  ե뼱̻ҥݥ
*            		char      *key   (IN)  
*            		int       ksz    (IN)  Υ
*                       char      *val   (IN)  Ǽǡ
*            		int       vsz    (IN)  ǼǡΥ
*
*   DESCRIPTION:	
*     ФơĹʣByteBinaryˤΥǡɲϿ롣
*     ǼƤͤϡNХ塼ñ̤˳ǼƤ롣
*
*   RETURN:		¸ߤƤ: 1
*                       ʤɲä: 2
*                       ۾ｪλ        : -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  Add_IXT_DATA2( CFile  *fp, char *key, int keysz, char *val, int vsz) 
{
  unsigned char  buff[BSIZE];       /* ɤ߹ߥХåե */
  int  ret , len ;
  int  bno ;

  //printf("KEY=[%s]\n",key) ;
  bno = Search_IXS( fp, key, keysz, buff) ;
  if ( bno < 0 ) {                  /* 쥳ɤ¸ߤʤ */
    ret = Put_IXT( fp, key, keysz, val, vsz ) ;
    return ret ;
  }
  ret = add_bin_datablock( fp, bno, buff, val, vsz) ;
  if ( ret == 2 ) {                 /* 쥳ɥХ塼ʬɲ */
    len = get4byte( &buff[4] ) ;
    put4byte( len + vsz, &buff[4] ) ;
    //lseek( fp->fd, bno, 0 ) ;
    //write( fp->fd, buff, fp->rbsz ) ;
    fseek( fp->fd, bno, 0 ) ;
    fwrite( buff, 1, fp->rbsz, fp->fd ) ;
  }
  return ret ;
}




/* Ĺǡ֤ǼƤ쥳ɤκǸɲä */
int add_bin_datablock(CFile *fp, int  cbn, char *work, char *val, int vsz)
{
  int   npo ,dlen, rlen, klen , ii, off;
  char *cp, *vp, buff[BSIZE] ;
  int   brsize, rix, rsize ;
  int  to, kb, cpt, npt, skip ;
  int  len, ret ;

  cpt = cbn ;
  brsize = fp->rbsz - 8 ;     /* ǡǼ֥å */
  rlen = get4byte(work+4) ;   /* 쥳Ĺ */
  klen = get2byte(work+8) ;   /*  */
  cp = work ;
  if ( klen > (brsize - 6) ) {/* ֥åڤʤ */
    off = ( klen + 6 ) % brsize ; /* ǡǼ׻ */
    kb = ( klen + 6 ) / brsize ;
    if ( off == 0 ) {
      kb-- ;
      off = brsize ;
    }
    npt = *(int *)&work[fp->rbsz - 4] ;
    for( ii=0  ; ii < kb ; ii++ ) {
      cpt = npt ;
      //lseek( fp->fd, npt, 0 ) ;
      //read( fp->fd, buff, fp->rbsz ) ;
      fseek( fp->fd, npt, 0 ) ;
      fread( buff, 1, fp->rbsz, fp->fd ) ;
      npt = *(int *)&buff[fp->rbsz - 4] ;
      cp = buff ;
    }
  }
  else {
    off = klen + 6 ;
    npt = *(int *)(work + fp->rbsz - 4) ;
  }
  /* CHECK DATA (off4byteŤ) */
  dlen = rlen - klen - 6 ;
  while( dlen != 0 ) {  /*  npt : next_block_no,  cpt : current_block_no */
    vp = val ;
    for( ii = 0 ; ii < vsz  ; ii++ ) {
      if ( off >= brsize ) {
        cpt = npt ;
        //lseek( fp->fd, npt, 0 ) ;
        //read( fp->fd, buff, fp->rbsz ) ;
        fseek( fp->fd, npt, 0 ) ;
        fread( buff, 1, fp->rbsz, fp->fd ) ;
        npt = *(int *)&buff[fp->rbsz - 4] ;
        cp = buff ;
        off = 0 ;
      }
      if ( *vp != *(cp + off + 4) )
        break ;
      vp++ ;
      off++ ;
    }
    if ( ii == vsz ) {  /* ǡꡪ */
      return 1 ;
    }
    dlen -= vsz ;
    off += ( vsz - ii ) ;
    while ( off > brsize ) {
      cpt = npt ;
      //lseek( fp->fd, npt, 0 ) ;
      //read( fp->fd, buff, fp->rbsz ) ;
      fseek( fp->fd, npt, 0 ) ;
      fread( buff, 1, fp->rbsz, fp->fd ) ;
      npt = *(int *)&buff[fp->rbsz - 4] ;
      cp = buff ;
      off -= brsize ;
    }
  }
  /* ͤɲ */ 
  vp = val ;
  for( ii = 0 ; ii < vsz  ; ii++ ) {
    if ( off >= brsize ) {
      npt = GetBlock1( fp ) ;
      //lseek( fp->fd, cpt, 0 ) ;
      fseek( fp->fd, cpt, 0 ) ;
      put4byte( npt, cp + (fp->rbsz) - 4 ) ;
      //write( fp->fd, cp, fp->rbsz ) ;
      fwrite( cp, 1, fp->rbsz, fp->fd ) ;

      /*** KOBA  for TEST ***/
      for( to = 0 ; to < BSIZE ; to++ ) {  /*** KOBA  for TEST ***/
        buff[to] = 0 ;                       /*** KOBA  for TEST ***/
      }/*** KOBA  for TEST ***/               /*** KOBA  for TEST ***/

      put4byte( cpt, &buff[0] ) ;
      cpt = npt ;
      npt = NULL ;
      cp = buff ;
      off = 0 ;
    }
    *(cp + 4 + off) = *vp ;
    off++ ;
    vp++ ;
  }
  //lseek( fp->fd, cpt, 0 ) ;
  fseek( fp->fd, cpt, 0 ) ;
  put4byte( NULL, cp + (fp->rbsz) - 4 ) ;
  //write( fp->fd, cp, fp->rbsz ) ;
  fwrite( cp, 1, fp->rbsz, fp->fd ) ;
  return 2 ;
}





/**********************************************************
*   ĹХ塼ꥹȤ˿ʥХ塼ɲä롣
*   USAGE:	        Add_IXT_DATAV(CFile  *fp, char *key, int ksz, char *val, int vsz)
*   SYNOPSIS:           CFile     *fp    (IN)  ե뼱̻ҥݥ
*            		char      *key   (IN)  
*            		int       ksz    (IN)  Υ
*                       char      *val   (IN)  Ǽǡ
*            		int       vsz    (IN)  ǼǡΥ
*
*   DESCRIPTION:	
*     ФơʸʲĹˤʣ³ƳǼƤ
*     쥳ɤκǸ˿ʥǡɲϿ롣
*    ա
*     ǼƤͤϡʸǥȥåѡ('\0')ɬפȤ롣
*
*   RETURN:		ｪλ        : 1
*                       ۾ｪλ        : -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  Add_IXT_DATAV( CFile  *fp, char *key, int keysz, char *val, int vsz) 
{
  unsigned char  buff[BSIZE];       /* ɤ߹ߥХåե */
  int  ret , len ;
  int  bno ;

  //printf("KEY=[%s]\n",key) ;
  bno = Search_IXS( fp, key, keysz, buff) ;
  if ( bno < 0 ) {                  /* 쥳ɤ¸ߤʤ */
    ret = Put_IXT( fp, key, keysz, val, vsz ) ;
    return ret ;
  }
  ret = add_str_datablock( fp, bno, buff, val, vsz) ;
  if ( ret > 0 ) {                  /* 쥳ɥХ塼ʬɲ */
    len = get4byte( &buff[4] ) ;
    put4byte( len + vsz, &buff[4] ) ;
    //lseek( fp->fd, bno, 0 ) ;
    //write( fp->fd, buff, fp->rbsz ) ;
    fseek( fp->fd, bno, 0 ) ;
    fwrite( buff, 1, fp->rbsz, fp->fd ) ;
  }
  return ret ;
}

/* ĹǡΥ쥳ɤκǸɲä */
int add_str_datablock(CFile *fp, int  cbn, char *work, char *val, int vsz)
{
  int   npo ,dlen, rlen, ii, off;
  char *cp, *vp, buff[BSIZE] ;
  int   brsize, rix, rsize ;
  int  to, kb, cpt, npt, skip ;
  int  len, ret ;

  cpt = cbn ;
  brsize = fp->rbsz - 8 ;     /* ǡǼ֥å */
  rlen = get4byte(work+4) ;   /* 쥳Ĺ */
  cp = work ;
  if ( rlen > brsize ) {/* 쥳ɤ֥åäƤʤ */
    off = rlen % brsize ; /* ǡǼΥեåȤ׻ */
    kb = rlen / brsize ;
    if ( off == 0 ) {
      kb-- ;
      off = brsize ;
    }
    npt = *(int *)&work[fp->rbsz - 4] ;
    for( ii=0  ; ii < kb ; ii++ ) {
      cpt = npt ;
      //lseek( fp->fd, npt, 0 ) ;
      //read( fp->fd, buff, fp->rbsz ) ;
      fseek( fp->fd, npt, 0 ) ;
      fread( buff, 1, fp->rbsz, fp->fd ) ;
      npt = *(int *)&buff[fp->rbsz - 4] ;
      cp = buff ;
    }
  }
  else {
    off = rlen ;
    npt = *(int *)(work + fp->rbsz - 4) ;
  }
  /* ͤɲ */ 
  vp = val ;
  for( ii = 0 ; ii < vsz  ; ii++ ) {
    if ( off >= brsize ) {
      npt = GetBlock1( fp ) ;
      //lseek( fp->fd, cpt, 0 ) ;
      fseek( fp->fd, cpt, 0 ) ;
      put4byte( npt, cp + (fp->rbsz) - 4 ) ;
      //write( fp->fd, cp, fp->rbsz ) ;
      fwrite( cp, 1, fp->rbsz, fp->fd ) ;

      /*** TEST
      for( to = 0 ; to < BSIZE ; to++ ) { 
        buff[to] = 0 ;                    
      }  ***/

      put4byte( cpt, &buff[0] ) ;
      cpt = npt ;
      npt = NULL ;
      cp = buff ;
      off = 0 ;
    }
    *(cp + 4 + off) = *vp ;
    off++ ;
    vp++ ;
  }
  //lseek( fp->fd, cpt, 0 ) ;
  fseek( fp->fd, cpt, 0 ) ;
  put4byte( NULL, cp + (fp->rbsz) - 4 ) ;
  //write( fp->fd, cp, fp->rbsz ) ;
  fwrite( cp, 1, fp->rbsz, fp->fd ) ;
  return 2 ;
}









/**********************************************************
*   byteХ塼ΥꥹȤ˿ʣbyteХ塼ƱХ塼Υå򤻤ɲä롣
*   USAGE:	        Add_IXT_DATANC(CFile  *fp, char *key, int ksz, char *val, int vsz)
*   SYNOPSIS:           CFile     *fp    (IN)  ե뼱̻ҥݥ
*            		char      *key   (IN)  
*            		int       ksz    (IN)  Υ
*                       char      *val   (IN)  Ǽǡ
*            		int       vsz    (IN)  ǼǡΥ
*
*   DESCRIPTION:	
*     ФơĹʣByteBinaryˤΥǡɲϿ롣
*     ǼƤͤϡNХ塼ñ̤˳ǼƤ롣
*
*   RETURN:		¸ߤƤ: 1
*                       ʤɲä: 2
*                       ۾ｪλ        : -1
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  Add_IXT_DATANC( CFile  *fp, char *key, int keysz, char *val, int vsz) 
{
  unsigned char  buff[BSIZE];       /* ɤ߹ߥХåե */
  int  ret , len ;
  int  bno ;

  //printf("KEY=[%s]\n",key) ;
  bno = Search_IXS( fp, key, keysz, buff) ;
  if ( bno < 0 ) {                  /* 쥳ɤ¸ߤʤ */
    ret = Put_IXT( fp, key, keysz, val, vsz ) ;
    return ret ;
  }
  ret = add_bin_datablock_nc( fp, bno, buff, val, vsz) ;
  len = get4byte( &buff[4] ) ;
  put4byte( len + vsz, &buff[4] ) ;
  //lseek( fp->fd, bno, 0 ) ;
  //write( fp->fd, buff, fp->rbsz ) ;
  fseek( fp->fd, bno, 0 ) ;
  fwrite( buff, 1, fp->rbsz, fp->fd ) ;
  return ret ;
}




/* Ĺǡ֤ǼƤ쥳ɤκǸɲä */
int add_bin_datablock_nc(CFile *fp, int  cbn, char *work, char *val, int vsz)
{
  int   npo ,dlen, rlen, klen , ii, off;
  char *cp, *vp, buff[BSIZE] ;
  int   brsize, rix, rsize ;
  int  to, kb, cpt, npt, skip ;
  int  len, ret ;

  cpt = cbn ;
  brsize = fp->rbsz - 8 ;     /* ǡǼ֥å */
  rlen = get4byte(work+4) ;   /* 쥳Ĺ */
  off = rlen % brsize ;       /* եå */
  cp = work ;
  npt = *(int *)&work[fp->rbsz - 4] ;
  while( npt != NULL ) {  /*  npt : next_block_no,  cpt : current_block_no */
     cpt = npt ;
     //lseek( fp->fd, npt, 0 ) ;
     //read( fp->fd, buff, fp->rbsz ) ;
     fseek( fp->fd, npt, 0 ) ;
     fread( buff, 1, fp->rbsz, fp->fd ) ;
     npt = *(int *)&buff[fp->rbsz - 4] ;
     cp = buff ;
  }
  if ( off == 0 )
    off = brsize ;
  /*** Set Data ; cpt = currect pointer ***/
  vp = val ;
  for( ii = 0 ; ii < vsz  ; ii++ ) {
    if ( off >= brsize ) {
      npt = GetBlock1( fp ) ;
      //lseek( fp->fd, cpt, 0 ) ;
      fseek( fp->fd, cpt, 0 ) ;
      put4byte( npt, cp + (fp->rbsz) - 4 ) ;
      //write( fp->fd, cp, fp->rbsz ) ;
      fwrite( cp, 1, fp->rbsz, fp->fd ) ;

      /*** KOBA  for TEST ***/
      for( to = 0 ; to < BSIZE ; to++ ) {  /*** KOBA  for TEST ***/
        buff[to] = 0 ;                       /*** KOBA  for TEST ***/
      }/*** KOBA  for TEST ***/               /*** KOBA  for TEST ***/

      put4byte( cpt, &buff[0] ) ;
      cpt = npt ;
      //npt = NULL ;
      cp = buff ;
      off = 0 ;
    }
    *(cp + 4 + off) = *vp ;
    off++ ;
    vp++ ;
  }
  //lseek( fp->fd, cpt, 0 ) ;
  fseek( fp->fd, cpt, 0 ) ;
  put4byte( NULL, cp + (fp->rbsz) - 4 ) ;
  //write( fp->fd, cp, fp->rbsz ) ;
  fwrite( cp, 1, fp->rbsz, fp->fd ) ;
  return 2 ;
}








/**************** REMOVE ********************************************/
/**********************************************************
*   ꤵ줿˳쥳ɤ롣
*   USAGE:	        Rem_IXT(CFile  *fp, char *key, int ksz)
*   SYNOPSIS:           CFile  *fp    (IN)  ե뼱̻ҥݥ
*            		char      *key   (IN)  оݥ쥳ɸ
*            		int       ksz    (IN)  оݥ쥳ɸΥ
*
*   DESCRIPTION:	
*	Υ쥳ɤ롣
*
*   RETURN:		쥳ɤǤ 
*                       쥳ɤ̵     
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  Rem_IXT(CFile  *fp, char *key, int ksz)
{
  unsigned char  cont[BSIZE];       /* ɤ߹ߥХåե */
  unsigned char  buff[BSIZE];       /* ɤ߹ߥХåե */
  int  newpt[1024] ,nct ;
  int  hid ;
  int  bno, pno, hno, nextp, next2 ;
  int  bp, off, ret ;

  //printf("key[%s] ksz=%d\n",key,ksz) ;
  hid = hash((unsigned char *)key,ksz,fp->flag,fp->hmax,fp->hsize) ;
  /* ǡγǼ֤η׻ */
  bno = ( hid / PTCOUNT ) * CBSIZE  ;
  //lseek( fp->fd, bno+CBSIZE , 0 ) ;
  //read( fp->fd, cont, CBSIZE ) ;
  fseek( fp->fd, bno+CBSIZE , 0 ) ;
  fread( cont, 1, CBSIZE, fp->fd ) ;
  pno = ( hid % PTCOUNT ) * 4;
  hno = nextp = *(int *)&cont[pno] ;
  if ( nextp == NULL) {              
    return -1 ;
  }
  /*** TRACE COLLISION CHAIN & UPDATE DATA ***/
  bp = nextp ;
  while( nextp != NULL  ) {
    //lseek( fp->fd, nextp , 0 ) ;
    //read( fp->fd, &buff[0], fp->rbsz ) ;
    fseek( fp->fd, nextp , 0 ) ;
    fread( &buff[0], 1, fp->rbsz, fp->fd ) ;
    if ( CompKey(fp, key, ksz, buff) == 0 ) { /*  */
      next2 = *(int *)&buff[0] ;
      if ( nextp == hno ) { /* ϥå奨ȥ꡼ */
        *(int *)&cont[pno] = next2 ;
        //lseek( fp->fd, bno+CBSIZE , 0 ) ;
        //write( fp->fd, cont, CBSIZE ) ;
        fseek( fp->fd, bno+CBSIZE , 0 ) ;
        fwrite( cont, 1, CBSIZE, fp->fd ) ;
        // nct = CurBlockList( fp, nextp, newpt, 1024 ) ;
        // SetFreeBlock(fp, &newpt[0], nct ) ;
        MoveFreeBlock( fp, nextp ) ;
      }
      else {
        //lseek( fp->fd, bp , 0 ) ;
        //read( fp->fd, &buff[0], fp->rbsz ) ;
        fseek( fp->fd, bp , 0 ) ;
        fread( &buff[0], 1, fp->rbsz, fp->fd ) ;
        *(int *)&buff[0] = next2 ;
        //lseek( fp->fd, bp , 0 ) ;
        //write( fp->fd, &buff[0], fp->rbsz ) ;
        fseek( fp->fd, bp , 0 ) ;
        fwrite( &buff[0], 1, fp->rbsz, fp->fd ) ;
        // nct = CurBlockList( fp, nextp, newpt, 1024 ) ;
        // SetFreeBlock(fp, &newpt[0], nct ) ;
        MoveFreeBlock( fp, nextp ) ;
      }
      return ( 1 ) ;
    } 
    bp = nextp ;
    nextp = *(int *)&buff[0] ;
  }
  return -1 ;
}



/*************************************************************
*   ǥåץեƤФơꤵ줿ؿ¹Ԥ롣
*   USAGE:	        ScanExec_IXT(CFile  *fp, int  (*func)() )
*   SYNOPSIS:           CFile  *fp    (IN)  ե뼱̻ҥݥ
*                       int    *func  (IN)  ¹Դؿ̾
*
*   DESCRIPTION:	
*	ǥåץե˳Ǽ줿Ƥ˥󤷤
*     Τ줾˻ꤵ줿桼ؿư롣
*       ؿϡǥ桼ؿΥݥ󥿡Ȥꡢե
*     ǼƤ륭бͤˤƥ桼ؿ༡ư롣
*       ư桼ؿϰʲΤ褦ʷȤ롣
*       int func-name(char *key, int key_size, char *data, int data_size)  ;
*           arg1: char *key      : ؤΥݥ
*           arg2: int   key_size : Υ
*           arg3: char *data     : Ф쥳ɥǡ
*           arg4: int   data_size: 쥳ɥǡΥ
*        ư桼ؿ֤ͤ硢λǽǤ
*        Υ꥿̴ͤؿ֤
*
*   RETURN:		ƤΥǡФƵư褿ϡ
*                           ưʥ쥳ˡ
*                       ʳϡưؿᤷ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  ScanExec_IXT(CFile  *fp, int  (*func)())
{
  unsigned char cont[CBSIZE], buff[CBSIZE];       /* ɤ߹ߥХåե */
  char work[BSIZE] ;
  char key[4096], data[8192] ;
  char *kp, *dp ;
  int   i, j, hmax, bct, ret ;
  int   pt, rct = 0 ;

  /* ȥ֥åɤ߹ */
  //lseek( fp->fd, 0L, 0 ) ;
  //read( fp->fd, cont, CBSIZE ) ;
  fseek( fp->fd, 0L, 0 ) ;
  fread( cont, 1, CBSIZE, fp->fd ) ;
 
  /* ϥå奨ȥ꡼ */
  hmax = *(int *)&cont[24] ;
  bct = hmax / PTCOUNT ;
  if ( ( hmax % PTCOUNT) != 0) {
    bct++ ;
  }
  //printf("bct = %d\n",bct) ;
  /* ȥ꡼֥åȥ졼 */
  for( i = 1 ; i <= bct ; i++) {
    //lseek( fp->fd, ( i * CBSIZE ), 0 ) ;
    //read( fp->fd, buff, CBSIZE ) ;
    fseek( fp->fd, ( i * CBSIZE ), 0 ) ;
    fread( buff, 1, CBSIZE, fp->fd ) ;
    for( j = 0 ; j < CBSIZE ; j += 4) {
      pt = *(int *)&buff[j] ;
      while( pt != NULL ) {
        pt = EXEC_UserFunc( fp, pt, func, &ret ) ;
        if ( ret < 0 ) {
          return ret ;
        }
        rct++ ;
      }
    }
  }  
  return rct ;
}




int  Chk_IXT_FILE(CFile  *fp, int  (*func)())
{
  unsigned char cont[CBSIZE], buff[CBSIZE];       /* ɤ߹ߥХåե */
  char work[BSIZE] ;
  char key[4096], data[8192] ;
  char *kp, *dp ;
  int   i, j, hmax, bct, ret ;
  int   pt, rct = 0 ;
  int   ct ;

  /* ȥ֥åɤ߹ */
  //lseek( fp->fd, 0L, 0 ) ;
  //read( fp->fd, cont, CBSIZE ) ;
  fseek( fp->fd, 0L, 0 ) ;
  fread( cont, 1, CBSIZE, fp->fd ) ;
 
  /* ϥå奨ȥ꡼ */
  hmax = *(int *)&cont[24] ;
  bct = hmax / PTCOUNT ;
  if ( ( hmax % PTCOUNT) != 0) {
    bct++ ;
  }
  //printf("bct = %d\n",bct) ;
  /* ȥ꡼֥åȥ졼 */
  for( i = 1 ; i <= bct ; i++) {
    //lseek( fp->fd, ( i * CBSIZE ), 0 ) ;
    //read( fp->fd, buff, CBSIZE ) ;
    fseek( fp->fd, ( i * CBSIZE ), 0 ) ;
    fread( buff, 1, CBSIZE, fp->fd ) ;
    for( j = 0 ; j < CBSIZE ; j += 4) {
      pt = *(int *)&buff[j] ;
      ct = 0 ;
      while( pt != NULL ) {
        pt = EXEC_UserFunc( fp, pt, func, &ret ) ;
        if ( ret < 0 ) {
          return ret ;
        }
        rct++ ;
        ct++ ;
      }
      fprintf( stdout, "#################################### %d\n", ct ) ;
    }
  }  
  return rct ;
}





int EXEC_UserFunc(CFile  *fp, int pt, int  (*func)(), int *subret )
{
  char work[BSIZE] ;
  char kbuff[4096], *kp ;
  char dbuff[32768], *dp ;
  int  nextp, off, curp ;
  int  brsize, sz, ret ;
  int  rlen, klen, dlen, len ;

  //printf("Start EXEC_UserFunc\n") ;

  brsize = fp->rbsz - 8 ;   /* 쥳ɳǼΰ襵 */
  //lseek( fp->fd, pt, 0 ) ;
  //read( fp->fd, work, fp->rbsz ) ;
  fseek( fp->fd, pt, 0 ) ;
  fread( work, 1, fp->rbsz, fp->fd ) ;
  nextp = *(int *)work ;    /* ｪλΥ꥿͡ʼΥ쥳ɤγǼ֡ */

  rlen = get4byte(work+4) ;   /* 쥳Ĺ */
  klen = get2byte(work+8) ;   /*  */
  dlen = rlen - klen - 6 ;    /* ǡ */
  if ( dlen == 0 )
    return nextp ;

  if ( klen >= 4096 ) {
    ret = klen / 4096 ;
    len = ( ret +1 ) * 4096 ;
    if ( (kp = (unsigned char *)malloc( len ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return -1 ;
    }
  }
  else {
    kp = kbuff ;
  }
  off = 6 ;
  curp = pt ;
  ret = Get_data_from_block(fp,kp,work,&curp,&off,klen) ;
  *(kp+klen) = '\0' ;


  if ( dlen >= 32768 ) {
    ret = dlen / 4096 ;
    len = ( ret +1 ) * 4096 ;
    if ( (dp = (unsigned char *)malloc( len ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return -1 ;
    }
  }
  else {
    dp = dbuff ;
  }
  ret = Get_data_from_block(fp,dp,work,&curp,&off,dlen) ;

  ret = (*func)(kp,klen,dp,dlen) ;
  if ( klen >= 4096 ) {
    free( kp ) ;
  }
  if ( dlen >= 32768 ) {
    free( dp ) ;
  }

  *subret = ret ;
  return nextp ;
}







/**********************************************************
*   ֥åλꤵ줿ʬͤФ
*   USAGE:	        Get_data_from_block( CFile *fp, char *out, char *work, int *curp, int *off, int len)
*   SYNOPSIS:           CFile  *fp   (IN)  ե뼱̻ҥݥ
*            		char   *out  (OUT) 
*            		char   *work (IN)  ֥åɤ߹ߥꥢƬ֥åǡ
*                       int    *curp (IN)  ֥åֹ
*                       int    *off  (IN)  եå
*                       int     len  (IN)  Ǽ
*
*   DESCRIPTION:	
*	ģΥǡƬ֥åȤꡢꤵ줿
*     եåȤΰ֤鳺ǡ򤽤ΥʬǼ롣
*     ǡƤΥ֥å˳ǼƤʤ
*     ϡΥ֥å缡ɤ߹ळȤȤ롣
*
*   RETURN:		Ǽ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  Get_data_from_block( CFile *fp, char *out, char *work, int *curp, int *off, int len)
{
  int  npo, klen, i ;
  char *cp, buff[BSIZE] ;
  int brsize ;
  int ret, sz ;
  char *keystop ;

  //printf("(Get_data_from_block) start!\n") ;
  brsize = fp->rbsz - 8 ;
  ret = 0 ;
  while( len > 0 ) {
    sz = brsize - (*off) ;
    if ( len <= sz ) 
      sz = len ;
    memcpy( out, work + (*off) + 4 , sz ) ;
    if ( len > (brsize - (*off)) ) {
      *curp = get4byte( work + fp->rbsz - 4 ) ;
      //lseek( fp->fd, *curp, 0 ) ;
      //read( fp->fd, work, fp->rbsz ) ;
      fseek( fp->fd, *curp, 0 ) ;
      fread( work, 1, fp->rbsz, fp->fd ) ;
      (*off) = 0 ;
    }
    else {
      (*off) += sz ;
    }
    len -= sz ;
    ret += sz ;
    out += sz ;
  }
  return ret ;
}


/*** SAMPLE ***/
int print_key_data_BS(char *key, int klen, char *data, int dlen)
{
  int  id ;

  id = get4byte( key ) ;
  if ( dlen <= 0 ) 
    printf("KEY[%d] =>[]\n", id ) ;
  else {
    *(data+dlen) = '\0' ;
    printf("KEY[%d] =>[%s]\n", id, data) ;
  }
  return 1 ;
}


int print_key_data_SBs(char *key, int klen, char *data, int dlen)
{
  int i, j, Rid ;
  if ( dlen <= 0 ) 
    printf("KEY[%s] =>[]\n", key) ;
  else {
    printf("KEY[%s] =>[", key ) ;
    for( i = j = 0 ; i < dlen  ; i += 4 ) {
      Rid = get4byte(data + i) ;
      printf("\t%07d", Rid ) ;
    }
    printf("]\n" ) ;
  }
  return 1 ;
}



int print_key_data_BBs(char *key, int klen, char *data, int dlen)
{
  int i, j, Rid ;
  int kv ;
  
  kv = get4byte(key) ;
  if ( dlen <= 0 ) 
    printf("KEY[%d] =>[]\n", kv) ;
  else {
    printf("KEY[%d] =>[", kv ) ;
    for( i = j = 0 ; i < dlen  ; i += 4 ) {
      Rid = get4byte(data + i) ;
      printf("\t%07d",Rid ) ;
    }
    printf("]\n" ) ;
  }
  return 1 ;
}


/**************** OUTPUT *****************************************/
/*************************************************************
*   ǥåץեƤϤ롣
*   USAGE:	        Dump_IXT(CFile  *fp, FILE *outfp, &int func)
*   SYNOPSIS:           CFile  *fp    (IN)  ե뼱̻ҥݥ
*            		FILE      *outfp (IN)  եݥ
*                       int       *func  (IN)  ƽϴؿ̾
*
*   DESCRIPTION:	
*	ǥåץե˳Ǽ줿Ƥ򤹤٤ƽ
*       롣
*
*   RETURN:		쥳ɿ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  Dump_IXT(CFile  *fp, FILE *outfp, int  *func)
{
  unsigned char cont[CBSIZE], buff[BSIZE];       /* ɤ߹ߥХåե */
  int   i, j, hmax, bct ;
  int   pt, rct = 0 ;

  /* ȥ֥åɤ߹ */
  //lseek( fp->fd, 0L, 0 ) ;
  //read( fp->fd, cont, CBSIZE ) ;
  fseek( fp->fd, 0L, 0 ) ;
  fread( cont, 1, CBSIZE, fp->fd ) ;
 
  /* ϥå奨ȥ꡼ */
  hmax = *(int *)&cont[24] ;
  bct = hmax / PTCOUNT ;
  if ( ( hmax % PTCOUNT) != 0) {
    bct++ ;
  }
  /* ȥ꡼֥åȥ졼 */
  for( i = 1 ; i <= bct ; i++) {
    //lseek( fp->fd, ( i * CBSIZE ), 0 ) ;
    //read( fp->fd, buff, CBSIZE ) ;
    fseek( fp->fd, ( i * CBSIZE ), 0 ) ;
    fread( buff, 1, CBSIZE, fp->fd ) ;
    for( j = 0 ; j < CBSIZE ; j += 4) {
      pt = *(int *)&buff[j] ;
      while( pt != NULL ) {
        //printf("i=%d : j=%d : pt=%d : buff[0]=%x,%x,%x,%x\n",i,j,pt,buff[j],buff[j+1],buff[j+2],buff[j+3]);
        pt = print_rec1( fp, outfp, pt, func) ;
        rct++ ;
      }
    }
  }  
  return rct ;
}


int print_rec1(CFile  *fp, FILE *outfp , int pt, int  (*func)() )
{
  char work[BSIZE] ;
  char kbuff[32768] ;
  char rbuff[32768] ;
  int  kix = 0, rix = 0 ;
  int  nextp , to, len ;
  int rlen, klen, obct, cpt, off, kb, npt, skip, i ;
  int  brsize , rsize, ret;

  brsize = fp->rbsz - 8 ;   /* 쥳ɳǼΰ襵 */
  //lseek( fp->fd, pt, 0 ) ;
  //read( fp->fd, work, fp->rbsz ) ;
  fseek( fp->fd, pt, 0 ) ;
  fread( work, 1, fp->rbsz, fp->fd ) ;
  nextp = *(int *)work ;
  rlen = get4byte(work+4) ;
  klen = get2byte(work+8) ;
  //printf(" rlen=%d klen=%d\n",rlen,klen) ;
  obct = rlen / brsize ;
  if ( ( rlen % brsize) != 0 )
    obct++ ;
  cpt = pt ;
  if ( klen > (brsize - 6) ) {
    off = ( klen + 6 ) % brsize ;
    kb = ( klen + 6 ) / brsize ;
    if ( off == 0 ) {
      kb-- ;
      off = brsize ;
    }
    npt = *(int *)&work[fp->rbsz - 4] ;
    skip = 6 ;
    for( i=0  ; i < kb ; i++ ) {
      memcpy( &kbuff[kix], &work[4+skip], brsize - skip ) ;
      kix += brsize - skip ;
      cpt = npt ;
      //lseek( fp->fd, npt, 0 ) ;
      //read( fp->fd, work, fp->rbsz ) ;
      fseek( fp->fd, npt, 0 ) ;
      fread( work, 1, fp->rbsz, fp->fd ) ;
      npt = *(int *)&work[fp->rbsz - 4] ;
      skip = 0 ;
    }
    memcpy( &kbuff[kix], &work[4+skip], off ) ;
    kix += off ;
  }
  else {
    off = klen + 6 ;
    npt = *(int *)(work + fp->rbsz - 4) ;
    memcpy( &kbuff[kix], &work[10], klen ) ;
    kix = klen ;
  }
  kbuff[kix] = '\0' ;
  /* SET DATA (offǼ) */
            /*  npt : next_block_no,  cpt : current_block_no */
  if ( rlen - klen - 6 == 0 ) {
    rbuff[0] = rbuff[1] = rbuff[2] = rbuff[3] = 0 ;
  }
  else {       
    rsize = rlen - klen - 6 ;
    for( i = 0 ; i <  rsize ; ) {
      to = rsize - i ;
      if ( to >= (brsize - off) ) {
        len = brsize - off ;
      }
      else {
        len = to ;
      }
      memcpy( &rbuff[rix], &work[4+off], len ) ;
      rix += len ;
      npt =  *(int *)&work[fp->rbsz - 4] ;
      i += len ;
      off = 0 ;
      if ( npt != NULL) {
        //lseek( fp->fd, npt, 0 ) ;
        //ret = read( fp->fd, work, fp->rbsz) ;
        fseek( fp->fd, npt, 0 ) ;
        ret = fread( work, 1, fp->rbsz, fp->fd ) ;
        //printf("read ret=%d:pt(%o)=>:work[4]=%x,%x,%x,%x\n",ret,npt,work[4],work[5],work[6],work[7]) ;
      }
    }
  }
  rbuff[rix] = '\0' ;
  i = (*func)(outfp,kbuff,kix,rbuff,rix) ;
  return nextp ;
}





/************************************************** For DEBUG ***/
int debug1(CFile *fPtr, char *str)
{
  int ret  ;
  char cont[CBSIZE] ;
  //lseek( fPtr->fd, 0L, 0 ) ;
  //ret = read( fPtr->fd, cont, 128 ) ;
  fseek( fPtr->fd, 0L, 0 ) ;
  ret = fread( cont, 1, 128, fPtr->fd ) ;
  if ( cont[0] != 0 || cont[1] != 0 || cont[2] != 0x01 || cont[3] != 0x01 ) {
    printf("%s(ret=%d)=>:cont[0]=%x,%x,%x,%x\n",str,ret,cont[0],cont[1],cont[2],cont[3]) ;
    printf("%s(ret=%d)=>:cont[4]=%x,%x,%x,%x\n",str,ret,cont[4],cont[5],cont[6],cont[7]) ;
    return -1 ;
  }
  return 0 ;
}

debug2(unsigned char buff2[], int len )
{
  int  kk ;
  for (kk = 0 ; kk < len ; kk++ ) {
    if ( (kk % 16) == 0 ) 
      fprintf( stdout,"\n") ;
    fprintf( stdout, " %2x", buff2[kk] ) ;
  }
  fprintf( stdout, "\n") ;
}




