/*
#############################################################################
#                                                                           #
#  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1995  #
#                                                                           #
#                    <Dictionary Translator for EDBroW>                     #
#                                                                           #
#  - For details regarding copyright, re-distribution, modification, and    #
#    use of this software see COPYING file.                                 #
#                                                                           #
#  - For UNIX version                                                       #
#    This software was developed on SunOS4.1.3 with the gcc.2.5.8 compiler  #
#    and on Solaris2.3 with the gcc2.5.6 compiler. The compilers supplied   #
#    with SunOS4.1.3 and Solaris2.3 were also used.                         #
#                                                                           #
#  - For Windows version                                                    #
#    This software was developed on Microsoft Windows 3.1 with the          #
#    Microsoft Visual C++ 1.0 compiler.                                     #
#                                                                           #
# ###########################################################################
*/

/*************************************************************\

   util.h : ȥ󥹥졼桼ƥƥؿѥإåե
   Ver.1.1
   95/04/12   by msato@edr8r.edr.co.jp

\*************************************************************/

#ifndef __UTIL_H__
#define __UTIL_H__

#define	FILENAME_SIZE	260	/* ե̾Υ */
#define	STDIN_MODE   0
#define FILEDEF_MODE 1
#define	END_COMMAND -1

#ifndef RDOPN_FLAG
#ifdef _WIN32
#define RDOPN_FLAG "rb"
#else
#define RDOPN_FLAG "r"
#endif
#endif

/*------------------*/
/* 顼 */
/*------------------*/
enum FatalList
{
  USAGE_ERROR,
  OUT_OF_MEMORY,
  CANNOT_OPEN_FILE_FATAL,
  CANNOT_WRITE,
  OTHER_ERROR
};

enum ErrList
{
  ILLEGAL_DATA,
  CANNOT_OPEN_FILE,
  ILLEGAL_DICT_SPEC,
  ILLEGAL_DICT_FILE,
  CANNOT_TRANSLATE
};

/*----------------------*/
/* ե̾ */
/*----------------------*/
#define  FDIC_TMP 0
#define  IDX_TMP  1
#define  IDX2_TMP 2
#define	 IDX3_TMP 3
#define  IDXX_SRT 4
#define  SORT_WRK 5


/*------------------------------*/
/* ǰ̻Ѵơ֥ */
/*------------------------------*/
#define LCID_LIST_SIZE 6

typedef struct LongCIDList {
  char	*longcid;
  char	*shortcid;
} LongCIDList;


/********************/
/* ؿץȥ */
/********************/

#if defined(__STDC__) || defined(__PCHECK__) || defined(__cplusplus)
# define P_(s) s
#else
# define P_(s) ()
#endif

void fatal P_((int num, char *filename, int line));
void print_err P_((int num, char *message));

int prompt P_((char *buf, int size));

int streuctosjis P_((unsigned char *srcPtr, unsigned char *dstPtr));
unsigned short euctosjis P_((unsigned char euc1, unsigned char euc2));

int get_field P_((char *input_str, char *field[], int max));
unsigned int ctoi P_((char c));

int make_filename P_((char *filename, int num));
int make_indexname P_((char *filename, int num));
FILE *get_txtDicFp P_((int mode));
unsigned long makeCID P_((char *cidStr));
int transCID P_((char *longStr, char *shortStr));
char *mystrchr P_((char *string, char index));

#undef P_

#endif /* __UTIL_H__ */
