/*
*****************************************************************************
*                                                                           *
*  Copyright (C) JAPAN ELECTRONIC DICTIONARY RESEARCH INSTITUTE, LTD. 1997  *
*                                                                           *
*****************************************************************************
*/
#include <stdio.h>
#include <fcntl.h>

#include "fconst.h"
#include "ftemp.h"
#include "sconst.h"
#include "stemp.h"

/**********************************************************
*   ***	ܥƥեؿ
*   USAGE:		CreateBSYSFile( char *fname )
*   SYNOPSIS:		char  *fname  ե̾
*   DESCRIPTION:	
*	ǡܥƥեؿ
*	եκʽˤ˼Ԥ硢顼֤
*	˥ե뤬줿ϡե
*       ̻ҤΥݥ󥿤֤
*       ե°
*             ʸñ̤ΣɣĤ򥭡Ȥ롣
*             ϥå奨ȥ꡼ : 
*             쥳ɥ֥å : 
*
*   RETURN:		NULLʳ : ｪλ
*                       NULL     : ۾ｪλ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
CFile  *CreateBSYSFile( char *fname )
{
  CFile  *fPtr;              /* ե뼱̻ҥݥ */

  fPtr = Create_IXT( fname , 'b', SYSHSMAX, -1, SYSBLOSZ) ;
  return fPtr ;
}



/**********************************************************
*   ***	ܥƥե򥪡ץ󤹤ؿ
*   USAGE:		OpenBSYSFile( char *fname )
*   SYNOPSIS:		char  *fname  ե̾
*
*   DESCRIPTION:	
*	ǡܥƥե򥪡ץ󤹤ؿ
*	եΥץ˼Ԥ硢顼֤
*	˥ե뤬ץǤϡե
*       ̻ҥݥ󥿤֤
*
*   RETURN:		NULLʳ : ｪλ
*                       NULL     : ۾ｪλ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
CFile  *OpenBSYSFile( char *fname )
{
  CFile  *fPtr;              /* ե뼱̻ҥݥ */

  fPtr = Open_IXT( fname, 'b' ) ;
  return fPtr ;
}



/**********************************************************
*   ***	ܥƥե򥯥ؿ
*   USAGE:		CloseBSYSFile( CFile *fp)
*   SYNOPSIS:		CFile  *fp  ե뼱̻ҥݥ
*   DESCRIPTION:	
*	ܥƥե򥯥롣
*
*   RETURN:
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
void  CLoseBSYSFile( CFile *fp)
{

   Close_IXT( fp) ;
}





/**********************************************************
*   ܥƥե˥ǡϿؿ
*   USAGE:		PutData_BSYSFile( CFile *fp, CData *cur )
*   SYNOPSIS:		CFile  *fp          (IN)  ե뼱̻ҥݥ
*                       CData  *cur         (IN)  ǡ¤
*                         Ǽ CDataΰʲΥС򻲾
*                           int    textno  (IN)  ʸֹ
*                           char  *field   (IN)  ե̾
*                           char  *data    (IN)  ǼǡƬɥ쥹
*                           int    datasize(IN)  Ǽǡ
*                           char  *subR    (IN)  쥳ɤФ
*                           char  *subF    (IN)  եɤФ
*
*   DESCRIPTION:	
*	ǡδѴܥƥե˥ǡǼؿ
*       ʸֹǼ쥳ɤγեɤͤ򹹿롣
*       쥳ɤФեɤФ
*       ʲηȤ˽񤫤Ƥΰʳ
*       Τޤݻ롣
*         ̾=;̾=;....
*         :ͤüʸޤ""ǰϤळȡ
*         :̾üʸޤǤϤʤ
*
*   RETURN:		Ǽ֥åֹ : ｪλ
*                       Ǽǡʤ     : 0
*                                    : ۾ｪλ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  PutData_BSYSFile( CFile *fp, CData *cur )
{
  unsigned char buff1[CBSIZE]; 
  unsigned char wk[2];
  char work[BSIZE] ;
  int   bp ;
  int   bno , cno, pno, nextp, tct;
  unsigned int hid ;

  if ( ChkSubInfo( cur->subR ) < 0 )    /* å */
    return -1 ;
  if ( ChkSubInfo( cur->subF ) < 0 )
    return -1 ;

  cur->fdpt = NULL ;                 
  cur->fcpt = NULL ;
  cur->rcpt = NULL ;

  hid = hash((unsigned char *)&(cur->textno),4,fp->flag,fp->hmax,fp->hsize) ;

  /* ǡγǼ֤η׻ */
  bno = ( hid / PTCOUNT ) * CBSIZE  ;
  //lseek( fp->fd, bno+CBSIZE , 0 ) ;
  //read( fp->fd, buff1, CBSIZE ) ;
  fseek( fp->fd, bno+CBSIZE , 0 ) ;
  fread( buff1, 1, CBSIZE, fp->fd ) ;
  pno = ( hid % PTCOUNT ) * 4 ;
  nextp = *(int *)&buff1[pno] ;
  if ( nextp == NULL) {                 /* Ͽ */
    if ( ExistPutSYSData( cur ) == 0 )
      return 0 ;
    cno = SetNewRecBSYSFile(fp, cur) ;
    *(int *)&buff1[pno] = cno ;
    //lseek( fp->fd, bno+CBSIZE , 0 ) ;
    //write( fp->fd, buff1, CBSIZE ) ;
    fseek( fp->fd, bno+CBSIZE , 0 ) ;
    fwrite( buff1, 1, CBSIZE, fp->fd ) ;
    UpdateRecordNoBSYSFile(fp,cur->textno) ;
    return cno ;
  }
  /*** TRACE COLLISION CHAIN & UPDATE DATA ***/
  bp = nextp ;
  while( nextp != NULL  ) {
    //lseek( fp->fd, nextp , 0 ) ;
    //read( fp->fd, &work[0], fp->rbsz ) ;
    fseek( fp->fd, nextp , 0 ) ;
    fread( &work[0], 1, fp->rbsz, fp->fd ) ;
    if ( CompKey(fp, (char *)&(cur->textno), 4, work) == 0 ) { /*  */
      ReplRecBSYSFile(fp, nextp, work, cur) ;
      return ( nextp ) ;
    } 
    bp = nextp ;
    nextp = *(int *)&work[0] ;
  }
                         /* ChainκǸ˥쥳ɤɲ */
  if ( ExistPutSYSData( cur ) == 0 )
    return 0 ;
  cno = SetNewRecBSYSFile(fp, cur) ;
  *(int *)&work[0] = cno ;
  //lseek( fp->fd, bp , 0 ) ;
  //write(fp->fd, &work[0], fp->rbsz ) ;
  fseek( fp->fd, bp , 0 ) ;
  fwrite( &work[0], 1, fp->rbsz, fp->fd ) ;
  UpdateRecordNoBSYSFile(fp,cur->textno) ;
  return ( cno ) ;
}



int ExistPutSYSData( CData *cur )
{
  if ( cur->datasize == 0 &&
       ( cur->subR == NULL || *(cur->subR) == '\0' ) &&
       ( cur->subF == NULL || *(cur->subF) == '\0' ) )
    return 0 ;

  return 1;
}



/**********************************************************
*   ȡ֥åΥ쥳ֹ򹹿
*   USAGE:		UpdateRecordNoBSYSFile(CFile *fp, int  textno) ;
*   SYNOPSIS:           CFile  *fp     (IN)  ե뼱̻ҥݥ
*                       int     textno (IN)  ƥֹ
*
*   DESCRIPTION:	
*	ȥ֥åο쥳ɣɣĤͤͤ
*     ʲǤʤ顢ȥ֥åͤ͡ܣ
*     롣
*       ȥ֥åο쥳ɣɣĤϡϿ
*     ݤ˻Ѥƥֹˤʤ롣
*
*   RETURN:		
*
*   SEE ALSO:	      Get_NewRecordNo( CFile *fPtr ) [FLIB/flib.c]
*   ERRORS:
***********************************************************/
void UpdateRecordNoBSYSFile(CFile *fp, int textno)
{
  unsigned char cont[CBSIZE]; 
  int ii ;

  //lseek( fp->fd, 0L, 0 ) ;
  //read( fp->fd, cont, CBSIZE ) ;
  fseek( fp->fd, 0L, 0 ) ;
  fread( cont, 1, CBSIZE, fp->fd ) ;
  ii = *(int *)&cont[36] ; /* Ǽ쥳ɣɣ */ 
  if ( ii <= textno ) {
    *(int *)&cont[36] = textno+1 ;
    fp->rct = textno+1 ;
    //lseek( fp->fd, 0L, 0 ) ;
    //write( fp->fd, cont, CBSIZE ) ;
    fseek( fp->fd, 0L, 0 ) ;
    fwrite( cont, 1, CBSIZE, fp->fd ) ;
  }
}





/**********************************************************
*   쥳ɤϿ
*   USAGE:		SetNewRecBSYSFile(CFile *fp, CData *cur) ;
*   SYNOPSIS:           CFile  *fp   (IN)  ե뼱̻ҥݥ
*                       CDATA  *cur  (IN)  ʲΥСι¤         
*                         int       textno  (IN)  ƥֹ
*                         char     *field   (IN)  ե̾
*                         char     *data    (IN)  Ǽǡ
*                         int       datasize(IN)  Ǽǡ
*                         char     *subR    (IN)  쥳
*                         char     *subF    (IN)  ե
*
*   DESCRIPTION:	
*	쥳ɤ򿷵쥳ɤȤϿ롣
*       :ȥ֥åο֥åե꡼֥å
*          ͤ⹹롣
*
*   RETURN:		Ǽ         : ｪλ
*                                      : ۾ｪλ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  SetNewRecBSYSFile(CFile  *fp, CData *cur ) 
{
  int   fno ;

  /* եɥ֥å */
  fno = SetFieldData( fp, cur, NULL , NULL ) ;
  if ( fno == -1 ) {
    fprintf( stderr, "ERROR(SetNewRecBSYSFile):Write error(1)!\n" ) ;
    return -1 ;
  }
  cur->fdpt = fno ; /* SetFieldContData ǻȤ */
  // printf("PUT FIELD block=%x(D%d O%o)\n",fno,fno,fno) ;

  /* եɥȥ֥å */
  fno = SetFieldContData( fp, cur, NULL , NULL ) ;
  if ( fno == -1 ) {
    fprintf( stderr, "ERROR(SetNewRecBSYSFile):Write error(2)!\n" ) ;
    return -1 ;
  }
  cur->fcpt = fno ; /* SetRecordContData ǻȤ */
  // printf("PUT FIELD_CONT block=%x(D%d O%o)\n",fno,fno,fno) ;

  /* 쥳ɥȥ֥å */
  fno = SetRecordContData( fp, cur, NULL , NULL ) ;
  if ( fno == -1 ) {
    fprintf( stderr, "ERROR(SetNewRecBSYSFile):Write error(3)!\n" ) ;
    return -1 ;
  }
  cur->rcpt = fno ;
  // printf("PUT RECORD_CONT block=%x(D%d O%o)\n",fno,fno,fno) ;
  return fno ;
}



void  put_sys_end_func( int maxct, int *ipt, int lim, int status)
{
  if ( maxct > lim ) 
    free( (char *)ipt ) ;
}



/**********************************************************
*   ***	쥳ɥȥǡι
*   USAGE:		SetRecordContData( CFile *fp, CData  *cur, int *bl, int next )
*   SYNOPSIS:           CFile  *fp   (IN)  ե뼱̻ҥݥ
*            		CData *cur   (IN)  ǡƴ¤
*                       int   *bl    (IN)  оݥեɳǼ֥åꥹ
*                       int    next  (IN)  Υ֥åؤΥݥ
*                       
*   DESCRIPTION:	
*	ʥ쥳ɴ󡿥쥳롣
*        
*   RETURN:		Ƭ֥åֹ : ｪλ
*                       -1               : ۾ｪλ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int   SetRecordContData( CFile *fp, CData *cur, int *bl, int next ) 
{
  unsigned char buff[BSIZE];
  char  fid ;
  int   ii, nct ;
  int   pno, nno, off ;
  int   start ;
  int   cdate, flag ;
  int   allsz, etcsz ;
  int   *ip, ret, len, maxct, mallen ;
  int   *ipt, newpt[1024] ;
  short keysz ;
  CFileInfo  cf ;

  cdate = PackNowDateI() ;           /* դ򹹿Ȥƥå */
  flag = GetFlagSubR( cur->subR ) ;  /* 󤫤ե饰   */

  /* եɥ ׻ */
  if ( cur->subR == NULL )
    len = 0 ;
  else 
    len = strlen( cur->subR ) + 1;   
  etcsz = len + 12 ;                 /* 󥵥 */
  allsz = etcsz + 18 ;               /* եɥ */

  /* 쥳ɴ쥳Ǽ֥å */
  nct = allsz / ( fp->rbsz - 4) ;
  if ( ( allsz % ( fp->rbsz - 4) ) != 0 )
    nct++ ;

  if ( nct <= 1024 ) {
    maxct = 1024 ;
    ipt = &newpt[0] ;
  }
  else {
    maxct = (( nct / 1024) + 1 ) * 1024 ;
    mallen = maxct * sizeof(int) ;
    if ( (ipt = (int *)malloc( mallen ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return -1 ;
    }
  }
  if ( bl != NULL ) {
    for( ii = 0 ; ii < nct  ; ii++ ) {
      if ( *bl == NULL )
        break ;
      *(ipt + ii) = *bl ;
      bl++ ;
    }
    ip = bl ;
    while( *bl != NULL ) 
      bl++ ;
    SetFreeBlock(fp, ip, bl - ip) ;
  }
  else
    ii = 0 ;
  ret = GetBlock( fp, nct-ii, ipt + ii, maxct-ii ) ;
  if ( ret != (nct-ii) ) {
    fprintf(stdout,"ERROR:ǡν񤭹ΰγݤ˼\n") ;
    if ( maxct > 1024 ) 
      free( (char *)ipt ) ;
    return ( -1 ) ;
  }


  /* ǼƬ֥åֹ򥻥å */
  ret = *ipt ;

  /* ǡ񤭹湽¤ν */
  cf.blist = ipt ;            /* ǡ򥻥åȤ֥åꥹ */
  cf.offset = 0 ;                   /* ǡåȰ */
  cf.buff = &buff[0] ;              /* Хåե */
  cf.next = NULL ;                  /* 쥳ɥ֥åֹ */
  cf.flag  = 1 ;                    /* ξ󤢤 */

  /* 쥳ɴ */
  if ( PutSYSFILE(fp,&cf,(char *)&next,4) != 4 ) {  /* next pointer */
    put_sys_end_func(maxct,ipt,1024,1) ;
    return -1 ;
  }
  allsz = etcsz + 14 ;
  if ( PutSYSFILE(fp,&cf,(char *)&allsz,4) != 4 ) { /* record size */
    put_sys_end_func(maxct,ipt,1024,2) ;
    return -1 ;
  }
  keysz = 4 ;
  if ( PutSYSFILE(fp,&cf,(char *)&keysz,2) != 2 ) { /* Key size */
    put_sys_end_func(maxct,ipt,1024,3) ;
    return -1 ;
  }
  if ( PutSYSFILE(fp,&cf,(char *)&(cur->textno),4) != 4 ) { /* Text_NO. */
    put_sys_end_func(maxct,ipt,1024,4) ;
    return -1 ;
  }
  if ( PutSYSFILE(fp,&cf,(char *)&(cur->fcpt),4) != 4 ) { /* FieldControlPointer */
    put_sys_end_func(maxct,ipt,1024,5) ;
    return -1 ;
  }

  /* : | 󥵥(4) | ե饰(4) | DATE(4) | ʸ\0 | */
  if ( PutSYSFILE(fp,&cf,(char *)&etcsz,4) != 4 ) { /* 󥵥 */
    put_sys_end_func(maxct,ipt,1024,6) ;
    return -1 ;
  }
  if ( PutSYSFILE(fp,&cf,(char *)&flag,4) != 4 ) {  /* Flag */
    put_sys_end_func(maxct,ipt,1024,7) ;
    return -1 ;
  }
  if ( cur->subR == NULL) 
    cf.flag = 0 ;
  if ( PutSYSFILE(fp,&cf,(char *)&cdate,4) != 4 ) { /*  */
    put_sys_end_func(maxct,ipt,1024,8) ;
    return -1 ;
  }
  if ( cur->subR == NULL ) {
    put_sys_end_func(maxct,ipt,1024,9) ;
    return ret ;
  }
  cf.flag = 0 ;
  allsz = strlen( cur->subR ) + 1 ;
  //printf("(SetRecordContData)cur->subR=[%s]\n",cur->subR) ;
  if ( PutSYSFILE(fp,&cf,(char *)(cur->subR),allsz) != allsz ) { /*  */
    put_sys_end_func(maxct,ipt,1024,10) ;
    return -1 ;
  }

  if ( maxct > 1024 ) 
    free( (char *)ipt ) ;

  return ret ;
}






/**********************************************************
*   ***	եɥǡι
*   USAGE:		SetFieldContData( CFile *fp, CData  *cur, int *bl, int next )
*   SYNOPSIS:           CFile  *fp   (IN)  ե뼱̻ҥݥ
*            		CData *cur   (IN)  ǡƴ¤
*                       int   *bl    (IN)  оݥեɳǼ֥åꥹ
*                       int    next  (IN)  Υեɥ֥åؤΥݥ
*                       
*   DESCRIPTION:	
*	ʥեɴ󡿥ե롣
*
*        
*   RETURN:		Ƭ֥åֹ : ｪλ
*                       -1               : ۾ｪλ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int   SetFieldContData( CFile *fp, CData *cur, int *bl, int next ) 
{
  unsigned char buff[BSIZE];
  unsigned char  fid ;
  int   ii, nct ;
  int   pno, nno, off ;
  int   start ;
  int   cdate, flag ;
  int   allsz, etcsz, sz ;
  int   *ip, ret, len, maxct, mallen ;
  int   *ipt, newpt[1024] ;
  CFileInfo  cf ;

  cdate = PackNowDateI() ;           /* դ򹹿Ȥƥå */
  flag = GetFlagSubF( cur->subF ) ;  /* 󤫤ե饰   */

  /* եɥ ׻ */
  if ( cur->subF == NULL )
    len = 0 ;
  else
    len = strlen( cur->subF ) + 1 ;   
  etcsz = len + 12 ;                 /* 󥵥 */
  sz = strlen( cur->field ) + 1 ;    /* ե̾ */
  allsz = sz + etcsz + 13 ;          /* եɥ */

  /* եɴեǼ֥å */
  nct = allsz / ( fp->rbsz - 4) ;
  if ( ( allsz % ( fp->rbsz - 4) ) != 0 )
    nct++ ;
  if ( nct <= 1024 ) {
    maxct = 1024 ;
    ipt = &newpt[0] ;
  }
  else {
    maxct = (( nct / 1024) + 1 ) * 1024 ;
    mallen = maxct * sizeof(int) ;
    if ( (ipt = (int *)malloc( mallen ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return -1 ;
    }
  }
  if ( bl != NULL ) {
    for( ii = 0 ; ii < nct  ; ii++ ) {
      if ( *bl == NULL )
        break ;
      *(ipt + ii) = *bl ;
      bl++ ;
    }
    ip = bl ;
    while( *bl != NULL ) 
      bl++ ;
    SetFreeBlock(fp, ip, bl - ip) ;
  }
  else
    ii = 0 ;
  ret = GetBlock( fp, nct-ii, ipt + ii, maxct-ii ) ;
  if ( ret != (nct-ii) ) {
    fprintf(stdout,"ERROR:ǡν񤭹ΰγݤ˼\n") ;
    return ( -1 ) ;
  }

  fid = Get_BSYSFID( cur->field ) ;  /* եID */

  /* ǡ񤭹湽¤ν */
  cf.blist = ipt ;            /* ǡ򥻥åȤ֥åꥹ */
  cf.offset = 0 ;                   /* ǡåȰ */
  cf.buff = &buff[0] ;              /* Хåե */
  cf.next = NULL ;                  
  cf.flag  = 1 ;                    /* ξ󤢤 */

  ret = *ipt ;

  /* եɴ */
  if ( PutSYSFILE(fp,&cf,(char *)&next,4) != 4 ) {  /* Next Field Pointer */
    put_sys_end_func(maxct,ipt,1024,21) ;
    return -1 ;
  }
  allsz -= 4 ;
  if ( PutSYSFILE(fp,&cf,(char *)&allsz,4) != 4 ) { /* Field Size */
    put_sys_end_func(maxct,ipt,1024,22) ;
    return -1 ;
  }
  if ( PutSYSFILE(fp,&cf,(char *)&fid,1) != 1 ) {  /* Field ID */
    put_sys_end_func(maxct,ipt,1024,23) ;
    return -1 ;
  }
  if ( PutSYSFILE(fp,&cf,(char *)(cur->field),sz) != sz ) {  /* Field */ 
    put_sys_end_func(maxct,ipt,1024,24) ;
   return -1 ;
  }
  if ( PutSYSFILE(fp,&cf,(char *)&(cur->fdpt),4) != 4 ){    /* Field Pointer*/
    put_sys_end_func(maxct,ipt,1024,25) ;
    return -1 ;
  }

  /* 󥵥ν񤭹 */
  if ( PutSYSFILE(fp,&cf,(char *)&etcsz,4) != 4 ) { /* 󥵥 */
    put_sys_end_func(maxct,ipt,1024,26) ;
    return -1 ;
  }
  if ( PutSYSFILE(fp,&cf,(char *)&flag,4) != 4 ) { /* եɥե饰 */
    put_sys_end_func(maxct,ipt,1024,27) ;
    return -1 ;
  }
  if ( cur->subF == NULL )
    cf.flag  = 0 ;                                /* ξʤ */
  if ( PutSYSFILE(fp,&cf,(char *)&cdate,4) != 4 ) { /*  */
    put_sys_end_func(maxct,ipt,1024,28) ;
    return -1 ;
  }
  
  if ( cur->subF == NULL ) {
    if ( maxct > 1024 ) 
      free( (char *)ipt ) ;
    return ret ;
  }

  cf.flag  = 0 ;                                  /* ξʤ */
  if ( PutSYSFILE(fp,&cf,(char *)(cur->subF),len) != len ) { /*  */
    put_sys_end_func(maxct,ipt,1024,29) ;
    return -1 ;
  }
  if ( maxct > 1024 ) 
    free( (char *)ipt ) ;

  return ret ;
}





/**********************************************************
*   ***	եɥǡι
*   USAGE:		SetFieldData( CFile *fp, CData  *cur, int *bl, int next )
*   SYNOPSIS:           CFile  *fp   (IN)  ե뼱̻ҥݥ
*            		CData *cur   (IN)  ǡƴ¤
*                       int   *bl    (IN)  оݥեɳǼ֥åꥹ
*                       int    next  (IN)  Υ֥åؤΥݥ
*                       
*   DESCRIPTION:	
*	ʥեɤ롣
*	եɤλ⿷Ƥ֤롣
*
*       쥳: |եɥ(4) | եɾ(n)         
*
*       оݥեɳǼ֥åꥹȤϿ줿֥åѤ롣
*       Ѥ֥åϡΥꥹȤ롣
*        
*   RETURN:		Ƭ֥åֹ : ｪλ
*                       -1               : ۾ｪλ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int   SetFieldData( CFile *fp, CData *cur, int *bl, int next ) 
{
  unsigned char buff[BSIZE];
  unsigned char  fid ;
  int   *ip ;
  int   ii, nct ;
  int   allsz ;
  int   ret, maxct, mallen ;
  int   *ipt, newpt[1024] ;
  CFileInfo  cf ;

  //printf("SetFieldData start cur->field=[%s] cur->datasize=%d\n", cur->field,cur->datasize) ;

  /* եɥ ׻ */
  allsz = cur->datasize + 4 ;
  /* եɴեǼ֥å */
  nct =  allsz / ( fp->rbsz - 4) ;
  if ( ( allsz % ( fp->rbsz - 4) ) != 0 )
    nct++ ;
  if ( nct <= 1024 ) {
    maxct = 1024 ;
    ipt = &newpt[0] ;
  }
  else {
    maxct = (( nct / 1024) + 1 ) * 1024 ;
    mallen = maxct * sizeof(int) ;
    if ( (ipt = (int *)malloc( mallen ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return -1 ;
    }
  }
  if ( bl != NULL ) {
    ip = bl ;
    for( ii = 0 ; ii < nct  ; ii++ ) {
      if ( *bl == NULL )
        break ;
      newpt[ii] = *bl ;
      bl++ ;
    }
    ip = bl ;
    while( *bl != NULL ) 
      bl++ ;
    SetFreeBlock(fp, ip, bl - ip) ;
  }
  else
    ii = 0 ;

  ret = GetBlock( fp, nct-ii, &newpt[ii], maxct-ii ) ;
  if ( ret != (nct-ii) ) {
    fprintf(stdout,"ERROR:ǡν񤭹ΰγݤ˼\n") ;
    return ( -1 ) ;
  }

  /* ǡ񤭹湽¤ν */
  cf.blist = ipt ;                /* ǡ򥻥åȤ֥åꥹ */
  cf.offset = 0 ;                   /* ǡåȰ */
  cf.buff = &buff[0] ;              /* Хåե */
  cf.next = NULL ;                  /* Ǽ֥å */
  cf.flag  = 1 ;                    /* ξ󤢤 */

  ret = *ipt ;

  /* եɾ */
  if ( PutSYSFILE(fp,&cf,(char *)&allsz,4) != 4 ) { /* Field Size */
    put_sys_end_func(maxct,ipt,1024,31) ;
    return -1 ;

  }
  cf.flag = 0 ;
  if ( PutSYSFILE(fp,&cf,(char *)(cur->data),cur->datasize) != cur->datasize ) {  /* Field Value */
    put_sys_end_func(maxct,ipt,1024,32) ;
    return -1 ;
  }
  if ( maxct > 1024 ) 
    free( (char *)ipt ) ;

  return ret ;
}




/**********************************************************
*   ***	Х塼ν񤭹
*   USAGE:		PutSYSFILE( CFile *fp, CFileInfo *cf, char *data, int size )
*   SYNOPSIS:		CFile      *fp   (IN)  ǡƴ¤
*                       CFileInfo  *cf   (IN)  ե륳ȥ
*                       char       *data (IN)  񤭹ߥǡƬɥ쥹
*                       int         size (IN)  񤭹ߥǡ
*                       
*   DESCRIPTION:	
*	ե륳ȥ򻲾Ȥ񤭹ߥǡ
*     ѥǡꥢ˥åȤ롣ǡꥢդˤʤ
*     ǳǡΥեؤν񤭹ߤԤʤ롣
*       ե륳ȥΥեå󥰥ե饰ξ硢
*     ǡΥåȸ˥ڡäƤ⡢եؤν񤭹
*     ߤԤʤȤȤ롣
*        
*   RETURN:		񤭹 : ｪλ
*                       -1               : ۾ｪλ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  PutSYSFILE( CFile *fp, CFileInfo *cf, char *data, int size )
{
  int i , len;
  char *cp ;
  int  *curp ;
  int   ret ;

  if ( size == 0 ) {
    if ( cf->flag == 0 ) {
      ret = Put_block_BSYSFile(fp, *(cf->blist), cf->buff, cf->next ) ;
      if ( ret < 0 )
        return -1 ;
      return 0 ;
    }
    return 0 ;
  }

  curp = cf->blist ;
  cp = data ;
  for( i = 0 ; i < size ; ) {
    if ( (size - i) > (fp->rbsz - 4 - cf->offset ) ) { /* ͤޤǳǼǤ */
      len = fp->rbsz - 4 - cf->offset ;
      memcpy( cf->buff + cf->offset , cp, len ) ;
      ret = Put_block_BSYSFile(fp, *curp, cf->buff, *(curp + 1) ) ;
      if ( ret < 0 ) {
        return -1 ;
      }
      cf->offset = 0 ;
      curp++ ;
      i += len ;
      cp += len ;
      continue ;
    }
    len = size -i ;
    memcpy( cf->buff + cf->offset , cp, len ) ;
    if ( (size - i) == (fp->rbsz - 4 - cf->offset ) ||
         cf->flag == 0 ) {
      ret = Put_block_BSYSFile(fp , *curp , cf->buff, cf->next ) ;
      if ( ret < 0 ) {
        return -1 ;
      }
      return size ;
    }
    cf->offset += len ;
    break ;
  }
  return size ;
}



/**********************************************************
*   ֥åγǼ
*   USAGE:	        Put_block_BSYSFile(CFile *fp, int cno, char *buff, int npo)
*   SYNOPSIS:           CFile  *fp   (IN)  ե뼱̻ҥݥ
*                       int     cno  (IN)  Ǽݥ
*       		char   *buff (IN) Ǽǡåȥꥢ
*                       int     npo  (IN) ͥȥݥ
*
*   DESCRIPTION:	
*	ꤵ줿֥å˥ǡ񤭹ࡣ
*       ֥å󤹤Υݥ󥿡ꥢ
*     ꤹ롣
*
*   RETURN:		Ǽǡ 
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int   Put_block_BSYSFile(CFile *fp,int cur, char *buff, int npo)
{
  int  ret ;

  fseek( fp->fd, cur, 0 ) ;     /* 쥳ɤγǼ */
  *(int *)&buff[fp->rbsz-4] = npo ;
  //ret = write( fp->fd, buff, fp->rbsz ) ;
  ret = fwrite( buff, 1, fp->rbsz, fp->fd ) ;
  if ( ret == fp->rbsz )
    return ret ;
  return -1 ;
}





/**********************************************************
*   ꤵ줿쥳γեɤؤ롣
*   USAGE:	        ReplRecBSYSFile(CFile  *fp, int curp, char *recd, CData *upd)
*   SYNOPSIS:           CFile  *fp   (IN) ե뼱̻ҥݥ
*                       int     curp (IN) 쥳ɤƬ֥åγǼ
*                       char   *recd (IN) 쥳ɤƬ֥å
*                       CData  *upd  (IN) ǡ
*
*   DESCRIPTION:	
*	쥳γեɥǡ򹹿롣
*
*   RETURN:		ｪλ: ǼƬ֥åֹ
*                       ۾ｪλ: ο
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int       ReplRecBSYSFile(CFile  *fp,int curp, char *recd, CData *upd) 
{
  int   len;
  int   cfpt, fieldp;
  int   fno, nextp, fct ;
  int   oldpt[1024] ;
  int   cdate ;
  short etcsz ;
  char *upt ;

  /* եɤؤ֥åpointˡեɤΥ֥ånextp */
  cfpt = get4byte( recd + 14 ) ;
  if ( upd->field != NULL ) {  /* °̾ꤷϿ */
    fct = SearchFieldPointer( fp, &cfpt, &nextp, &fieldp, upd->field) ;
    if ( fct == -1 ) { /* եɤ¸ߤʤ */
      /* եɥ֥å */
      fno = SetFieldData( fp, upd, NULL , NULL ) ;
      if ( fno == -1 ) {
        fprintf( stderr, "ERROR(ReplRecBSYSFile):Write error!\n" ) ;
        return -1 ;
      }
      upd->fdpt = fno ;
      //printf("PUT FIELD block=%x(D%d O%o)\n",fno,fno,fno) ;

      /* եɥȥ֥å */
      cfpt = get4byte( recd + 14 ) ;
      fno = SetFieldContData( fp, upd, NULL , cfpt ) ;
      if ( fno == -1 ) {
        fprintf( stderr, "ERROR(ReplRecBSYSFile):Write error!\n" ) ;
        return -1 ;
      }
      upd->fcpt = fno ;
      //printf("PUT FIELD_CONT block=%x(D%d O%o)\n",fno,fno,fno) ;
      put4byte( fno, recd+14 ) ;      /* Set Field Pointer */
    }
    else { /* ¸Υ֥åȤ촹 */
      CurBlockList( fp, fieldp, oldpt, 1024 ) ;
      /* եɾ */
      fno = SetFieldData( fp, upd, oldpt, NULL ) ;
      if ( fno == -1 ) {
        fprintf( stderr, "ERROR(ReplRecBSYSFile):Write error!\n" ) ;
        return -1 ;
      }
      upd->fdpt = fno ;
      //printf("PUT FIELD block=%x(D%d O%o)\n",fno,fno,fno) ;

      /* եɥȥ֥å */
      upd->fdpt = fno ;
      CurBlockList( fp, cfpt, oldpt, 1024 ) ;
      fno = SetFieldContData( fp, upd, oldpt , nextp ) ;
      if ( fno == -1 ) {
        fprintf( stderr, "ERROR(ReplRecBSYSFile):Write error!\n" ) ;
        return -1 ;
      }
      upd->fcpt = fno ;
      //printf("PUT FIELD_CONT block=%x(D%d O%o)\n",fno,fno,fno) ;
    }
  }
  else { /* ؤγǼ */
    upd->fcpt = get4byte( recd + 14 ) ;
  }
  /* 쥳ɴ󹹿 */
  cdate = PackNowDateI() ;
  if ( upd->subR == NULL ) { /* 쥳ɴι̵ */
    put4byte( cdate, recd+26 ) ;            /*  */
    //lseek(fp->fd, curp, 0 ) ;
    //write( fp->fd, recd, fp->rbsz ) ;
    fseek(fp->fd, curp, 0 ) ;
    fwrite( recd, 1, fp->rbsz, fp->fd ) ;
    return curp ;    
  }
  
  len = strlen( upd->subR )  ;
  etcsz = get4byte( recd + 18 ) ;
  upt = (char *)malloc( len + etcsz +20 ) ; /* ʬɲ */
  if ( upt == NULL ) {
    fprintf( stderr, "ERROR(ReplRecBSYSFile):Write error!\n" ) ;
    return ( -1 ) ;
  }
  UpdSubR( fp, recd, upd->subR, upt, len + etcsz +20) ;  /* 쥳 */
  /* 쥳ɥȥ֥å */
  CurBlockList( fp, curp, oldpt, 1024 ) ;
  cfpt = get4byte( recd + 0 ) ;
  upd->subR = upt ;
  fno = SetRecordContData( fp, upd, oldpt , cfpt ) ;
  if ( fno == -1 ) {
    fprintf( stderr, "ERROR(ReplRecBSYSFile):Write error!\n" ) ;
    return -1 ;
  }
  upd->rcpt = fno ;
  //printf("PUT RECORD_CONT block=%x(D%d O%o)\n",fno,fno,fno) ;
  free( upt ) ;
  return fno ;
}



int Get_BSYSFID( char *field )
{
  int ret ;

  /* եID */
  ret = hash(field, strlen(field),STR_TYPE,FIDHMAX, FIDHSIZE) ;
  return ret ;
}



/**********************************************************
*   եɤΥéꡢեɤ롣
*   USAGE:	        SearchFieldPointer( CFile *fp, int *cfpt, int *nextp, int *fieldp, char *field)
*   SYNOPSIS:           CFile  *fp       (IN)  ե뼱̻ҥݥ
*                       int    *cfpt     (IN/OUT) IN: Ƭ֥åֹ
*                                                 OUT:եɥ֥åֹ
*                       int    *nextp    (OUT) Υեɥ֥åֹ
*                       int    *fieldp   (OUT) եͤγǼ֥åֹ
*
*   DESCRIPTION:	
*	ʸγ°֤ͤ
*
*   RETURN:		쥳Ǥγեɤνиֹʣʾ
*                       եɤ¸ߤʤ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int SearchFieldPointer( CFile *fp, int *cfpt, int *nextp, int *fieldp, char *field) 
{
  int  ret, len ;
  unsigned char buff[BSIZE] ;
  unsigned char fid ;

  if ( *cfpt == NULL ) {
    *cfpt = *nextp = *fieldp = NULL ;
    return ( -1 ) ;
  } 

  fid = hash(field, strlen(field),STR_TYPE,FIDHMAX, FIDHSIZE) ;
  ret = 0 ;
  while( *cfpt != NULL ) {
    ret++ ;
    //lseek(fp->fd, *cfpt, 0 ) ;
    //read( fp->fd, buff, fp->rbsz );
    fseek(fp->fd, *cfpt, 0 ) ;
    fread( buff, 1, fp->rbsz, fp->fd );
    if ( fid == buff[8] &&
         strcmp( &buff[9], field ) == 0 ) {
      *nextp = get4byte( &buff[0] ) ;
      len = strlen( &buff[9] ) +1 ;      
      *fieldp = get4byte( &buff[ len + 9 ] ) ;
      return ret ; 
    }
    *cfpt = get4byte( &buff[0] ) ;
  }
  *cfpt = *nextp = *fieldp = NULL ;
  return ( -1 ) ;
} 



/**************** GET ********************************************/
/**********************************************************
*   ʸֹǥ°ΥХ塼롣
*   USAGE:	        GetData_BSYSFile(CFile  *fp, int outflag, CData *out )
*   SYNOPSIS:           CFile  *fp       (IN)  ե뼱̻ҥݥ
*                       int     outflag  (IN)  Ͼե饰
*                              0x01 ON : °͡ʥե͡
*                              0x02 ON : 쥳
*                              0x04 ON : ե
*            		CData  *out      (IN)  ϴĶ
*
*   DESCRIPTION:	
*	ʸγ°֤ͤ
*
*   RETURN:		ｪλ
*                       쥳ɤʤ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/    
int  GetData_BSYSFile( CFile *fp, int outflag, CData *out )
{
  unsigned char buff1[CBSIZE]; 
  unsigned char wk[2];
  char work[BSIZE] ;
  int   bp, ret ;
  int   bno , cno, pno, nextp, tct;
  unsigned int hid ;

  if ( ( outflag & RETC ) != 0 ) 
    *(out->subR) = '\0' ;
  if ( ( outflag & FETC ) != 0 ) 
    *(out->subF) = '\0' ;
  if ( ( outflag & FVALUE ) != 0 ) 
    *(out->data) = '\0' ;

  hid = hash((unsigned char *)&(out->textno),4,fp->flag,fp->hmax,fp->hsize) ;

  /* ǡγǼ֤η׻ */
  bno = ( hid / PTCOUNT ) * CBSIZE  ;
  //lseek( fp->fd, bno+CBSIZE , 0 ) ;
  //read( fp->fd, buff1, CBSIZE ) ;
  fseek( fp->fd, bno+CBSIZE , 0 ) ;
  fread( buff1, 1, CBSIZE, fp->fd ) ;
  pno = ( hid % PTCOUNT ) * 4;
  nextp = *(int *)&buff1[pno] ;
  if ( nextp == NULL) {                 /* Ͽ */
    return 0 ;
  }
  /*** TRACE COLLISION CHAIN & UPDATE DATA ***/
  bp = nextp ;
  while( nextp != NULL  ) {
    //printf("TRACE COLLISION CHAIN block=%x(D%d O%o)\n",nextp,nextp,nextp) ;
    //lseek( fp->fd, nextp , 0 ) ;
    //read( fp->fd, &work[0], fp->rbsz ) ;
    fseek( fp->fd, nextp , 0 ) ;
    fread( &work[0], 1, fp->rbsz, fp->fd ) ;
    if ( CompKey(fp, (char *)&(out->textno), 4, work) == 0 ) { /*  */
      ret = get_fieldBSYSFile(fp, nextp, work, outflag, out ) ;
      if ( ret == -1 ) 
        return ( 0 ) ;
      return ( 1 ) ;
    } 
    bp = nextp ;
    nextp = *(int *)&work[0] ;
  }
  return ( 0 ) ;
}




int get_fieldBSYSFile(CFile *fp, int curp, char *recd, int outflag, CData *out)
{
  int  npo ,rlen, klen , i, off, nextp ;
  int brsize, rix, rsize ;
  int  to, kb, npt, skip, cpt ;
  int  len, ret ;
  int  cfpt , fieldp ;
  int  fct ;

  if ( out->field == NULL || *(out->field) == '\0' ) {
    if ( ( outflag & RETC ) != 0 ) { 
      GetRECETC( fp, recd, out) ;
    }
    return 1 ;
  }
    
  /* եɤؤ֥å cfpt ˡեɤΥ֥ånextp */
  cfpt = get4byte( recd + 14 ) ;
  fct = SearchFieldPointer( fp, &cfpt, &nextp, &fieldp, out->field) ;
  if ( fct == -1 ) { /* եɤ¸ߤʤ */
    return ( -1 ) ;
  }
  /* 쥳 */
  if ( ( outflag & RETC ) != 0 ) { 
    GetRECETC( fp, recd, out) ;
  }

  /* եå */
  if ( fieldp == NULL ) {
    if ( ( outflag & FETC ) != 0 ) 
      *(out->subF) = '\0' ;
    if ( ( outflag & FVALUE ) != 0 ) 
      *(out->data) = '\0' ;
    return 1 ;
  }
  //lseek( fp->fd, cfpt, 0 ) ;
  //read( fp->fd, recd, fp->rbsz ) ;
  fseek( fp->fd, cfpt, 0 ) ;
  fread( recd, 1, fp->rbsz, fp->fd ) ;
  len = strlen( recd + 9 ) + 1 ;
  fieldp = get4byte( recd + len + 9 ) ;
  if ( ( outflag & FETC ) != 0 ) {
    GetFDETC( fp, recd, out ) ;
  }
  /* եɾ */
  if ( ( outflag & FVALUE ) != 0 ) {
    if ( fieldp == NULL ) {
      *(out->data) = '\0' ;
    }
    else {
      //lseek( fp->fd, fieldp, 0 ) ;
      //read( fp->fd, recd, fp->rbsz ) ;
      fseek( fp->fd, fieldp, 0 ) ;
      fread( recd, 1, fp->rbsz, fp->fd ) ;
      if ( ( outflag & FVALUE ) != 0 ) {
        GetFDVAL( fp, recd, out) ;
      }
    }
  }
  return 1 ;
} 


/*  쥳 */
int GetRECETC( CFile *fp, char *recd, CData *out)
{
  int   etcsz ;
  int   cdate, flag ;
  int   len ;
  char  val[10] ;

  etcsz = get4byte( recd + 18 ) ;
  
  //printf("out->subRbfsz=%d etcsz=%d\n",out->subRbfsz,etcsz);
  if ( out->subRbfsz >= (etcsz +20)) { /* ʬ褻ƥå */
    GetDataFromSYSFile( fp, out->subR, recd, 30, etcsz - 12 ) ;
    len = AddCDATEETCField( out->subR, out->subRbfsz, recd + 26 ) ;
    out->subRsize = strlen( out->subR ) ;
    return ( out->subRsize ) ;
  }
  fprintf( stderr, "ERROR(GetRECETC):Output buffer is too small!\n" ) ;
  fprintf( stderr, "  RECORD[%d]->FIELD[%s]\n",out->textno,out->field) ;
  fprintf( stderr, "  ETC(RECORD) LENGTH is %d (+20)\n",etcsz) ;
  *(out->subR) = '\0' ;
  return 0 ;
}



/* ˺դɲä */
int  AddCDATEETCField( char *etc, int bsz, char *pdate ) 
{
  int  ret ;
  char datewk[10] ;

  CDATEFromETC4byte( datewk, pdate ) ; /* ʥѥå͡ˤʸ */
  ret = AddPropertyETCRecord( etc, bsz, "CDATE", datewk )  ;
  return ret ;
}




/* եФ */
int GetFDETC( CFile *fp, char *recd, CData *out)
{
  int   etcsz ;
  int   cdate, flag ;
  int   len ;

  len = strlen( recd + 9 ) + 1 ;
  etcsz = get4byte( recd + len + 13 ) ;

  //printf("filedname=[%s]\n",  recd + 9 );
  //printf("etcsz=%d\n",etcsz) ;
  if ( out->subFbfsz >= etcsz ) {
    GetDataFromSYSFile( fp, out->subF, recd, len + 25, etcsz - 12 ) ;
    len = AddCDATEETCField( out->subF, out->subFbfsz, recd + len + 21 ) ;
    out->subFsize = strlen( out->subF ) ;
    return ( out->subFsize ) ;
  }
  fprintf( stderr, "ERROR(GetFDETC):Output buffer is too small!\n" ) ;
  fprintf( stderr, "  RECORD[%d]->FIELD[%s]\n",out->textno,out->field) ;
  fprintf( stderr, "  ETC(RECORD) LENGTH is %d\n",etcsz) ;
  *(out->subF) = '\0' ;
  return 0 ;
}



/* եɤ˳ǼƤͤФ */
int GetFDVAL( CFile *fp, char *recd, CData *out)
{
  int  sz ;

  sz = get4byte( recd  ) ;

  //printf("FieldSize=%d\n",sz) ;
  if ( out->databfsz >= sz ) {
    GetDataFromSYSFile( fp, out->data, recd, 4 , sz - 4 ) ;
    out->datasize = sz - 4 ;
    return ( sz - 4 ) ;
    //out->datasize = sz - 2 ;
    //return ( sz - 2 ) ;
  }
  fprintf( stderr, "ERROR(GetFDVAL):Output buffer is too small!\n" ) ;
  fprintf( stderr, "  RECORD[%d]->FIELD[%s]\n",out->textno,out->field) ;
  fprintf( stderr, "  VALUE  LENGTH is %d\n",sz) ;
  fprintf( stderr, "  BUFFER LENGTH is %d\n",out->databfsz) ;
  *(out->data) = '\0' ;
  out->datasize = 0 ;
  return 0 ;
}



/* ʣΥǡ֥å˳Ǽ줿Ф */
void GetDataFromSYSFile( CFile  *fp, char *ocp, char *icp , int off, int len )
{
  int sz ;
  int next ;

  /*****
  if ( len == 0 ) {
    *ocp = '\0' ;
    return ;
  }********/
  sz = fp->rbsz - 4 - off ;
  //printf("len=%d  sz=%d\n",len,sz) ;
  if ( len > sz )  {
    memcpy( ocp, icp + off, sz ) ;
    next = get4byte( icp + fp->rbsz - 4 ) ;
    //lseek( fp->fd, next, 0 ) ;
    //read( fp->fd, icp, fp->rbsz) ;
    fseek( fp->fd, next, 0 ) ;
    fread( icp, 1, fp->rbsz, fp->fd ) ;
    len -= sz ;
    ocp += sz ;
    off = 0 ;
    GetDataFromSYSFile( fp, ocp, icp, off, len ) ;
    return ;
  }
  memcpy( ocp, icp + off, len ) ;
  return ;
}






/*************************************************************
*   ܥƥե˳Ǽ줿ƤФơꤵ줿ؿ¹Ԥ롣
*   USAGE:	        ScanExec_SYS(CFile  *fp, int  (*func)() )
*   SYNOPSIS:           CFile  *fp    (IN)  ե뼱̻ҥݥ
*                       int    *func  (IN)  ¹Դؿ̾
*
*   DESCRIPTION:	
*	ܥƥե˳Ǽ줿Ƥ˥󤷤
*     Τ줾˻ꤵ줿桼ؿư롣
*       ؿϡǥ桼ؿΥݥ󥿡Ȥꡢե
*     ǼƤ륭бͤˤƥ桼ؿ༡ư롣
*       ư桼ؿϰʲΤ褦ʷȤ롣
*       int func-name(char *key, int key_size, int record_pt)  ;
*           arg1: CFile *fp      : ܥƥեݥ
*           arg2: char  *key     : ؤΥݥ
*           arg3: int   key_size : Υ
*           arg4: int   data_size: 쥳ɤγǼ
*        ư桼ؿ֤ͤ硢λǽǤ
*        Υ꥿̴ͤؿ֤
*
*      :ǥåץեƻȴؿScanExec_IXTˤ
*           äơ쥳ɤƬݥ󥿡Ϥ롣
*
*   RETURN:		ƤΥǡФƵư褿ϡ
*                           ưʥ쥳ˡ
*                       ʳϡưؿᤷ
*
*   SEE ALSO:	      
*   ERRORS:
***********************************************************/
int  ScanExec_SYS(CFile  *fp, int  (*func)())
{
  unsigned char cont[CBSIZE], buff[CBSIZE];       /* ɤ߹ߥХåե */
  char work[BSIZE] ;
  char key[4096], data[8192] ;
  char *kp, *dp ;
  int   i, j, hmax, bct, ret ;
  int   pt, rct = 0 ;

  /* ȥ֥åɤ߹ */
  //lseek( fp->fd, 0L, 0 ) ;
  //read( fp->fd, cont, CBSIZE ) ;
  fseek( fp->fd, 0L, 0 ) ;
  fread( cont, 1, CBSIZE, fp->fd ) ;
 
  /* ϥå奨ȥ꡼ */
  hmax = *(int *)&cont[24] ;
  bct = hmax / PTCOUNT ;
  if ( ( hmax % PTCOUNT) != 0) {
    bct++ ;
  }
  //printf("bct = %d\n",bct) ;
  /* ȥ꡼֥åȥ졼 */
  for( i = 1 ; i <= bct ; i++) {
    //lseek( fp->fd, ( i * CBSIZE ), 0 ) ;
    //read( fp->fd, buff, CBSIZE ) ;
    fseek( fp->fd, ( i * CBSIZE ), 0 ) ;
    fread( buff, 1, CBSIZE, fp->fd ) ;
    for( j = 0 ; j < CBSIZE ; j += 4) {
      pt = *(int *)&buff[j] ;
      while( pt != NULL ) {
        pt = EXEC_UserFuncSYS( fp, pt, func, &ret ) ;
        if ( ret < 0 ) {
          return ret ;
        }
        rct++ ;
      }
    }
  }  
  return rct ;

}





int EXEC_UserFuncSYS(CFile  *fp, int pt, int  (*func)(), int *subret )
{
  char work[BSIZE] ;
  char kbuff[4096], *kp ;
  int  nextp, off, curp  ;
  int  brsize , sz , ret;
  int  rlen, klen, dlen, len ;

  //printf("Start EXEC_UserFunc\n") ;

  brsize = fp->rbsz - 8 ;   /* 쥳ɳǼΰ襵 */
  //lseek( fp->fd, pt, 0 ) ;
  //read( fp->fd, work, fp->rbsz ) ;
  fseek( fp->fd, pt, 0 ) ;
  fread( work, 1, fp->rbsz, fp->fd ) ;
  nextp = *(int *)work ;    /* ｪλΥ꥿͡ʼΥ쥳ɤγǼ֡ */

  rlen = get4byte(work+4) ;   /* 쥳Ĺ */
  klen = get2byte(work+8) ;   /*  */
  dlen = rlen - klen - 6 ;    /* ǡ */
  if ( dlen == 0 )
    return nextp ;

  if ( klen >= 4096 ) {
    ret = klen / 4096 ;
    len = ( ret +1 ) * 4096 ;
    if ( (kp = (unsigned char *)malloc( len ) ) == NULL ) {
      fprintf( stderr,"ERROR:malloc error!\n" ) ;
      return -1 ;
    }
  }
  else {
    kp = kbuff ;
  }
  off = 6 ;
  curp = pt ;
  ret = Get_data_from_block(fp,kp,work,&curp,&off,klen) ;
  *(kp+klen) = '\0' ;

  ret = (*func)(fp, kp, klen, pt) ;
  if ( klen >= 4096 ) {
    free( kp ) ;
  }

  *subret = ret ;
  return nextp ;
}







